//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "updownclient.h"
#include "emule.h"
#include "UploadQueue.h"
#include "Clientlist.h"
#include "otherfunctions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//	members of CUpDownClient
//	which are used by down and uploading functions

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef OLD_SOCKETS_ENABLED
CUpDownClient::CUpDownClient(CClientReqSocket *pRequestSocket)
{
	m_pRequestSocket = pRequestSocket;
	m_pReqPartFile = NULL;
	Init();
}
#endif //OLD_SOCKETS_ENABLED
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CUpDownClient::CUpDownClient(uint16 uPort, uint32 dwClientID, uint32 dwServerIP, uint16 uServerPort, CPartFile *pReqPartFile)
{
#ifdef OLD_SOCKETS_ENABLED
	m_pRequestSocket = NULL;
#endif //OLD_SOCKETS_ENABLED

	Init();

	SetUserID(dwClientID);
	m_uUserPort = uPort;
	m_iSourcesSlot = m_dwUserID % SOURCESSLOTS;
	if (!HasLowID())
	{
		m_strFullUserIP.Format( _T("%u.%u.%u.%u"),
								static_cast<byte>(m_dwUserID),
								static_cast<byte>(m_dwUserID >> 8),
								static_cast<byte>(m_dwUserID >> 16),
								static_cast<byte>(m_dwUserID >> 24) );
	}
	m_dwServerIP = dwServerIP;
	m_uServerPort = uServerPort;
	m_pReqPartFile = pReqPartFile;
	ReGetClientSoft();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::Init()
{
	EMULE_TRY

	m_strFullUserIP = "";
	m_pCredits = 0;
	m_dwEnteredConnectedState = 0;
	m_uLastPartAsked = 0xFFFF;
	m_dwAvgDownDataRate = 0;
	m_dwAvgUpDataRate = 0;
	m_qwClientSumDLDataRateOverLastNMeasurements = 0;
	m_qwClientSumDLTickOverLastNMeasurements = 0;
	m_dwTransferredInLastPeriod = 0;
	m_uUDPPort = 0;
	m_byteFailedCount = 0;
	m_dwBanTime = 0;
	m_dwMaxSendAllowed = 0;
	m_dwTransferredUp = 0;
	m_dwAskedCount = 0;
	m_dwDownAskedCount = 0;
	m_lUpDataRate = -1;
	m_strUserName = "";
	m_dwUserIP = 0;
	SetUserID(0);
	m_uServerPort = 0;
	m_bIsOnLan = false;
	m_bBanned = false;
	m_iFileListRequested = m_iFileListRequestedSave = 0;
	m_dwLastUpRequest = 0;
	m_bEmuleProtocol = false;
	m_bUsedCompressionDown = false;
	m_bUsedCompressionUp = false;
	m_bCompleteSource = false;
	m_bCommentDirty = false;
	m_bReaskPending = false;
	m_bUDPPending = false;
	m_byteEmuleVersion = 0;
	m_strModVersion = "";
	m_strModExtended = "";
	m_uUserPort = 0;
	m_uPartCount = 0;
	m_uUpPartCount = 0;
	m_pbytePartStatuses = 0;
	m_pbyteUpPartStatuses = 0;
	m_dwLastAskedTime = 0;
	m_eDownloadState = DS_NONE;
	m_dwUploadTime = 0;
	m_dwTransferredDown = 0;
	m_dwDownDataRate = 0;
	m_byteFailedFileRequestsCount = 0;
	m_eUploadState = US_NONE;
	m_dwLastBlockReceived = 0;
	m_byteEmuleVersion = 0;
	m_byteDataCompVer = 0;
	m_dwDataPlusVers = 0;
	m_byteUDPVer = 0;
	m_byteSourceExchangeVer = 0;
	m_byteAcceptCommentVer = 0;
	m_byteExtendedRequestsVer = 0;
	m_byteDataTarodVer = 0;
	m_uRemoteQueueRank = 0;
	m_dwLastSourceRequest = 0;
	m_dwLastSourceAnswer = 0;
	m_uRemoteClientSpeed = 0;
	m_dwCompatibleClient = 0;
	m_bIsHybrid = false;
	m_dwAwayMessageResendCount = 0;
	m_bIsML = false;
	m_pFriend = NULL;
	m_eRating = PF_RATING_NONE;
	m_strComment = _T("");
	m_dwLastGotULDataTime = 0;
	m_eClientSoft = SO_UNKNOWN;
	m_bRemoteQueueFull = false;
	md4clr(m_userHash);
	SetWaitStartTime();
	m_dwRemoteScore = 0;
	m_uRemoteRatio = 0;
	m_uRemoteBaseModifier = 0;
	m_bRemoteInfoAvailable = false;
	m_bRemoteCommunity = false;
	m_bRemoteCommunityEnabled = false;
	m_bIsHashThief = false;

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket != NULL)
	{
		SOCKADDR_IN		sockAddr;

		memzero(&sockAddr, sizeof(sockAddr));

		int		iSockAddrLen = sizeof(sockAddr);

		m_pRequestSocket->GetPeerName(reinterpret_cast<SOCKADDR*>(&sockAddr),&iSockAddrLen);
		m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
		m_strFullUserIP = inet_ntoa(sockAddr.sin_addr);
	}
#endif //OLD_SOCKETS_ENABLED
	m_iSourcesSlot = 0;
	m_uUpCompleteSourcesCount = 0;
	m_dwUpCompleteSourcesTime = 0;
	m_dwLastRefreshedULDisplayTime = ::GetTickCount();
	m_bScoreBaseIsCached = false;
	m_bCommunityIsCached = false;
	m_bSupportsAskSharedDirs = false;
	md4clr(m_reqFileHash);

	m_dwLastL2HACExec = 0;
	m_dwL2HACTime = 0;
	m_bL2HACEnabled = false;

	m_eSecureIdentState = IS_UNAVAILABLE;
	m_dwLastSignatureIP = 0;
	m_byteSupportSecIdent = 0;
	m_eInfoPacketsReceived = IP_NONE;

	pUploadingPartFile = NULL;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CUpDownClient::~CUpDownClient()
{
	EMULE_TRY

//	AddDebugLogLine(false, _T("%s: Destroying client %s (addr 0x%08X)"),__FUNCTION__,GetUserName(), this);

	g_eMuleApp.m_pDownloadList->RemoveSource(this);
	g_eMuleApp.m_pClientList->RemoveClient(this);

	if (m_pFriend != NULL)
	{
		m_pFriend->m_pLinkedClient = NULL;
		g_eMuleApp.m_pFriendList->RefreshFriend(m_pFriend);
		m_pFriend = NULL;
	}
#ifdef OLD_SOCKETS_ENABLED
	g_eMuleApp.m_pListenSocket->DeleteSocket(m_pRequestSocket);
#endif //OLD_SOCKETS_ENABLED
	if (m_pbytePartStatuses != NULL)
	{
		delete[] m_pbytePartStatuses;
		m_pbytePartStatuses	= NULL;
	}
	if (m_pbyteUpPartStatuses != NULL)
	{
		delete[] m_pbyteUpPartStatuses;
		m_pbyteUpPartStatuses = NULL;
	}
	ClearUploadBlockRequests();

	while (!m_requestedFilesList.IsEmpty())
	{
		delete m_requestedFilesList.RemoveHead();
	}

	ClearDownloadBlocksList();
	ClearPendingBlocksList();

	if (m_eRating != PF_RATING_NONE || m_strComment.GetLength() > 0)
	{
		m_eRating = PF_RATING_NONE;
		m_strComment = _T("");
		m_pReqPartFile->UpdateFileRatingCommentAvail();
	}

	m_averageUDRList.clear();
	m_averageDLDataRateList.clear();
#ifdef OLD_SOCKETS_ENABLED

	DEBUG_ONLY (g_eMuleApp.m_pListenSocket->Debug_ClientDeleted(this));
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::ProcessHelloPacket(BYTE *pbytePacket, uint32 dwSize)
{
	EMULE_TRY

	CSafeMemFile		packetStream(pbytePacket, dwSize);

	byte		byteHashSize;

	packetStream.Read(&byteHashSize, 1);
	return ProcessHelloTypePacket(packetStream);

	EMULE_CATCH

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessHelloAnswer(char* pbytePacket, uint32 dwSize)
{
	EMULE_TRY
	CSafeMemFile packetStream((BYTE*)pbytePacket, dwSize);
	ProcessHelloTypePacket(packetStream);
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::ProcessHelloTypePacket(CSafeMemFile &packetStream)
{
	EMULE_TRY

	m_bIsHybrid = false;
	m_bIsML = false;

	packetStream.Read(&m_userHash, 16);

	uint32		dwUserID;

	packetStream.Read(&dwUserID, 4);

	if (m_dwUserID == 0)
		SetUserID(dwUserID);

	packetStream.Read(&m_uUserPort, 2);

	uint32	dwTagCount;

	packetStream.Read(&dwTagCount, 4);

	bool			bCrashed = false;
	bool			bWrongPort = false;
	CClientTag	   *pTempTag = NULL;

	for (uint32 i = 0; i < dwTagCount; i++)
	{
		pTempTag = new CClientTag(packetStream);
		switch (pTempTag->GetSpecialTag())
		{
			case CT_NAME:
			{
				m_strUserName.Empty();
				if (pTempTag->GetStringValue().IsEmpty())
				{
					bCrashed = true;

//					AddDebugLogLine(false, _T("%s: Invalid user name received! Userhash:%s, IP:%s, Userport:%d"), __FUNCTION__, HashToString(m_userHash), m_strFullUserIP, m_uUserPort);

					m_strUserName = _T("[Invalid user name]");
				}
				else
				{
					m_strUserName.SetString(pTempTag->GetStringValue(), pTempTag->GetStringValue().GetLength()); //eklmn: used CSimpleString class & functions
				}
				break;
			}
			case CT_VERSION:
			{
				m_dwClientVersion = pTempTag->GetIntValue();
				break;
			}
			case CT_PORT:
			{
			//	morevit: What does the hybrid use this port tag for if not the user port?
				if (pTempTag->GetIntValue() != m_uUserPort && GetClientSoft() != SO_EDONKEYHYBRID)
				{
					bWrongPort = true;
				}
				break;
			}
			case CT_MOD_VERSION:
			{
				m_strModVersion = pTempTag->GetStringValue();
				break;
			}
			case CT_EMULE_RESERVED1:
			case CT_EMULE_RESERVED2:
			case CT_EMULE_RESERVED3:
			case CT_EMULE_RESERVED4:
			case CT_EMULE_RESERVED5:
			case CT_EMULE_RESERVED6:
			case CT_EMULE_RESERVED7:
			case CT_EMULE_RESERVED8:
			case CT_EMULE_RESERVED9:
			case CT_EMULE_UDPPORTS:
			case CT_EMULE_MISCOPTIONS1:
			case CT_EMULE_VERSION:
			case CT_EMULE_RESERVED10:
			case CT_EMULE_RESERVED11:
			case CT_EMULE_RESERVED12:
			case CT_EMULE_RESERVED13:
			case CT_FRIENDSHARING:
			case CT_UNKNOWNx0:
			case CT_UNKNOWNx12:
			case CT_UNKNOWNx13:
			case CT_UNKNOWNx14:
			case CT_UNKNOWNx15:
			case CT_UNKNOWNx16:
			case CT_UNKNOWNx17:
			case CT_UNKNOWNx22:
			case CT_UNKNOWNx3c:
			case CT_UNKNOWNx3d:
			case CT_UNKNOWNx63:
			case CT_UNKNOWNx64:
			case CT_UNKNOWNx68:
			case CT_UNKNOWNx69:
			case CT_UNKNOWNx88:
			case CT_UNKNOWNx8c:
			case CT_UNKNOWNx8d:
			case CT_UNKNOWNx99:
			case CT_UNKNOWNxbb:
				break;
			default:
			{
#ifdef _DEBUG
				if (!pTempTag->GetStringValue().IsEmpty())
				{
					CString buffer = pTempTag->GetStringValue();
					TagToDebugLogLine(RGB_LOG_DIMMED + _T("Hello: Unknown eDonkey tag"), buffer, buffer.GetLength(), pTempTag->GetSpecialTag());
				}
				AddDebugLogLine(false, RGB_LOG_DIMMED + _T("%s: Hello: Unknown eDonkey tag: 0x%x, Intvalue: %d Stringvalue: %s, (client version:%d) %s"),
				                 __FUNCTION__, /*pTempTag->GetSpecialTag(),*/ static_cast<int>(pTempTag->GetSpecialTag()),
								 pTempTag->GetIntValue(), pTempTag->GetStringValue(), m_dwClientVersion, m_strUserName );
#endif
			}
		}
		delete pTempTag;
		pTempTag = NULL;
	}

//	Check the other client's server parameters and add it to our server list
	packetStream.Read(&m_dwServerIP, 4);
	packetStream.Read(&m_uServerPort, 2);
//	If the client didn't try to crash us with a blank name and the "add servers
//		to server list on connect" preference is on...
	if (!bCrashed && g_eMuleApp.m_pGlobPrefs->GetAddServersFromConn())
	{
	//	... and server IP is valid (fast check) and the server isn't already in our server list
		if ((m_dwServerIP != 0) && !g_eMuleApp.m_pServerList->GetServerByIP(m_dwServerIP, m_uServerPort))
		{
			in_addr		addhost;

			addhost.S_un.S_addr = m_dwServerIP;

			CServer		*pServer = new CServer(m_uServerPort, CString(inet_ntoa(addhost)));

			pServer->SetListName(pServer->GetAddress());
			if (!g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.AddServer(pServer, true))
				delete pServer;
		}
	}

//	Hybrid now has an extra uint32.. What is it for?
//	Also, many clients seem to send an extra 6? These are not eDonkeys or Hybrids..
	if (packetStream.GetLength() - packetStream.GetPosition() == 4)
	{
		uint32		dwTest;

		packetStream.Read(&dwTest, 4);
		if (dwTest == 'KDLM')
		{
			m_bIsML = true;
		}
		else
		{
			m_bIsHybrid = true;
			m_bSupportsAskSharedDirs = true;
		}
	}

#ifdef OLD_SOCKETS_ENABLED
//	If the client sent a mismatched user port tag and it's not a hybrid...
	if (bWrongPort && !m_bIsHybrid)
	{
		CString		ip_addr;
		UINT		port;

		m_pRequestSocket->GetPeerName(ip_addr, port);
		AddDebugLogLine(false, _T("%s: User %s (client version:%d) IP:%s sent an incorrect user port. Used the "
								  "real one instead: %d."), __FUNCTION__, m_strUserName, m_dwClientVersion,
						ip_addr, m_uUserPort);
	}
#endif //OLD_SOCKETS_ENABLED

	SOCKADDR_IN		sockAddr;

	memzero(&sockAddr, sizeof(sockAddr));

	uint32			dwSockAddrLen = sizeof(sockAddr);

#ifdef OLD_SOCKETS_ENABLED
	m_pRequestSocket->GetPeerName((SOCKADDR*) & sockAddr, (int*) & dwSockAddrLen);
#endif //OLD_SOCKETS_ENABLED

	m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
	m_strFullUserIP = inet_ntoa(sockAddr.sin_addr);

//	If Lancast is enabled check to see if this client is on the LAN
	m_bIsOnLan = ((g_eMuleApp.m_pGlobPrefs->GetLancastEnabled()) && ((g_eMuleApp.m_pGlobPrefs->GetLancastIP() & g_eMuleApp.m_pGlobPrefs->GetLancastSubnet()) == (m_dwUserIP & g_eMuleApp.m_pGlobPrefs->GetLancastSubnet())));
	if (m_bIsOnLan)
		m_dwUserID = m_dwUserIP;

//	Make sure if this user is a highid user there userid matches there ip address
	if (!HasLowID() && m_dwUserID != m_dwUserIP)
		SetUserID(m_dwUserIP);

//	get client credits
	uchar key[16];
	md4cpy(key, m_userHash);
	m_pCredits = g_eMuleApp.m_pClientCreditList->GetCredit(key);
	if ((m_pFriend = g_eMuleApp.m_pFriendList->LinkFriend(key, m_dwUserIP, m_uUserPort)) != NULL)
	{
		m_pFriend->m_pLinkedClient = this;
		m_pFriend->m_dwHasHash = 1;
		md4cpy(m_pFriend->m_abyUserhash, GetUserHash());
		m_pFriend->m_strName.Format(_T("%s"), m_strUserName);
		m_pFriend->m_dwLastUsedIP = m_dwUserIP;
		m_pFriend->m_nLastUsedPort = m_uUserPort;
		g_eMuleApp.m_pFriendList->RefreshFriend(m_pFriend);
		if (m_eChatState == MS_CONNECTING)
		{
			TCITEM newitem;
			newitem.mask = TCIF_TEXT;
			newitem.pszText = m_strUserName.GetBuffer(256);
			g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.SetItem(g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.GetTabByClient(this), &newitem);
		}
	}
	ReGetClientSoft();

//--- xrmb:hashthieves1 ---
//--- detectmystolenhash ---
	//get IP-Port hash
	const uint64 qwIPPortID = GetUID();
	uint32 dwNewUnfairActions = 0;
	uint32 dwUnfairClientActions = 0;
	OffenseCounterMap::iterator OffenseCounterIt = g_eMuleApp.m_pClientList->m_mapOffenseCounter.find(qwIPPortID);

	if (OffenseCounterIt != g_eMuleApp.m_pClientList->m_mapOffenseCounter.end())
	{
		dwUnfairClientActions = OffenseCounterIt->second;
	}

#ifdef OLD_SOCKETS_ENABLED
	//check if remote client has our HASH
	if (g_eMuleApp.m_pServerConnect->GetClientID() != m_dwUserID
		&& md4cmp(m_userHash, g_eMuleApp.m_pGlobPrefs->GetUserHash()) == 0
		&& g_eMuleApp.m_pGlobPrefs->GetMlDonkeyCM())
	{
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_HASHIMP));
		m_bIsHashThief = true;
		dwNewUnfairActions++;
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumUnfairActions);
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumUseMyHashActions);
/*
		AddDebugLogLine( false, RGB_LOG_DIMMED + _T("%s: Client '%s' uses my hash, ip %i.%i.%i.%i:%i, suspicious actions: %i (%i in total/%i clients)!"), __FUNCTION__, m_strUserName,
		                 (byte)m_dwUserIP, (byte)(m_dwUserIP >> 8), (byte)(m_dwUserIP >> 16), (byte)(m_dwUserIP >> 24), m_uUserPort,
		                 (dwUnfairClientActions + dwNewUnfairActions), g_dwTotalNumUnfairActions, g_dwTotalNumUnfairClients);
*/
	}
#endif //OLD_SOCKETS_ENABLED

	// detect a hash chager (detect id-changer)
	// eklmn: actually we are detecting a change of ID based on UserHash
	uint64 qwNewHashID = 0;
	uint32 *pdwHash = reinterpret_cast<uint32*>(GetUserHash());

// Calculate a HASH-ID
	qwNewHashID = (static_cast<uint64>(pdwHash[1] ^ pdwHash[3]) << static_cast<uint64>(32)) |
		static_cast<uint64>(pdwHash[0] ^ pdwHash[2]);

// Check a map
	HashBaseMap::iterator HashBaseIt = g_eMuleApp.m_pClientList->m_mapHashBase.find(qwIPPortID);

	if (HashBaseIt !=  g_eMuleApp.m_pClientList->m_mapHashBase.end())
	{
		if ( HashBaseIt->second != qwNewHashID)
	{
		m_bIsHashThief = true;
			dwNewUnfairActions++;
			//eklmn: update global statistic
			InterlockedIncrement(&g_eMuleApp.m_lTotalNumUnfairActions);
			InterlockedIncrement(&g_eMuleApp.m_lTotalNumHashChangeActions);

			/*
			AddDebugLogLine( false, RGB_LOG_DIMMED + _T("%s: Client '%s' changed hash, ip %i.%i.%i.%i:%i, suspicious actions: %i (%i in total/%i clients)!"), __FUNCTION__, m_strUserName,
			                 (byte)m_dwUserIP, (byte)(m_dwUserIP >> 8), (byte)(m_dwUserIP >> 16), (byte)(m_dwUserIP >> 24), m_uUserPort,
			                 (dwUnfairClientActions + dwNewUnfairActions), g_dwTotalNumUnfairActions, g_dwTotalNumUnfairClients);
			*/
		}
	}
	// update a IDhash
	 g_eMuleApp.m_pClientList->m_mapHashBase[qwIPPortID] = qwNewHashID;

	//check famous stolen hashs/names
	if (IsStolenName(m_strUserName))
	{
		m_bIsHashThief = true;
		dwNewUnfairActions++;
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumUnfairActions);
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumStolenNameActions);
/*
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine( false, RGB_LOG_DIMMED + _T("%s: Client '%s' is known for cheating, ip %i.%i.%i.%i:%i, suspicious actions: %i (%i in total)!"), __FUNCTION__, m_strUserName,
		        (byte)m_dwUserIP, (byte)(m_dwUserIP >> 8), (byte)(m_dwUserIP >> 16), (byte)(m_dwUserIP >> 24), m_uUserPort, (dwUnfairClientActions + dwNewUnfairActions), g_dwTotalNumUnfairActions );
*/
	}

	if ((dwUnfairClientActions + dwNewUnfairActions) >= 3
		&& g_eMuleApp.m_pGlobPrefs->GetMlDonkeyCM())
	{
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_HASHSTEAL));
	}

	//if we found new unfair action from remote client, then update a table
	if (dwNewUnfairActions != 0)
	{
		g_eMuleApp.m_pClientList->m_mapOffenseCounter[qwIPPortID] = dwUnfairClientActions + dwNewUnfairActions;
		//InterlockedIncrement(&g_eMuleApp.g_dwTotalNumUnfairClients);
		g_eMuleApp.m_lTotalNumUnfairClients = g_eMuleApp.m_pClientList->m_mapOffenseCounter.size();
	}
//--- :xrmb ---

	m_eInfoPacketsReceived |= IP_EDONKEYPROTPACK;
	if (m_eInfoPacketsReceived == IP_BOTH)
		InfoPacketsReceived();

	return true;

	EMULE_CATCH

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendHelloPacket()
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
//	if IP is filtered, don't greet him but disconnect...
	if (m_pRequestSocket != NULL)
	{
		SOCKADDR_IN	sockAddr;

		memzero(&sockAddr, sizeof(sockAddr));

		uint32		dwSockAddrLen = sizeof(sockAddr);

		m_pRequestSocket->GetPeerName(reinterpret_cast<SOCKADDR*>(&sockAddr), reinterpret_cast<int*>(&dwSockAddrLen));

		CMemFile	packetStream;
		byte		byteHashSize = 16;

		packetStream.Write(&byteHashSize, 1);
		SendHelloTypePacket(packetStream);

		Packet		*pPacket = new Packet(&packetStream);

		pPacket->m_eOpcode = OP_HELLO;
		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
		m_pRequestSocket->SendPacket(pPacket, true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendMuleInfoPacket(bool bAnswer)
{
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket)
	{
		CMemFile packetStream;
		//header of the info packet
		byte uClientVersion = CURRENT_VERSION_SHORT;
		packetStream.Write(&uClientVersion, 1);
		byte uProtVersion = EMULE_PROTOCOL;
		packetStream.Write(&uProtVersion, 1);
		uint32 dwTagCount = 10;
		packetStream.Write(&dwTagCount, 4);
		//body of the info packet
		CEmuleTag tag1(ET_COMPRESSION, 1);
		tag1.WriteToFile(packetStream);
		CEmuleTag tag2(ET_UDPVER, 3);	// netwolf: complete sources UDP
		tag2.WriteToFile(packetStream);
		CEmuleTag tag3(ET_UDPPORT, g_eMuleApp.m_pGlobPrefs->GetUDPPort());
		tag3.WriteToFile(packetStream);
		CEmuleTag tag4(ET_SOURCEEXCHANGE, 1);
		tag4.WriteToFile(packetStream);
		CEmuleTag tag5(ET_COMMENTS, 1);
		tag5.WriteToFile(packetStream);
		CEmuleTag tag6(ET_MOD_PLUS, CURRENT_PLUS_VERSION);	// To check for eMulePlus
		tag6.WriteToFile(packetStream);
		CEmuleTag tag7(ET_EXTENDEDREQUEST, 2);
		tag7.WriteToFile(packetStream);
		CEmuleTag tag8(ET_MOD_VERSION, _T(PLUS_VERSION_STR));
		tag8.WriteToFile(packetStream);	 //More harmless than the other 2! :D
		CEmuleTag tag9(ET_L2HAC, FILEREASKTIME);	//<<-- enkeyDEV(th1) -L2HAC-
		tag9.WriteToFile(packetStream);			//<<-- enkeyDEV(th1) -L2HAC-
		CEmuleTag tag10(ET_FEATURES, (uint32)(g_eMuleApp.m_pClientCreditList->CryptoAvailable() ? 3 : 0));
		tag10.WriteToFile(packetStream);

		Packet		*pPacket = new Packet(&packetStream, OP_EMULEPROT);
		if (!bAnswer)
			pPacket->m_eOpcode = OP_EMULEINFO;
		else
			pPacket->m_eOpcode = OP_EMULEINFOANSWER;

		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
		m_pRequestSocket->SendPacket(pPacket, true, true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}

void CUpDownClient::ProcessMuleInfoPacket(BYTE* pbytePacket, uint32 dwSize)
{
	EMULE_TRY
	CSafeMemFile packetStream(pbytePacket, dwSize);
	m_dwCompatibleClient = 0;
	packetStream.Read(&m_byteEmuleVersion, 1);
	if (m_byteEmuleVersion == 0x2B)
		m_byteEmuleVersion = 0x22;
	byte protversion;
	packetStream.Read(&protversion, 1);

//implicitly supported options by older clients
	if (protversion == EMULE_PROTOCOL)
	{
	//in the future do not use version to guess about new features

		if (m_byteEmuleVersion < 0x25 && m_byteEmuleVersion > 0x22)
			m_byteUDPVer = 1;

		if (m_byteEmuleVersion < 0x25 && m_byteEmuleVersion > 0x21)
			m_byteSourceExchangeVer = 1;

		if (m_byteEmuleVersion == 0x24)
			m_byteAcceptCommentVer = 1;

	//	Shared directories are requested from eMule 0.28+ because eMule 0.27 has a bug in
	//	the OP_ASKSHAREDFILESDIR handler, which does not return the shared files for a
	//	directory which has a trailing backslash.
	//	MLdonkey currently does not support shared directories
	//	eMule+ supports shared directories with 1h (0x0108)
		if (m_byteEmuleVersion >= 0x28 && !m_bIsML && (GetPlusVersion() == 0 || GetPlusVersion() >= 0x0108))
			m_bSupportsAskSharedDirs = true;

	}
	else
	{
		return;
	}
	m_bEmuleProtocol = true;

	m_dwL2HACTime = 0;	//<<-- enkeyDEV(th1) -L2HAC-

	uint32 dwTagCount = 0;
	packetStream.Read(&dwTagCount, 4);
	CEmuleTag* pTempTag = NULL;
	for (uint32 i = 0;i < dwTagCount; i++)
	{
		try
		{
		pTempTag = new CEmuleTag(packetStream);
		if (pTempTag)
		{
			switch (pTempTag->GetSpecialTag())
			{
				case ET_COMPRESSION:
				{
					m_byteDataCompVer = pTempTag->GetIntValue();
					break;
				}
				case ET_UDPPORT:
				{
					m_uUDPPort = pTempTag->GetIntValue();
					break;
				}
				case ET_UDPVER:
				{
					m_byteUDPVer = pTempTag->GetIntValue();
					break;
				}
				case ET_SOURCEEXCHANGE:
				{
					m_byteSourceExchangeVer = pTempTag->GetIntValue();
					break;
				}
				case ET_COMMENTS:
				{
					m_byteAcceptCommentVer = pTempTag->GetIntValue();
					break;
				}
				case ET_EXTENDEDREQUEST:
				{
					m_byteExtendedRequestsVer = pTempTag->GetIntValue();
					break ;
				}
				case ET_COMPATIBLECLIENT:
				{
					m_dwCompatibleClient = pTempTag->GetIntValue();
					break;
				}
				case ET_MOD_FEATURESET:
				{
					break;
				}
				case ET_MOD_VERSION:
				{
					m_strModVersion = pTempTag->GetStringValue();
					break;
				}
				case ET_MOD_PROTOCOL:
				{
					m_strModExtended = pTempTag->GetStringValue();
					break;
				}
				case ET_MOD_PLUS:
				{
					m_dwDataPlusVers = pTempTag->GetIntValue();
					break ;
				}
				case ET_MOD_TAROD:
				{
					m_byteDataTarodVer = pTempTag->GetIntValue();
					break;
				}
				case ET_MOD_BOWLFISH:
				case ET_MOD_TAROD_VERSION:
				case ET_MOD_FUSION:
				case ET_MOD_FUSION_VERSION:
				case ET_MOD_Morph:
				case ET_MOD_Morph_VERSION:
				case ET_MOD_MorTillo:
				case ET_MOD_MorTillo_VERSION:
				case ET_MOD_LSD:
				case ET_MOD_LSD_VERSION:
				case ET_MOD_LOVELACE_VERSION:
				case ET_MOD_OXY:
				case ET_MOD_UNKNOWNx12:
				case ET_MOD_UNKNOWNx13:
				case ET_MOD_UNKNOWNx14:
				case ET_MOD_UNKNOWNx17:
				case ET_MOD_UNKNOWNx2F:
				case ET_MOD_UNKNOWNx30:
				case ET_MOD_UNKNOWNx36:
				case ET_MOD_UNKNOWNx3C:
				case ET_MOD_UNKNOWNx41:
				case ET_MOD_UNKNOWNx42:
				case ET_MOD_UNKNOWNx43:
				case ET_MOD_UNKNOWNx50:
				case ET_MOD_UNKNOWNx59:
				case ET_MOD_UNKNOWNx5B:
				case ET_MOD_UNKNOWNx5C:
				case ET_MOD_UNKNOWNx60:
				case ET_MOD_UNKNOWNx64:
				case ET_MOD_UNKNOWNx76:
				case ET_MOD_UNKNOWNx84:
				case ET_MOD_UNKNOWNx85:
				case ET_MOD_UNKNOWNx86:
				case ET_MOD_UNKNOWNx91:
				case ET_MOD_UNKNOWNx92:
				case ET_MOD_UNKNOWNx93:
				case ET_MOD_UNKNOWNxA0:
				case ET_MOD_UNKNOWNxA1:
				case ET_MOD_UNKNOWNxA6:
				case ET_MOD_UNKNOWNxB1:
				case ET_MOD_UNKNOWNxB4:
				case ET_MOD_UNKNOWNxC8:
				case ET_MOD_UNKNOWNxC9:
				case ET_MOD_UNKNOWNxDA:
				{
					break;
				}
				case ET_L2HAC:     	// START enkeyDEV(th1) -L2HAC-
				{
					m_dwL2HACTime = pTempTag->GetIntValue();
					break;		// END enkeyDEV(th1) -L2HAC-
				}
				case ET_INCOMPLETEPARTS:      // enkeyDEV(th1) -ICS-
				{
					break;
				}
				case ET_FEATURES:     	// secure credits (official 0.29b)
				{
				//	Bits 31- 8: 0 - reserved
				//	Bit   7- 0: secure identification
					m_byteSupportSecIdent = pTempTag->GetIntValue() & 3;
					break;
				}
				default:
				{
					if (!pTempTag->GetStringValue().IsEmpty())
					{
//						CString buffer = pTempTag->GetStringValue();
//						TagToDebugLogLine(RGB_LOG_DIMMED + _T("Process: Unknown eMule tag"), buffer, buffer.GetLength(), pTempTag->GetSpecialTag());
					}
//					AddDebugLogLine(false, RGB_LOG_DIMMED + _T("%s: Process: Unknown eMule tag: 0x%x, Intvalue: %d Stringvalue: %s User: %s(%s)"),
//						__FUNCTION__, pTempTag->GetSpecialTag(), pTempTag->GetIntValue(), pTempTag->GetStringValue(), m_strUserName, GetClientNameAndVersionString(this) );
				}
			}
			delete pTempTag;
			pTempTag = NULL;
		}
	}
		catch (CException* error)
		{
			error->Delete();
			safe_delete(pTempTag);
		}
	}

//	START enkeyDEV(th1) -L2HAC- Enable every emule anyway and disable bad clients
	if (!m_dwL2HACTime)
		m_dwL2HACTime = L2HAC_DEFAULT_EMULE;
	if (m_dwL2HACTime < L2HAC_MIN_TIME || m_dwL2HACTime > L2HAC_MAX_TIME)
		m_dwL2HACTime = 0;
//	END enkeyDEV(th1) -L2HAC-

	if (m_byteDataCompVer == 0)
	{
		m_byteSourceExchangeVer = 0;
		m_byteExtendedRequestsVer = 0;
		m_byteAcceptCommentVer = 0;
		m_uUDPPort = 0;
		m_dwL2HACTime = 0;	//<<-- enkeyDEV(th1) -L2HAC-
	}
	
	ReGetClientSoft();	// 9/5/2003 [Moosetea] Official client, this messes the stats up, creates lots of invalid edonkey clients
						// 29.03.2004 [eklmn] after rewriting of ReGetClientSoft() it's back, cause otherwise we are losing 
						// 			information from compatibility tag

	m_eInfoPacketsReceived |= IP_EMULEPROTPACK;
	if (m_eInfoPacketsReceived == IP_BOTH)
		InfoPacketsReceived();

//	emuleplus supports 'complete sources' with versions 1f and 1g (force ET_EXTENDEDREQUEST v2 for backward compatibility)
	if ((GetPlusVersion() >= 0x0106) && (GetPlusVersion() < 0x0108) && (GetExtendedRequestsVersion() == 1))
		m_byteExtendedRequestsVer = 2;

	// check a leecher clients
	if (IsLeecherType(GetModVersion()) 
		|| (GetModVersion() == _T(PLUS_VERSION_STR) && GetMuleVersion() != CURRENT_VERSION_SHORT) )
	{
		const uint64 qwIPPortID = GetUID();
		uint32 dwUnfairClientActions = 0;
		OffenseCounterMap::iterator OffenseCounterIt = g_eMuleApp.m_pClientList->m_mapOffenseCounter.find(qwIPPortID);

		if (OffenseCounterIt != g_eMuleApp.m_pClientList->m_mapOffenseCounter.end())
		{
			dwUnfairClientActions = OffenseCounterIt->second;
		}
		dwUnfairClientActions++;
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumUnfairActions);
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumLeecherTypeActions);
		g_eMuleApp.m_pClientList->m_mapOffenseCounter[qwIPPortID] = dwUnfairClientActions;
		g_eMuleApp.m_lTotalNumUnfairClients = g_eMuleApp.m_pClientList->m_mapOffenseCounter.size();
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_LEECHERADV));
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendHelloAnswer()
{
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket)
	{
		CMemFile packetStream;
		SendHelloTypePacket(packetStream);
		Packet		*pPacket = new Packet(&packetStream);
		pPacket->m_eOpcode = OP_HELLOANSWER;
		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
		m_pRequestSocket->SendPacket(pPacket, true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendHelloTypePacket(CMemFile &packetStream)
{
	EMULE_TRY

	BYTE		hash[16];

	md4cpy(hash, g_eMuleApp.m_pGlobPrefs->GetUserHash());

//	Checking for MLDonkey does not help against their unfair share policy anymore
//	since they have removed this feature so we emulate now an eDonkey to MLDonkey.

//	If we can see that the client is MLDonkey and MLDonkey countermeasures are turned on...
	if (GetClientSoft() == SO_MLDONKEY && g_eMuleApp.m_pGlobPrefs->GetMlDonkeyCM())
	{
	//
	//	Spoof the identifying bytes in the hash with random values.
		do
		{
			uint32 dwRnd = rand();

			hash[5] = static_cast<BYTE>(dwRnd);
			hash[14] = static_cast<BYTE>(dwRnd >> 8);
		} while ((hash[5] == 14) || (hash[14] == 111));
	}
	packetStream.Write(hash, 16);					// <userhash 16>

#ifdef OLD_SOCKETS_ENABLED
	uint32		dwClientID = g_eMuleApp.m_pServerConnect->GetClientID();

	packetStream.Write(&dwClientID, 4);				// <ourclientid 4>
#endif //OLD_SOCKETS_ENABLED

	uint16		nPort = g_eMuleApp.m_pGlobPrefs->GetListenPort();  //Maverick

	packetStream.Write(&nPort, 2);					// <ourport 2>

	uint32		dwTagCount = 2;

	packetStream.Write(&dwTagCount, 4);				// <tagcount 4>

/*
	CClientTag		*pTag = new CClientTag(CT_NAME, g_eMuleApp.m_pGlobPrefs->GetUserNick().GetBuffer());

	pTag->WriteToFile(packetStream);				//    { NAME : int }
	delete pTag;
*/
	if (g_eMuleApp.m_pGlobPrefs->m_pNameTag)
	{
		g_eMuleApp.m_pGlobPrefs->m_pNameTag->WriteToFile(packetStream);			//{ NAME : int }
	}
/*
	pTag = new CClientTag(CT_VERSION, EDONKEYVERSION);
	pTag->WriteToFile(packetStream);				//    { VERSION : int }
	delete pTag;
*/
	if (g_eMuleApp.m_pGlobPrefs->m_pVersionTag)
	{
		g_eMuleApp.m_pGlobPrefs->m_pVersionTag->WriteToFile(packetStream);		//    { VERSION : int }
	}

	uint32		dwIP = 0;

	nPort = 0;
#ifdef OLD_SOCKETS_ENABLED

	if (g_eMuleApp.m_pServerConnect->IsConnected())
	{
		dwIP = g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetIP();
		nPort = g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetPort();
	}
#endif //OLD_SOCKETS_ENABLED
	packetStream.Write(&dwIP, 4);					// <serverip 4>
	packetStream.Write(&nPort, 2);					// <serverport 2>
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessMuleCommentPacket(char* pachPacket, uint32 dwSize)
{
	EMULE_TRY

	if ((m_pReqPartFile != NULL) && (dwSize > 2))
	{
		CSafeMemFile packetStream((BYTE*)pachPacket, dwSize);
		int length;
		packetStream.Read(&m_eRating, sizeof(m_eRating));
		packetStream.Read(&length, sizeof(length));
		if (length > 50)
			length = 50;
		if (length > 0)
		{
			packetStream.Read(m_strComment.GetBuffer(length + 1), length);
			m_strComment.ReleaseBuffer(length);
		//(SyruS) netwolf commentfilter
			CString strList(g_eMuleApp.m_pGlobPrefs->GetCommentFilter().MakeLower());
			if (!strList.IsEmpty())
			{
				CString lowComment(m_strComment);	//make a copy of casesensitive comment
				lowComment.MakeLower();				//make copy only lowercase to search in
				int curPos = 0;
				CString resToken(strList.Tokenize(_T("|"), curPos));
				while (!resToken.IsEmpty())
				{
					if (lowComment.Find(resToken) > -1)
					{
						AddDebugLogLine(false, RGB_LOG_DIMMED + _T("%s: Description for file '%s' filtered: %s"), __FUNCTION__, m_strClientFilename, m_strComment);
						m_strComment = _T("");
						m_eRating = PF_RATING_NONE;
						break;
					}
					resToken = strList.Tokenize(_T("|"), curPos);
				}
			}
			if (!m_strComment.IsEmpty())
			{
				m_pReqPartFile->SetHasComment(true);
				AddDebugLogLine(false, _T("%s: Description for file '%s' received: %s"), __FUNCTION__, m_strClientFilename, m_strComment);
			}
		}
		if (m_eRating != PF_RATING_NONE)
		{
			m_pReqPartFile->SetHasRating(true);
			AddDebugLogLine(false, _T("%s: Rating for file '%s' received: %s"), __FUNCTION__, m_strClientFilename, ::GetRatingString(m_eRating));
		}
		if ((!m_strComment.IsEmpty()) || (m_eRating != PF_RATING_NONE))	// #zegzav:pastcomment
			m_pReqPartFile->RemovePastComment(this, false);
	}
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::Disconnected(bool bRetryConnection /*=true*/)
{
	bool	bDeleted = false;

	EMULE_TRY

	if (g_eMuleApp.m_pClientList->IsValidClient(this))
	{
	//	If the client is uploading, remove it from the upload queue.
		if (GetUploadState() == US_UPLOADING)
			g_eMuleApp.m_pUploadQueue->RemoveFromUploadQueue(this, ETS_DISCONNECT);
	//	If the client is downloading, leave it on the queue but stop it from downloading
		if (GetDownloadState() == DS_DOWNLOADING)
			SetDownloadState(DS_ONQUEUE);
	//	If the client is requesting a hashset...
		if ((GetDownloadState() == DS_REQHASHSET) && m_pReqPartFile != NULL)
			m_pReqPartFile->m_bHashSetNeeded = true;
		ASSERT(g_eMuleApp.m_pClientList->IsValidClient(this));
	//
	//	Check if this client is needed in any way, if not delete it
	//
		bool bDelete = true;

		switch (m_eUploadState)
		{
			case US_ONUPLOADQUEUE:
			{
				bDelete = false;
			}
		};
		switch (m_eDownloadState)
		{
			case DS_ONQUEUE:
			case DS_TOOMANYCONNS:
			case DS_NONEEDEDPARTS:
			case DS_LOWTOLOWIP:
			{
				bDelete = false;
			}
		};

		switch (m_eUploadState)
		{
			case US_CONNECTING:
			case US_WAITCALLBACK:
			case US_ERROR:
			{
				bDelete = true;
			}
		};
		switch (m_eDownloadState)
		{
			case DS_CONNECTING:
			{
				m_byteFailedCount++;
				if (bRetryConnection && m_byteFailedCount <= 2)
				{
					TryToConnect();
					return bDeleted;
				}
			}
			case DS_WAITCALLBACK:
			case DS_ERROR:
			{
				bDelete = true;
			}
		};

		if (GetChatState() != MS_NONE)
		{
		//	SyruS (0.29c)
			bDelete = false;
			g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.ConnectingResult(this, false);
		}
#ifdef OLD_SOCKETS_ENABLED
		g_eMuleApp.m_pListenSocket->DeleteSocket(m_pRequestSocket);
#endif //OLD_SOCKETS_ENABLED

		if (m_iFileListRequested)
		{
			AddDebugLogLine(false, _T("%s: ") + ::GetResString(IDS_SHAREDFILES_FAILED), __FUNCTION__, GetUserName());
			m_iFileListRequested = m_iFileListRequestedSave = 0;
		}
		if (m_pFriend)
		{
			g_eMuleApp.m_pFriendList->RefreshFriend(m_pFriend);
		}

		if (bDelete)
		{
			delete this;
			bDeleted = true;
		}
		else
		{
			g_eMuleApp.m_pClientList->UpdateClient(this);
			m_dwEnteredConnectedState = 0;
		}
	}
	else
	{
		AddDebugLogLine(false, _T("%s: Invalid client."), __FUNCTION__);
	}

	EMULE_CATCH

	return bDeleted;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::TryToConnect(bool bIgnoreMaxCon)
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
//	If we have too many sockets open and we're not already connected...
	if ((g_eMuleApp.m_pListenSocket->TooManySockets() && !bIgnoreMaxCon) && !(m_pRequestSocket != NULL && m_pRequestSocket->IsConnected()))
	{
		Disconnected();
		return false;
	}
//
//	BavarianSnail - filter LowIDs separately from HighIDs
//

//	If the client has a client IP...
	if (m_dwUserIP > 0)
	{
	//	case 1: it's a Client with known IP, always test the client IP instead of the client ID.
		if (g_eMuleApp.m_pIPFilter->IsFiltered(m_dwUserIP))
		{
			if (!g_eMuleApp.m_pGlobPrefs->GetCMNotLog())
			{
				AddDebugLogLine(false, RGB_LOG_DIMMED + _T("%s: Filtered client (don't connect): %s %s"), __FUNCTION__, GetFullIP(), g_eMuleApp.m_pIPFilter->GetLastHit());
			}
		//	Disconnect and don't retry.
			Disconnected(false);
			InterlockedIncrement(&g_eMuleApp.m_lOutgoingFiltered);
			InterlockedIncrement(&g_eMuleApp.m_lTotalFiltered);	//g_eMuleApp.stat_filteredclients++;
			return false;
		}
	}
//	If the client has no IP...
	else
	{
	//	If the client has a high ID...
		if (m_dwUserID > 0xFFFFFF)
		{
		//	case 2: it's HighID with client IP empty, test client ID instead
			if (g_eMuleApp.m_pIPFilter->IsFiltered(m_dwUserID))
			{
				if (!g_eMuleApp.m_pGlobPrefs->GetCMNotLog())
					AddDebugLogLine(false, RGB_LOG_DIMMED + _T("%s: Filtered client (don't connect): %s %s"), __FUNCTION__, GetFullIP(), g_eMuleApp.m_pIPFilter->GetLastHit());
				Disconnected(false);
				InterlockedIncrement(&g_eMuleApp.m_lOutgoingFiltered);
				InterlockedIncrement(&g_eMuleApp.m_lTotalFiltered);	//g_eMuleApp.stat_filteredclients++;
				return false;
			}
		}
		else
		{
		//	case 3: it's a LowID without known IP, cannot test yet
		//	AddDebugLogLine(false, RGB_LOG_DIMMED + _T("%s: Cannot filter LowID (no IP yet): m_uUserID %u m_dwUserIP %u GetFullIP %s"), __FUNCTION__, m_dwUserID,m_dwUserIP,GetFullIP());
		}
	}

//	If we both have Low IDs...
	if ((g_eMuleApp.m_pServerConnect->GetClientID() < 0x1000000) && HasLowID())
	{
		if (GetDownloadState() == DS_CONNECTING)
		{
			SetDownloadState(DS_LOWTOLOWIP);
		}
		else if (GetDownloadState() == DS_REQHASHSET)
		{
			SetDownloadState(DS_ONQUEUE);
			m_pReqPartFile->m_bHashSetNeeded = true;
		}
		if (GetUploadState() == US_CONNECTING)
		{
			Disconnected(false);
		}

		return false;
	}
#endif OLD_SOCKETS_ENABLED

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL)
	{
		m_pRequestSocket = new CClientReqSocket(g_eMuleApp.m_pGlobPrefs, this);
		if (!m_pRequestSocket->Create())
		{
			m_pRequestSocket->Safe_Delete();
			return true;
		}
	}
	else if (!m_pRequestSocket->IsConnected())
	{
		m_pRequestSocket->Safe_Delete();
		m_pRequestSocket = new CClientReqSocket(g_eMuleApp.m_pGlobPrefs, this);
		if (!m_pRequestSocket->Create())
		{
			m_pRequestSocket->Safe_Delete();
			return true;
		}
	}
//	If we already have a connected request socket, we're done
	else
	{
		ConnectionEstablished();
		return true;
	}
#endif OLD_SOCKETS_ENABLED
//	MOD Note: Do not change this part - Merkur
	if (HasLowID())
	{
		if (GetDownloadState() == DS_CONNECTING)
		{
			SetDownloadState(DS_WAITCALLBACK);
		}
		if (GetUploadState() == US_CONNECTING)
		{
			Disconnected();
			return false;
		}

#ifdef OLD_SOCKETS_ENABLED
	//	If the client is on the same server that we are...
		if (g_eMuleApp.m_pServerConnect->IsLocalServer(m_dwServerIP, m_uServerPort))
		{
			Packet		*pPacket = new Packet(OP_CALLBACKREQUEST, 4);

			memcpy2(pPacket->m_pcBuffer, &m_dwUserID, 4);
			g_eMuleApp.m_pUploadQueue->AddUpDataOverheadServer(pPacket->m_dwSize);
			g_eMuleApp.m_pServerConnect->SendPacket(pPacket);
		}
	//	If the LowID client is on another server...
		else
		{
		//	If we're not uploading to him or currently downloading...
			if (GetUploadState() == US_NONE && (!GetRemoteQueueRank() || m_bReaskPending))
			{
				g_eMuleApp.m_pDownloadQueue->RemoveSource(this);
				Disconnected();
				return false;
			}
			else
			{
				if (GetDownloadState() == DS_WAITCALLBACK)
				{
					m_bReaskPending = true;
					SetDownloadState(DS_ONQUEUE);
				}
			}
		}
#endif //OLD_SOCKETS_ENABLED

	}
//	MOD Note - end
	else
	{
#ifdef OLD_SOCKETS_ENABLED
		m_pRequestSocket->Connect(GetFullIP(), GetUserPort());
#endif //OLD_SOCKETS_ENABLED

		SendHelloPacket();
	}
	return true;

	EMULE_CATCH
	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ConnectionEstablished()
{
	EMULE_TRY

	m_byteFailedCount = 0;
//
//	Ok we have a connection, let's see if we want anything from this client.

//	If we're connecting for chat...
	if (GetChatState() == MS_CONNECTING)
	{
		g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.ConnectingResult(this, true);
	}
//	If we're connecting for download...
	switch (GetDownloadState())
	{
		case DS_CONNECTING:
		case DS_WAITCALLBACK:
			m_bReaskPending = false;
			SetDownloadState(DS_CONNECTED);
			SendFileRequest();
	}
//	If we're connecting for a "reask"...
	if (m_bReaskPending)
	{
		m_bReaskPending = false;
		if (GetDownloadState() != DS_NONE && GetDownloadState() != DS_DOWNLOADING)
		{
			SetDownloadState(DS_CONNECTED);
			SendFileRequest();
		}
	}
//	If we're connecting for upload...
	switch (GetUploadState())
	{
		case US_CONNECTING:
		case US_WAITCALLBACK:
		{
			if (g_eMuleApp.m_pUploadQueue->IsDownloading(this))
			{
				SetUploadState(US_UPLOADING);

				Packet		*pPacket = new Packet(OP_ACCEPTUPLOADREQ);

				g_eMuleApp.m_pUploadQueue->AddUpDataOverheadFileRequest(pPacket->m_dwSize);

#ifdef OLD_SOCKETS_ENABLED
				m_pRequestSocket->SendPacket(pPacket, true);
#endif OLD_SOCKETS_ENABLED

				SetLastGotULData();	//eklmn: set Upload Timer
			}
		}
	}
//	If we're connecting to retrieve the client's file list...
	if (m_iFileListRequested == 1)
	{
		Packet		*pPacket = new Packet(m_bSupportsAskSharedDirs ? OP_ASKSHAREDDIRS : OP_ASKSHAREDFILES);

		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);

#ifdef OLD_SOCKETS_ENABLED
		m_pRequestSocket->SendPacket(pPacket, true, true);
#endif OLD_SOCKETS_ENABLED
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CUpDownClient::GetHashType()
{
	if (m_userHash[5] == 13 && m_userHash[14] == 110)
		return SO_OLDEMULE;
	else if (m_userHash[5] == 14 && m_userHash[14] == 111)
		return SO_EMULE;
	else if (m_userHash[5] == 'M' && m_userHash[14] == 'L')
		return SO_MLDONKEY;
	else
		return SO_UNKNOWN;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ReGetClientSoft()
{
	EMULE_TRY

//	If this client hasn't been contacted, it is SO_UNKNOWN
	if (m_strUserName.IsEmpty())
	{
		m_eClientSoft = SO_UNKNOWN;
		return;
	}

//	What is this client's hash type
	int		iHashType = GetHashType();

	switch (iHashType)
	{
	//	If the client is an old emule...
		case SO_OLDEMULE:
		{
			m_eClientSoft = SO_OLDEMULE;
			break;
		}
	//	If the client is an Ml donkey...
		case SO_MLDONKEY:
		{
			m_eClientSoft = SO_MLDONKEY;
			break;
		}
	//	If the client is an Emule compatible client...
		case SO_EMULE:
		{
			if (m_byteEmuleVersion != 0x99)
			{
				CString		strTemp;

				strTemp.Format("%02X", m_byteEmuleVersion);
				m_dwClientVersion = _tstoi(strTemp.GetBuffer()) * 10;
			}
			m_eClientSoft = GetClientTypeFromCompatibilityTag(m_dwCompatibleClient);
			if (m_eClientSoft == SO_UNKNOWN)
			{
				if (m_bIsML)
				{
					m_eClientSoft = SO_MLDONKEY;
				}
				else if (m_bIsHybrid)
				{
					m_eClientSoft = SO_EDONKEYHYBRID;
				}
				else
				{
					m_eClientSoft = SO_EMULE;
					AddDebugLogLine(false, "%s: New Compatible ClientSoft ET_COMPATIBLECLIENT = %i client will be listed as an emule ", __FUNCTION__, m_dwCompatibleClient);
				}
			}
			break;
		}
		default:
			// if we got ET_COMPATIBLECLIENT tag, try to detect client over this tag
			if (m_dwCompatibleClient != 0)
				m_eClientSoft = GetClientTypeFromCompatibilityTag(m_dwCompatibleClient);
			
			if (m_eClientSoft == SO_UNKNOWN)
			{
			//	If the client is an Ml donkey
				if (m_bIsML)
					m_eClientSoft = SO_MLDONKEY;
				else if (m_bEmuleProtocol)
				{
					m_eClientSoft = SO_EMULE;
				}
				else
				{
				//	We're left with donkeys and Hybrids
					if (m_bIsHybrid)
						m_eClientSoft = SO_EDONKEYHYBRID;
					else
						m_eClientSoft = SO_EDONKEY;
				}
			}
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::RequestSharedFileList()
{
	EMULE_TRY

	if (m_iFileListRequested == 0)
	{
		AddDebugLogLine(true, IDS_SHAREDFILES_REQUEST, GetUserName());
		m_iFileListRequested = m_iFileListRequestedSave = 1;
		TryToConnect(true);
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessSharedFileList(char *pachPacket, uint32 dwSize, LPCTSTR strDirectory)
{
	EMULE_TRY

	if (m_iFileListRequested > 0)
	{
		bool		bFirstDir = (m_iFileListRequested == m_iFileListRequestedSave);

		m_iFileListRequested--;
		g_eMuleApp.m_pSearchList->ProcessSharedFileListAnswer(pachPacket, dwSize, this, strDirectory, bFirstDir);
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString CUpDownClient::GetUploadFileInfo()
{
	if (this == NULL)
		return _T("");
	CString sRet;

//	build info text and display it
	sRet.Format(GetResString(IDS_USERINFO), GetUserName(), GetUserID());
	CKnownFile* file = g_eMuleApp.m_pSharedFilesList->GetFileByID(this->m_reqFileHash);
	if (file)
	{
		sRet += GetResString(IDS_SF_REQUESTED);
		sRet += CString(file->GetFileName());
		sRet += _T('\n');
		sRet.AppendFormat( GetResString(IDS_FILESTATS_SESSION) + GetResString(IDS_FILESTATS_TOTAL),
		             file->statistic.GetAccepts(), file->statistic.GetRequests(), CastItoXBytes(file->statistic.GetTransferred()),
		             file->statistic.GetAllTimeAccepts(), file->statistic.GetAllTimeRequests(), CastItoXBytes(file->statistic.GetAllTimeTransferred()) );
	}
	else
	{
		sRet += GetResString(IDS_REQ_UNKNOWNFILE);
	}
	return sRet;
}

void CUpDownClient::SetUserHash(uchar* m_achstrTempUserHash)
{
	if (m_achstrTempUserHash == NULL)
	{
		md4clr(m_userHash);
	}
	else
	{
		md4cpy(m_userHash, m_achstrTempUserHash);
	}
}

//BEGIN Improved Tooltips
CString CUpDownClient::GetUploadFileInfo4Tooltips()
{
	EMULE_TRY
	if (this == NULL)
		return _T("");
	CString sRet;

//	build info text and display it
	sRet.Format(GetResString(IDS_TT_USERINFO), GetUserName(), GetUserID());
	CKnownFile* file = g_eMuleApp.m_pSharedFilesList->GetFileByID(this->m_reqFileHash);
	if (file)
	{
		sRet.AppendFormat(GetResString(IDS_TT_REQUESTED), CString(file->GetFileName()));

		sRet.AppendFormat( GetResString(IDS_TT_FILESTATS_SESSION) + GetResString(IDS_TT_FILESTATS_TOTAL),
		             file->statistic.GetAccepts(), file->statistic.GetRequests(), CastItoXBytes(file->statistic.GetTransferred()),
		             file->statistic.GetAllTimeAccepts(), file->statistic.GetAllTimeRequests(), CastItoXBytes(file->statistic.GetAllTimeTransferred()) );
	}
	else
	{
		sRet += GetResString(IDS_REQ_UNKNOWNFILE);
	}
	return sRet;

	EMULE_CATCH

	return _T("");
}
//END Improved Tooltips
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	SendPublicKeyPacket() sends our public key to the client that requested it.
void CUpDownClient::SendPublicKeyPacket()
{
#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Sending public key to '%s'", __FUNCTION__, GetUserName()));
#endif

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL || m_pCredits == NULL || m_eSecureIdentState != IS_KEYANDSIGNEEDED)
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;

	Packet		*pPacket = new Packet(OP_PUBLICKEY, g_eMuleApp.m_pClientCreditList->GetPubKeyLen() + 1, OP_EMULEPROT);

	g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
	memcpy2(pPacket->m_pcBuffer + 1, g_eMuleApp.m_pClientCreditList->GetPublicKey(), g_eMuleApp.m_pClientCreditList->GetPubKeyLen());
	pPacket->m_pcBuffer[0] = g_eMuleApp.m_pClientCreditList->GetPubKeyLen();
#ifdef OLD_SOCKETS_ENABLED

	m_pRequestSocket->SendPacket(pPacket, true, true);
#endif //OLD_SOCKETS_ENABLED

	m_eSecureIdentState = IS_SIGNATURENEEDED;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendSignaturePacket()
{
//	signate the public key of this client and send it
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL || m_pCredits == NULL || m_eSecureIdentState == 0)
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED

	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;
	if (m_pCredits->GetSecIDKeyLen() == 0)
		return; // We don't have his public key yet, will be back here later
#ifdef DEBUG_SHOW_SECUREID

	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Sending signature key to '%s'", __FUNCTION__, GetUserName()));
#endif
//	do we have a challenge value received (actually we should if we are in this function)
	if (m_pCredits->m_dwCryptRndChallengeFrom == 0)
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Want to send signature but challenge value is invalid ('%s')", __FUNCTION__, GetUserName());
		return;
	}
//	v2
//	we will use v1 as default, except if only v2 is supported
	bool		bUseV2;

	if ((m_byteSupportSecIdent & 1) == 1)
		bUseV2 = false;
	else
		bUseV2 = true;

	byte		byteChallengeIPKind = 0;
	uint32		ChallengeIP = 0;
#ifdef OLD_SOCKETS_ENABLED

	if (bUseV2)
	{
		if (g_eMuleApp.m_pServerConnect->GetClientID() == 0 || g_eMuleApp.m_pServerConnect->IsLowID())
		{
		//	We cannot know for sure our public ip, so use the remote clients one
			ChallengeIP = GetIP();
			byteChallengeIPKind = CRYPT_CIP_REMOTECLIENT;
		}
		else
		{
			ChallengeIP = g_eMuleApp.m_pServerConnect->GetClientID();
			byteChallengeIPKind = CRYPT_CIP_LOCALCLIENT;
		}
	}
//end v2
#endif //OLD_SOCKETS_ENABLED
	uchar		achBuffer[250];
	byte		siglen = g_eMuleApp.m_pClientCreditList->CreateSignature(m_pCredits, achBuffer, 250, ChallengeIP, byteChallengeIPKind);

	if (siglen == 0)
	{
		ASSERT (false);
		return;
	}
	Packet		*pPacket = new Packet(OP_SIGNATURE, siglen + 1 + ((bUseV2) ? 1 : 0), OP_EMULEPROT);

	g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
	memcpy2(pPacket->m_pcBuffer + 1, achBuffer, siglen);
	pPacket->m_pcBuffer[0] = siglen;
	if (bUseV2)
		pPacket->m_pcBuffer[1 + siglen] = byteChallengeIPKind;
#ifdef OLD_SOCKETS_ENABLED

	m_pRequestSocket->SendPacket(pPacket, true, true);
#endif //OLD_SOCKETS_ENABLED

	m_eSecureIdentState = IS_ALLREQUESTSSEND;
}

void CUpDownClient::ProcessPublicKeyPacket(uchar* pbytePacket, uint32 dwSize)
{
//	g_eMuleApp.m_pClientList->AddTrackClient(this);
#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Receiving public key from '%s'", __FUNCTION__, GetUserName()));
#endif

#ifdef OLD_SOCKETS_ENABLED
	if ( m_pRequestSocket == NULL || m_pCredits == NULL || pbytePacket[0] != dwSize - 1
	     || dwSize == 0 || dwSize > 250 )
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;
//	the function will handle everything (mulitple key etc)
	if (m_pCredits->SetSecureIdent(pbytePacket + 1, pbytePacket[0]))
	{
	//	if this client wants a signature, now we can send him one
		if (m_eSecureIdentState == IS_SIGNATURENEEDED)
		{
			SendSignaturePacket();
		}
		else if (m_eSecureIdentState == IS_KEYANDSIGNEEDED)
		{
		//	something is wrong
			g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Invalid State error: IS_KEYANDSIGNEEDED in ProcessPublicKeyPacket", __FUNCTION__);
		}
	}
	else
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Failed to use new received public key", __FUNCTION__);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessSignaturePacket(uchar *pbytePacket, uint32 dwSize)
{
#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Receiving signature from '%s'", __FUNCTION__, GetUserName()));
#endif

//	Here we separate the good guys from the bad ones ;)

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL || m_pCredits == NULL || dwSize == 0 || dwSize > 250)
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED

	BYTE		byteChallengeIPKind;
	BYTE		byteSigLen = pbytePacket[0];
	bool		bClientSupportsSecIdentV2 = (m_byteSupportSecIdent & 2) > 0;

//	If the packet consists only of the signature length and signature (SecureIdent V1)...
	if (dwSize == sizeof(byteSigLen) + byteSigLen)
	{
		byteChallengeIPKind = 0;
	}
//	If the packet is long enough to contain the challenge IP kind (SecureIdent V2) and the client supports V2...
	else if (dwSize == byteSigLen + sizeof(byteSigLen) + sizeof(byteChallengeIPKind) && bClientSupportsSecIdentV2)
	{
		byteChallengeIPKind = pbytePacket[dwSize - 1];
	}
	else
	{
		ASSERT (false);
		return;
	}

	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;

//	If we already have a signature from this client IP...
	if (m_dwLastSignatureIP == GetIP())
	{
	//	We accept only one signature per IP, to avoid floods which need a lot cpu time for crypt functions
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Received multiple signatures from one client", __FUNCTION__);
		return;
	}
//	If we don't have a public key for this client...
	if (m_pCredits->GetSecIDKeyLen() == 0)
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Received signature for client without public key", __FUNCTION__);
		return;
	}
//	If we haven't generated a challenge value for this client yet...
	if (m_pCredits->m_dwCryptRndChallengeFor == 0)
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Received signature for client with invalid challenge value ('%s')", __FUNCTION__, GetUserName());
		return;
	}

	if (g_eMuleApp.m_pClientCreditList->VerifyIdent(m_pCredits, pbytePacket + 1, byteSigLen, GetIP(), byteChallengeIPKind))
	{
	//	result is saved in function above
	//g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "'%s' has passed the secure identification, V2 State: %i", GetUserName(), byteChallengeIPKind);
	}
#ifdef DEBUG_SHOW_SECUREID
	else
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: '%s' has failed the secure identification, V2 State: %i", __FUNCTION__, GetUserName(), byteChallengeIPKind);
	}
#endif

	m_dwLastSignatureIP = GetIP();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendSecIdentStatePacket()
{
//	check if we need public key and signature
	BYTE		byteValue = 0;

	if (m_pCredits != NULL)
	{
		if (g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		{
			if (m_pCredits->GetSecIDKeyLen() == 0)
			{
				byteValue = IS_KEYANDSIGNEEDED;
			}
			else if (m_dwLastSignatureIP != GetIP())
			{
				byteValue = IS_SIGNATURENEEDED;
			}
		}
	//	If we already have the key and signature, we're done.
		if (byteValue == 0)
		{
#ifdef DEBUG_SHOW_SECUREID
			DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Not sending SecIdentState Packet, because State is Zero", __FUNCTION__));
#endif
			return;
		}
	//	crypt: send random data to sign
		uint32		dwRandom = rand() + 1;

		m_pCredits->m_dwCryptRndChallengeFor = dwRandom;

#ifdef DEBUG_SHOW_SECUREID
		DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Sending SecIdentState packet, state: %i (to '%s')", __FUNCTION__, byteValue, GetUserName()));
#endif

		Packet		*pPacket = new Packet(OP_SECIDENTSTATE, 5, OP_EMULEPROT);

		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
		pPacket->m_pcBuffer[0] = byteValue;
		memcpy2(pPacket->m_pcBuffer + 1, &dwRandom, sizeof(dwRandom));

#ifdef OLD_SOCKETS_ENABLED
		m_pRequestSocket->SendPacket(pPacket, true, true);
#endif //OLD_SOCKETS_ENABLED

	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessSecIdentStatePacket(uchar *pbytePacket, uint32 dwSize)
{
	if (dwSize != 5)	// <= ICK! Define a struct and use sizeof :P !
		return;
	if (m_pCredits == NULL)
		return;

	switch (pbytePacket[0])
	{
		case 0:
			m_eSecureIdentState = IS_UNAVAILABLE;
			break;
		case 1:
			m_eSecureIdentState = IS_SIGNATURENEEDED;
			break;
		case 2:
			m_eSecureIdentState = IS_KEYANDSIGNEEDED;
			break;
	}
	uint32		dwRandom;

	memcpy2(&dwRandom, pbytePacket + 1, 4);
	m_pCredits->m_dwCryptRndChallengeFrom = dwRandom;

#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Received SecIdentState Packet, state: %i", __FUNCTION__, pbytePacket[0]));
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	InfoPacketsReceived() is called once the HELLO/HELLOANSWER and EMULEINFO/EMULEINFOANSWER information has
//		been received.
void CUpDownClient::InfoPacketsReceived()
{
	ASSERT (m_eInfoPacketsReceived == IP_BOTH);

	m_eInfoPacketsReceived = IP_NONE;

//	If this client supports secure credits...
	if (m_byteSupportSecIdent)
	{
		SendSecIdentStatePacket();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
