//this file is part of eMule
//created by Ornis
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// CatDialog.cpp : implementation file

#include "stdafx.h"
#include "eMule.h"
#include "CatDialog.h"
#include "Preferences.h"
#include "otherfunctions.h"
#include "AddBuddy.h"

// CCatDialog dialog

IMPLEMENT_DYNAMIC(CCatDialog, CDialog)
CCatDialog::CCatDialog(int index)
	: CDialog(CCatDialog::IDD, 0)
{
	m_pCat = CCat::GetCatByIndex(index);
	if (m_pCat == NULL)
		return;
}

BOOL CCatDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	Localize();
	UpdateData();

	AddBuddy(GetDlgItem(IDC_INCOMING)->m_hWnd, GetDlgItem(IDC_BROWSE)->m_hWnd, BDS_RIGHT);

	return true;
}

void CCatDialog::UpdateData()
{
	SetDlgItemText(IDC_TITLE, m_pCat->GetTitle());
	SetDlgItemText(IDC_INCOMING, m_pCat->GetPath());
	SetDlgItemText(IDC_COMMENT, m_pCat->GetComment());

	m_dwNewColor = m_pCat->GetColor();
	m_ctlColor.SetColor(m_dwNewColor);

	SetDlgItemText(IDC_AUTOCATEXT, m_pCat->GetAutoCatExt());

	m_cmbPriority.SetCurSel(m_pCat->GetPriority());
}

CCatDialog::~CCatDialog()
{
}

void CCatDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CATCOLOR, m_ctlColor);
	DDX_Control(pDX, IDC_PRIOCOMBO, m_cmbPriority);
}


BEGIN_MESSAGE_MAP(CCatDialog, CDialog)
	ON_BN_CLICKED(IDC_BROWSE, OnBnClickedBrowse)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_MESSAGE(CPN_SELENDOK, OnSelChange) //CPN_SELCHANGE
END_MESSAGE_MAP()

// CCatDialog message handlers

void CCatDialog::Localize()
{
	static const int s_aiResTbl[][2] =
	{
		{ IDC_STATIC_TITLE, IDS_TITLE },
		{ IDC_STATIC_COMMENT, IDS_COMMENT },
		{ IDCANCEL, IDS_CANCEL },
		{ IDC_STATIC_COLOR, IDS_COLOR },
		{ IDC_STATIC_PRIO, IDS_STARTPRIO },
		{ IDC_STATIC_AUTOCAT, IDS_AUTOCAT_LABEL }
	};

	CString strBuffer = GetResString(IDS_PW_INCOMING);

	strBuffer.Remove(_T(':'));
	SetDlgItemText(IDC_STATIC_INCOMING, strBuffer);

	for (uint32 i = 0; i < ELEMENT_COUNT(s_aiResTbl); i++)
		SetDlgItemText(s_aiResTbl[i][0], GetResString(static_cast<UINT>(s_aiResTbl[i][1])));

	m_ctlColor.CustomText = _T(GetResString(IDS_COL_MORECOLORS));
	m_ctlColor.DefaultText = _T(GetResString(IDS_DEFAULT));
	m_ctlColor.SetDefaultColor(NULL);

	SetWindowText(GetResString(IDS_CAT_EDIT));

	while (m_cmbPriority.GetCount() > 0)
		m_cmbPriority.DeleteString(0);
	m_cmbPriority.AddString(GetResString(IDS_DONTCHANGE));
	m_cmbPriority.AddString(GetResString(IDS_PRIOLOW));
	m_cmbPriority.AddString(GetResString(IDS_PRIONORMAL));
	m_cmbPriority.AddString(GetResString(IDS_PRIOHIGH));
	m_cmbPriority.AddString(GetResString(IDS_PRIOAUTO));
	m_cmbPriority.SetCurSel(m_pCat->GetPriority());
}

void CCatDialog::OnBnClickedBrowse()
{
//	TCHAR buffer[MAX_PATH] = {0};
//	GetDlgItemText(IDC_INCOMING, buffer, ARRSIZE(buffer));
//	if(SelectDir(GetSafeHwnd(), buffer,GetResString(IDS_SELECTOUTPUTDIR)))
//		CString newpath = BrowseFolder(g_eMuleApp.m_pdlgEmule->m_hWnd,GetResString(IDS_SELECTOUTPUTDIR),dir);
//	GetDlgItem(IDC_INCOMING)->SetWindowText(buffer);

	CString	strDir;

	GetDlgItemText(IDC_INCOMING, strDir);

	CString strNewPath = BrowseFolder(GetSafeHwnd(), GetResString(IDS_SELECTOUTPUTDIR), strDir);

	if (strNewPath != strDir)
		SetDlgItemText(IDC_INCOMING, strNewPath);
}

void CCatDialog::OnBnClickedOk()
{
	CString	strOldPath = m_pCat->GetPath();

	TCHAR		strPath[MAX_PATH];

	GetDlgItemText(IDC_TITLE, m_pCat->m_strTitle);
	if (m_pCat->m_strTitle.GetLength() > 64)
		m_pCat->m_strTitle.Truncate(64);

	if (GetDlgItem(IDC_INCOMING)->GetWindowTextLength() > 2)
	{
		GetDlgItemText(IDC_INCOMING, strPath, MAX_PATH);
		//m_pCat->m_strSavePath = strPath;

		::MakeFolderName(strPath);
		m_pCat->m_strSavePath = strPath;

		if (!g_eMuleApp.m_pGlobPrefs->IsShareableDirectory(m_pCat->GetPath()))
		{
			_tcscpy(strPath,g_eMuleApp.m_pGlobPrefs->GetIncomingDir());
			::MakeFolderName(strPath);
			m_pCat->m_strSavePath = strPath;
		}
		if (!PathFileExists(m_pCat->GetPath()))
			::CreateDirectory(m_pCat->GetPath(), 0);

		CString	strNewPath = m_pCat->GetPath();

		if (strNewPath.CompareNoCase(strOldPath) != 0)
		{
			CString	strCatPath = m_pCat->GetPath();
			bool	bFoundDir = false;

			if (strCatPath.GetLength() != 3)
				strCatPath += _T("\\");

			for (POSITION pos = g_eMuleApp.m_pGlobPrefs->m_sharedDirList.GetHeadPosition(); pos != NULL; )
			{
				if (g_eMuleApp.m_pGlobPrefs->m_sharedDirList.GetNext(pos) == strCatPath)
				{
					bFoundDir = true;
					break;
				}
			}

			if (!bFoundDir)
			{
				g_eMuleApp.m_pGlobPrefs->m_sharedDirList.AddTail(strCatPath);
				g_eMuleApp.m_pSharedFilesList->Reload();
			}
		}
	}

	GetDlgItemText(IDC_COMMENT, m_pCat->m_strComment);

	m_pCat->m_crColor = m_dwNewColor;
	m_pCat->m_iPriority = m_cmbPriority.GetCurSel();

	GetDlgItemText(IDC_AUTOCATEXT, m_pCat->m_strAutoCatExt);

	g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlDownloadList.Invalidate();

	OnOK();
}

LONG CCatDialog::OnSelChange(UINT lParam, LONG wParam)
{
	if (lParam == CLR_DEFAULT)
		m_dwNewColor = 0;
	else
		m_dwNewColor = m_ctlColor.GetColor();

	return TRUE;
}
