
#include "stdafx.h"
#include "emule.h"
#include "CommentDialogLst.h"
#include "PastComment.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define DRAWTEXTFMT		(DT_LEFT | DT_BOTTOM | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX)


IMPLEMENT_DYNAMIC(CCommentDialogLst, CDialog)
CCommentDialogLst::CCommentDialogLst(CPartFile* file)
   : CResizableDialog(CCommentDialogLst::IDD, 0)
{
   m_file = file;
}

CCommentDialogLst::~CCommentDialogLst()
{
}

void CCommentDialogLst::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_LST, pmyListCtrl);
}

BEGIN_MESSAGE_MAP(CCommentDialogLst, CResizableDialog)
   ON_BN_CLICKED(IDCOK, OnBnClickedApply)
   ON_BN_CLICKED(IDCREF, OnBnClickedRefresh)
   ON_WM_DESTROY()
   ON_WM_DRAWITEM()
   ON_NOTIFY(NM_RCLICK, IDC_LST, OnNMRclickList)
END_MESSAGE_MAP()



void CCommentDialogLst::OnBnClickedApply()
{
   CDialog::OnOK();
}

void CCommentDialogLst::OnBnClickedRefresh()
{
   CompleteList();
}

BOOL CCommentDialogLst::OnInitDialog()
{
   CResizableDialog::OnInitDialog();

   //SetIcon(g_eMuleApp.m_pdlgEmule->m_hiconSourceTray,FALSE);

   AddAnchor(IDC_LST,TOP_LEFT,BOTTOM_RIGHT);
   AddAnchor(IDCOK,BOTTOM_RIGHT);
   AddAnchor(IDCREF,BOTTOM_RIGHT);
   AddAnchor(IDC_CMSTATUS,BOTTOM_LEFT);

   pmyListCtrl.InsertColumn(0, GetResString(IDS_QL_USERNAME), LVCFMT_LEFT, 100, -1);
   pmyListCtrl.InsertColumn(1, GetResString(IDS_DL_FILENAME), LVCFMT_LEFT, 150, -1);
   pmyListCtrl.InsertColumn(2, GetResString(IDS_QL_RATING), LVCFMT_LEFT, 80, 1);
   pmyListCtrl.InsertColumn(3, GetResString(IDS_COMMENT), LVCFMT_LEFT, 315, 1);
   pmyListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT);

   Localize();
   CompleteList();

   return TRUE;
}

void CCommentDialogLst::Localize(void)
{
   SetDlgItemText(IDCOK, GetResString(IDS_CW_CLOSE));
   SetDlgItemText(IDCREF, GetResString(IDS_CMT_REFRESH));
   SetWindowText(GetResString(IDS_CMT_READALL)+_T(" (")+ m_file->GetFileName() +_T(")"));
}

void CCommentDialogLst::CompleteList ()
{
	POSITION			pos;
	CUpDownClient	   *pClient;
	int					iCount = 0;

	pmyListCtrl.DeleteAllItems();

	for (int sl = 0; sl < SOURCESSLOTS; sl++)
	{
		if (!m_file->m_srcLists[sl].IsEmpty())
		{
			for (pos = m_file->m_srcLists[sl].GetHeadPosition(); pos != NULL; )
			{
				pClient = m_file->m_srcLists[sl].GetNext(pos);

				if (pClient->GetFileComment().GetLength() > 0 || pClient->GetFileRating() != PF_RATING_NONE)
				{
					pmyListCtrl.InsertItem(iCount, pClient->GetUserName());
					pmyListCtrl.SetItemText(iCount, 1, pClient->GetClientFilename());
					pmyListCtrl.SetItemText(iCount, 2, GetRatingString(pClient->GetFileRating()));
					pmyListCtrl.SetItemText(iCount, 3, pClient->GetFileComment());
					iCount++;
			  	}
			}
		}
	}

   	CString	comment = m_file->GetFileComment();
	CString	rated = GetRatingString(m_file->GetFileRating());

	if (comment != _T("") || rated != GetRatingString(PF_RATING_NONE))
	{
		pmyListCtrl.InsertItem(iCount, g_eMuleApp.m_pGlobPrefs->GetUserNick());
		pmyListCtrl.SetItemText(iCount, 1, m_file->GetFileName());
		pmyListCtrl.SetItemText(iCount, 2, rated);
		pmyListCtrl.SetItemText(iCount, 3, comment);
		iCount++;
	}

	CPastCommentList	   &pclist = m_file->GetPastCommentList();

	for (pos = pclist.GetHeadPosition(); pos != NULL; )
	{
		CPastComment &pc = pclist.GetNext(pos);

		pmyListCtrl.InsertItem(LVIF_TEXT | LVIF_PARAM, iCount, pc.GetClientName(), 0, 0, 0, 1);
		pmyListCtrl.SetItemText(iCount, 1, pc.GetFileName());
		pmyListCtrl.SetItemText(iCount, 2, GetRatingString(pc.GetRating()));
		pmyListCtrl.SetItemText(iCount, 3, pc.GetComment());
		iCount++;
	}

	CString	info = _T("");

	if (iCount == 0)
	{
		info.Format(_T("(%s)"), GetResString(IDS_CMT_NONE));
	}
	SetDlgItemText(IDC_CMSTATUS, info);
	m_file->UpdateFileRatingCommentAvail();
}

void CCommentDialogLst::OnDestroy()
{
	CResizableDialog::OnDestroy();
}

void CCommentDialogLst::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	if (nIDCtl != IDC_LST)
		return;

	UINT nItemID= lpDrawItemStruct->itemID;
	if (nItemID == (UINT)-1)
		return;

	CString strUserName= pmyListCtrl.GetItemText(nItemID, 0);
	CString strFileName= pmyListCtrl.GetItemText(nItemID, 1);
	CString strRate= pmyListCtrl.GetItemText(nItemID, 2);
	CString strComment= pmyListCtrl.GetItemText(nItemID, 3);
	bool bPastComment= (pmyListCtrl.GetItemData(nItemID) != 0);

	CDC dc;
	dc.Attach(lpDrawItemStruct->hDC);
	CRect rc(lpDrawItemStruct->rcItem);

	dc.SetBkMode(TRANSPARENT);

	if ( (lpDrawItemStruct->itemAction | ODA_SELECT) && (lpDrawItemStruct->itemState & ODS_SELECTED) )
	{
		dc.FillSolidRect(rc, GetSysColor(COLOR_HIGHLIGHT));
		dc.SetTextColor(bPastComment ? GetSysColor(COLOR_GRAYTEXT) : GetSysColor(COLOR_HIGHLIGHTTEXT));
	}
	else
	{
		dc.FillSolidRect(rc, GetSysColor(COLOR_WINDOW));
		dc.SetTextColor(bPastComment ? GetSysColor(COLOR_GRAYTEXT) : GetSysColor(COLOR_WINDOWTEXT));
	}

	rc.right= rc.left + pmyListCtrl.GetColumnWidth(0) - 2;
	rc.left+= 2;
	dc.DrawText(strUserName, rc, DRAWTEXTFMT);

	rc.left= rc.right + 4;
	rc.right+= pmyListCtrl.GetColumnWidth(1);
	dc.DrawText(strFileName, rc, DRAWTEXTFMT);

	rc.left= rc.right + 4;
	rc.right+= pmyListCtrl.GetColumnWidth(2);
	dc.DrawText(strRate, rc, DRAWTEXTFMT);

	rc.left= rc.right + 4;
	rc.right+= pmyListCtrl.GetColumnWidth(3);
	dc.DrawText(strComment, rc, DRAWTEXTFMT);

	dc.Detach();
}

void CCommentDialogLst::OnNMRclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	if ((pmyListCtrl.GetSelectionMark() != (-1)) && (pmyListCtrl.GetSelectedCount() == 1))
	{
		CTitleMenu	menuCmt;
		POINT		point;

		::GetCursorPos(&point);
		menuCmt.CreatePopupMenu();
		//menuCmt.AddMenuTitle(GetResString(IDS_COMMENT));
		menuCmt.AppendMenu(MF_STRING, MP_MESSAGE, GetResString(IDS_COPY));
		menuCmt.TrackPopupMenuEx(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this, NULL);
//	Menu objects are destroyed in their destructor
	}
	*pResult = 0;
}

BOOL CCommentDialogLst::OnCommand(WPARAM wParam,LPARAM lParam )
{
	if (pmyListCtrl.GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED) != -1)
	{
		switch (wParam)
		{
		case MP_MESSAGE:
			POSITION pos = pmyListCtrl.GetFirstSelectedItemPosition();
			g_eMuleApp.CopyTextToClipboard( pmyListCtrl.GetItemText(pmyListCtrl.GetNextSelectedItem(pos), 3) );
			return true;
		}
	}
	return CDialog::OnCommand(wParam, lParam);
}
