// CDScores.cpp : implementation file
//

#include "stdafx.h"
#include "CDScores.h"
#include "..\UpDownClient.h"
#include "..\eMule.h"


// CCDScores dialog

IMPLEMENT_DYNCREATE(CCDScores, CPropertyPage)

CCDScores::CCDScores() : CPropertyPage(CCDScores::IDD)
{
	//{{AFX_DATA_INIT(CCDScores)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CCDScores::~CCDScores()
{
}

void CCDScores::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCDScores)
	DDX_Control(pDX, IDC_SCORES_LBL, m_ctrlScores);
	DDX_Control(pDX, IDC_REMOTESCORES_LBL, m_ctrlRemoteScores);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_DLUPMODIFIER_VAL, m_ctrlDlUpModifier);
	DDX_Control(pDX, IDC_COMMUNITYUSER_VAL, m_ctrlCommunityUser);
	DDX_Control(pDX, IDC_RATING_VAL, m_ctrlRating);
	DDX_Control(pDX, IDC_UPQUEUESCORE_VAL, m_ctrlUpQueueScore);
	DDX_Control(pDX, IDC_QUEUETIME_VAL, m_ctrlQueueTime);
	DDX_Control(pDX, IDC_REMCOMMUNITY_VAL, m_ctrlRemCommunityUser);
	DDX_Control(pDX, IDC_REMDLUPMODIFIER_VAL, m_ctrlRemDlUpModifier);
	DDX_Control(pDX, IDC_REMRATING_VAL, m_ctrlRemRating);
	DDX_Control(pDX, IDC_REMUPQUEUESCORE_VAL, m_ctrlRemUpQueueScore);
}


BEGIN_MESSAGE_MAP(CCDScores, CPropertyPage)
	//{{AFX_MSG_MAP(CCDScores)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CCDScores message handlers

BOOL CCDScores::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CCDScores::Update(void)
{
	EMULE_TRY

	if(m_pClient == NULL)
		return;

	if(!::IsWindow(GetSafeHwnd()))
		return;

	UINT		dwResStrId = IDS_DISABLED;

	if (g_eMuleApp.m_pGlobPrefs->CommunityEnabled())
	{
		dwResStrId = ((m_pClient->IsCommunity()) ? IDS_YES : IDS_NO);
	}
	m_ctrlCommunityUser.SetWindowText(::GetResString(dwResStrId));

	CString strBuffer;

	if(m_pClient->Credits())
	{
		strBuffer.Format(_T("%.1f"), (double)m_pClient->Credits()->GetScoreRatio(m_pClient->GetIP()));
		m_ctrlDlUpModifier.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlDlUpModifier.SetWindowText(_T("?"));
	}

	bool bLoadedSourceName = false ;
	if(m_pClient->GetUserName())
	{
		bLoadedSourceName = (_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_LOADEDSOURCE)) != NULL) || 
							(_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_EXCHANGEDSOURCE)) != NULL) ;
	}

	if(m_pClient->GetUserName() && !bLoadedSourceName)
	{
		strBuffer.Format(_T("%.1f"), (double)m_pClient->GetScore(false, m_pClient->IsDownloading(), true));
		m_ctrlRating.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlRating.SetWindowText(_T("?"));
	}

	if(m_pClient->GetUploadState() != US_NONE)
	{
		strBuffer.Format(_T("%u"), m_pClient->GetScore(false, m_pClient->IsDownloading(), false));
		m_ctrlUpQueueScore.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlUpQueueScore.SetWindowText(_T("-"));
	}

	if(m_pClient->GetDownloadState() == DS_ONQUEUE)
	{
		m_ctrlQueueTime.SetWindowText(::CastSecondsToHM(m_pClient->GetQueueWaitTime() / 1000));
	}
	else
	{
		m_ctrlQueueTime.SetWindowText(_T("-"));
	}

	dwResStrId = IDS_DISABLED;

	if (m_pClient->IsRemoteInfoAvaiable() && m_pClient->GetRemoteCommunityEnabled())
	{
		dwResStrId = (m_pClient->GetRemoteCommunity()) ? IDS_YES : IDS_NO;
	}
	m_ctrlRemCommunityUser.SetWindowText(::GetResString(dwResStrId));

	if (m_pClient->IsRemoteInfoAvaiable() || m_pClient->Credits())
	{
		strBuffer.Format(_T("%0.1f"), m_pClient->GetRemoteBaseModifier());
		m_ctrlRemDlUpModifier.SetWindowText(strBuffer);

		strBuffer.Format(_T("%ld"), m_pClient->GetRemoteRatio());
		m_ctrlRemRating.SetWindowText(strBuffer);
		
		strBuffer.Format(_T("%ld"), m_pClient->GetRemoteScore());
		m_ctrlRemUpQueueScore.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlRemDlUpModifier.SetWindowText(_T("?"));
		m_ctrlRemRating.SetWindowText(_T("?"));
		m_ctrlRemUpQueueScore.SetWindowText(_T("?"));
	}

	EMULE_CATCH
}

void CCDScores::Localize(void)
{
	static const int aiResTbl[][2] =
	{
		{ IDC_SCORES_LBL, IDS_CD_SCORES },
		{ IDC_COMMUNITYUSER_LBL, IDS_COMUSER },
		{ IDC_DLUPMODIFIER_LBL, IDS_CD_MOD },
		{ IDC_UPQUEUESCORE_LBL, IDS_CD_USCORE },
		{ IDC_QUEUETIME_LBL, IDS_QUEUETIMELBL },
		{ IDC_REMOTESCORES_LBL, IDS_INFLST_REMOTE_SCORES },
		{ IDC_REMCOMMUNITY_LBL, IDS_COMUSER },
		{ IDC_REMDLUPMODIFIER_LBL, IDS_CD_MOD },
		{ IDC_REMUPQUEUESCORE_LBL, IDS_CD_USCORE }
	};
	static const int aiResTbl2[][2] =
	{
		{ IDC_RATING_LBL, IDS_QL_RATING },
		{ IDC_REMRATING_LBL, IDS_QL_RATING }
	};

	EMULE_TRY

	if (GetSafeHwnd())
	{
		for (uint32 i = 0; i < ELEMENT_COUNT(aiResTbl); i++)
			SetDlgItemText(aiResTbl[i][0], GetResString(static_cast<UINT>(aiResTbl[i][1])));

		CString strBuffer;

		for (uint32 i = 0; i < ELEMENT_COUNT(aiResTbl2); i++)
		{
			strBuffer.Format("%s:", GetResString(static_cast<UINT>(aiResTbl2[i][1])));
			SetDlgItemText(aiResTbl2[i][0], strBuffer);
		}
	}

	EMULE_CATCH
}
