// FDAviInfo.cpp : implementation file
//

#include "stdafx.h"
#include "FDAviInfo.h"
#include "..\eMule.h"
#include "..\otherfunctions.h"

// CFDAviInfo dialog

IMPLEMENT_DYNCREATE(CFDAviInfo, CPropertyPage)

CFDAviInfo::CFDAviInfo() : CPropertyPage(CFDAviInfo::IDD)
, m_bARoundBitrate(FALSE)
{
	//{{AFX_DATA_INIT(CFDAviInfo)
	//}}AFX_DATA_INIT

	m_pFile = NULL;
}

CFDAviInfo::~CFDAviInfo()
{
}

void CFDAviInfo::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDAviInfo)
	DDX_Control(pDX, IDC_WIDTH_VAL, m_ctrlWidth);
	DDX_Control(pDX, IDC_VIDEOCODEC_VAL, m_ctrlVideoCodec);
	DDX_Control(pDX, IDC_VIDEOBITRATE_VAL, m_ctrlVideoBitrate);
	DDX_Control(pDX, IDC_SAMPLERATE_VAL, m_ctrlSamplerate);
	DDX_Control(pDX, IDC_HEIGHT_VAL, m_ctrlHeight);
	DDX_Control(pDX, IDC_FPS_VAL, m_ctrlFPS);
	DDX_Control(pDX, IDC_CHANNEL_VAL, m_ctrlChannel);
	DDX_Control(pDX, IDC_AUDIOCODEC_VAL, m_ctrlAudioCodec);
	DDX_Control(pDX, IDC_AUDIOBITRATE_VAL, m_ctrlAudioBitrate);
	DDX_Control(pDX, IDC_VIDEO_LBL, m_ctrlVideoLbl);
	DDX_Control(pDX, IDC_PICTURE_LBL, m_ctrlPictureLbl);
	DDX_Control(pDX, IDC_AUDIO_LBL, m_ctrlAudioLbl);
	//}}AFX_DATA_MAP
	DDX_Check(pDX, IDC_ROUNDBITRATE_BTN, m_bARoundBitrate);
	DDX_Control(pDX, IDC_FILESIZE_VAL, m_ctrlFilesize);
	DDX_Control(pDX, IDC_FILELENGTH_VAL, m_ctrlFilelength);
}


BEGIN_MESSAGE_MAP(CFDAviInfo, CPropertyPage)
	//{{AFX_MSG_MAP(CFDAviInfo)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ROUNDBITRATE_BTN, OnBnClickedRoundbitrateBtn)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDAviInfo message handlers

BOOL CFDAviInfo::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_bARoundBitrate = TRUE;
	m_dwAbitrate = 0;
	CPropertyPage::UpdateData(FALSE);
	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CFDAviInfo::Update()
{
	EMULE_TRY

	if(m_pFile == NULL)
		return;
	
	if(!::IsWindow(GetSafeHwnd()))
		return;

	CFile *pFile = &m_pFile->m_hPartFile;
	try
	{
		TCHAR szTemp[5];
		uint32 u32;
		uint16 u16;

		if(pFile == NULL)
		{
			return;
		}

		pFile->Seek(8, CFile::begin);
		pFile->Read(szTemp, 4);
		szTemp[4] = 0;
		if(_tcscmp(szTemp, _T("AVI "))) // not avi
		{
			return;
		}

		CString		strBuffer;
		uint32		dwSize;

	//	Filesize
		pFile->Seek(4, CFile::begin);
		pFile->Read(&dwSize, 4);
		strBuffer.Format(_T("%.2f MB"), (static_cast<double>(dwSize) / 1024.0 / 1024.0));
		m_ctrlFilesize.SetWindowText(strBuffer);
		
	//	Header sizes
		long lAviheadersize, lVheadersize;
		pFile->Seek(28, CFile::begin);
		pFile->Read(&lAviheadersize, 4);

		long lAviheaderstart = 32;
		long lVheaderstart = lAviheaderstart + lAviheadersize + 20;

	//	Misc
		long lMicrosec;
		pFile->Seek(lAviheaderstart, CFile::begin);
		pFile->Read(&lMicrosec, 4);

		long lLengthInFrames;
		pFile->Seek(lAviheaderstart + 16, CFile::begin);
		pFile->Read(&lLengthInFrames, 4);

	//	FPS
		double dFps = (double)1000000 / (double)lMicrosec;
		strBuffer.Format(_T("%.2f"), dFps);
		m_ctrlFPS.SetWindowText(strBuffer);

	//	Length
		uint32 dwLengthInSec = (long)(lLengthInFrames / dFps);
		m_ctrlFilelength.SetWindowText(CastSecondsToHM(dwLengthInSec));

	//	Video width
		pFile->Seek(lAviheaderstart + 32, CFile::begin);
		pFile->Read(&u32, 4);
		strBuffer.Format(_T("%u"), u32);
		m_ctrlWidth.SetWindowText(strBuffer);

	//	Video height
		pFile->Seek(lAviheaderstart + 36, CFile::begin);
		pFile->Read(&u32, 4);
		strBuffer.Format(_T("%u"), u32);
		m_ctrlHeight.SetWindowText(strBuffer);

	//	Video codec
		pFile->Seek(lVheaderstart + 4, CFile::begin);
		pFile->Read(szTemp, 4);
		szTemp[4] = 0;
		if(!_tcscmp(szTemp, _T("div3")) || !_tcscmp(szTemp, _T("DIV3")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("DivX 3 Low-Motion"));
		}
		else if(!_tcscmp(szTemp, _T("div4")) || !_tcscmp(szTemp, _T("DIV4")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("DivX 3 High-Motion"));
		}
		else if(!_tcscmp(szTemp, _T("divx")) || !_tcscmp(szTemp, _T("DIVX")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("DivX 4"));
		}
		else if(!_tcscmp(szTemp, _T("DX50")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("DivX 5"));
		}
		else if(!_tcscmp(szTemp, _T("div2")) || !_tcscmp(szTemp, _T("DIV2")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("MS MPEG4 v2"));
		}
		else if(!_tcscmp(szTemp, _T("mp43")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("Microcrap MPEG4 v3"));
		}
		else if(!_tcscmp(szTemp, _T("xvid")) || !_tcscmp(szTemp, _T("XVID")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("XviD"));
		}
		else
		{
			m_ctrlVideoCodec.SetWindowText(szTemp);
		}
		
	//	Header sizes
		pFile->Seek(lAviheaderstart + lAviheadersize + 4, CFile::begin);
		pFile->Read(&lVheadersize, 4);

		long lAheaderstart = lVheaderstart + lVheadersize + 8;	//first databyte of audio header

		long lAstrhsize;
		pFile->Seek(lAheaderstart - 4, CFile::begin);
		pFile->Read(&lAstrhsize, 4);

	//	Audio codec
		pFile->Seek(lAheaderstart + lAstrhsize + 8, CFile::begin);
		pFile->Read(&u16, 2);
		switch(u16)
		{
			case 0:
			case 1:
				m_ctrlAudioCodec.SetWindowText(_T("PCM"));
				break;
			case 353:
				m_ctrlAudioCodec.SetWindowText(_T("DivX;-) Audio"));
				break;
			case 85:
				m_ctrlAudioCodec.SetWindowText(_T("MPEG Layer 3"));
				break;
			case 8192:
				m_ctrlAudioCodec.SetWindowText(_T("AC3-Digital"));
				break;
			default:
				strBuffer.Format(_T("Unknown (%u)"), u16);
				m_ctrlAudioCodec.SetWindowText(strBuffer);
				break;
		}

	//	Audio channel
		pFile->Seek(lAheaderstart + 2 + lAstrhsize + 8, CFile::begin);
		pFile->Read(&u16, 2);
		switch(u16)
		{
			case 1:
				m_ctrlChannel.SetWindowText(_T("1 (mono)"));
				break;
			case 2:
				m_ctrlChannel.SetWindowText(_T("2 (stereo)"));
				break;
			case 5:
				m_ctrlChannel.SetWindowText(_T("5.1 (surround)"));
				break;
			default:
				strBuffer.Format(_T("%u"), u16);
				m_ctrlChannel.SetWindowText(strBuffer);
				break;
		}

	//	Audio samplerate
		pFile->Seek(lAheaderstart + 4 + lAstrhsize + 8, CFile::begin);
		pFile->Read(&u32, 2);
		strBuffer.Format(_T("%u"), u32);
		m_ctrlSamplerate.SetWindowText(strBuffer);

	//	Audio bitrate
		pFile->Seek(lAheaderstart + 8 + lAstrhsize + 8, CFile::begin);
		pFile->Read(&m_dwAbitrate, 4);
		OnBnClickedRoundbitrateBtn();

	//	Video bitrate
		strBuffer.Format(_T("%u Kbit/s"), (dwSize / dwLengthInSec - m_dwAbitrate) / 128);
		m_ctrlVideoBitrate.SetWindowText(strBuffer);

	}
	catch(CFileException* error)
	{
		OUTPUT_DEBUG_TRACE();
		error->Delete();
		return;
	}

	EMULE_CATCH
}

void CFDAviInfo::OnBnClickedRoundbitrateBtn()
{
	EMULE_TRY

	if (m_dwAbitrate != 0)
	{
		CPropertyPage::UpdateData();

		uint32		dwKbit = m_dwAbitrate / (1024 / 8);

		if (m_bARoundBitrate)
		{
			if ((dwKbit >= 246) && (dwKbit <= 260))
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("256 Kbit/s"));
			}	
			else if ((dwKbit >= 216) && (dwKbit <= 228))
			{
				m_ctrlAudioBitrate.SetWindowText(_T("224 Kbit/s"));
			}
			else if ((dwKbit >= 187) && (dwKbit <= 196))
			{
				m_ctrlAudioBitrate.SetWindowText(_T("192 Kbit/s"));
			}
			else if ((dwKbit >= 156) && (dwKbit <= 164))
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("160 Kbit/s"));
			}
			else if ((dwKbit >= 124) && (dwKbit <= 132))
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("128 Kbit/s"));
			}
			else if ((dwKbit >= 108) && (dwKbit <= 116))
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("112 Kbit/s"));
			}
			else if ((dwKbit >= 92) && (dwKbit <= 100))
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("96 Kbit/s"));
			}
			else if ((dwKbit >= 60) && (dwKbit <= 68))
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("64 Kbit/s"));
			}
			else
			{
				CString strBuffer;
				strBuffer.Format(_T("%u Kbit/s"), dwKbit);
				m_ctrlAudioBitrate.SetWindowText(strBuffer);
			}
		}
		else
		{
			CString strBuffer;
			strBuffer.Format(_T("%u Kbit/s"), dwKbit);
			m_ctrlAudioBitrate.SetWindowText(strBuffer);
		}
	}
	else
	{	
		m_ctrlAudioBitrate.SetWindowText(_T(""));
	}

	EMULE_CATCH
}

void CFDAviInfo::Localize()
{
	static const int aiResTbl[][2] =
	{
		{ IDC_PICTURE_LBL, IDS_FD_PICTURE },
		{ IDC_AUDIO_LBL, IDS_AUDIO },
		{ IDC_ROUNDBITRATE_BTN, IDS_ROUNDBITRATE },
		{ IDC_VIDEO_LBL, IDS_VIDEO },
		{ IDC_FILESIZE_LBL, IDS_FD_SIZE }
	};
	static const int aiResTbl2[][2] =
	{
		{ IDC_WIDTH_LBL, IDS_WIDTH },
		{ IDC_HEIGHT_LBL, IDS_HEIGHT },
		{ IDC_AUDIOCODEC_LBL, IDS_CODEC },
		{ IDC_AUDIOBITRATE_LBL, IDS_BITRATE },
		{ IDC_SAMPLERATE_LBL, IDS_SAMPLERATE },
		{ IDC_CHANNEL_LBL, IDS_CHANNELS },
		{ IDC_VIDEOCODEC_LBL, IDS_CODEC },
		{ IDC_VIDEOBITRATE_LBL, IDS_BITRATE },
		{ IDC_FPS_LBL, IDS_FPS },
		{ IDC_FILELENGTH_LBL, IDS_LENGTH }
	};

	EMULE_TRY

	if (GetSafeHwnd())
	{
		for (uint32 i = 0; i < ELEMENT_COUNT(aiResTbl); i++)
			SetDlgItemText(aiResTbl[i][0], GetResString(static_cast<UINT>(aiResTbl[i][1])));

		CString strBuffer;

		for (uint32 i = 0; i < ELEMENT_COUNT(aiResTbl2); i++)
		{
			strBuffer.Format("%s:", GetResString(static_cast<UINT>(aiResTbl2[i][1])));
			SetDlgItemText(aiResTbl2[i][0], strBuffer);
		}
	}

	EMULE_CATCH
}
