// FDSrcNames.cpp : implementation file
//

#include "stdafx.h"
#include "FDSrcNames.h"
#include "FileDetails.h"
#include "..\UpDownClient.h"
#include "..\TitleMenu.h"
#include "..\emule.h"

// CFDSrcNames dialog

IMPLEMENT_DYNCREATE(CFDSrcNames, CPropertyPage)

CFDSrcNames::CFDSrcNames() : CPropertyPage(CFDSrcNames::IDD)
{
	//{{AFX_DATA_INIT(CFDSrcNames)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pFile = NULL;
}

CFDSrcNames::~CFDSrcNames()
{
}

void CFDSrcNames::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDSrcNames)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_FDS_TAKEOVER, m_ctrlTakeOver);
	DDX_Control(pDX, IDC_CLEANUP, m_ctrlCleanUp);
	DDX_Control(pDX, IDC_RENAME, m_ctrlRename);
	DDX_Control(pDX, IDC_FILENAME, m_ctrlFilename);
}


BEGIN_MESSAGE_MAP(CFDSrcNames, CPropertyPage)
	//{{AFX_MSG_MAP(CFDSrcNames)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RENAME, OnBnClickedRename)
	ON_BN_CLICKED(IDC_CLEANUP, OnBnClickedCleanup)
	ON_BN_CLICKED(IDC_FDS_TAKEOVER, OnBnClickedFdsTakeover)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_SOURCENAMES, OnLvnColumnclick)
	ON_NOTIFY(NM_DBLCLK, IDC_SOURCENAMES, OnNMDblclkList)
	ON_NOTIFY(NM_RCLICK, IDC_SOURCENAMES, OnNMRclickList)
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CFDSrcNames message handlers
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::Update()
{
	EMULE_TRY

	if(m_pFile == NULL)
		return;

	if(!::IsWindow(GetSafeHwnd()))
		return;

	EnumPartFileStatuses	eFileStatus = m_pFile->GetStatus();
	bool	bEnable = ((eFileStatus == PS_COMPLETE) || (eFileStatus == PS_COMPLETING)) ? false : true;

	m_ctrlRename.EnableWindow(bEnable);
	m_ctrlCleanUp.EnableWindow(bEnable);
	m_ctrlTakeOver.EnableWindow(bEnable);

	FillSourcenameList();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::FillSourcenameList()
{
	EMULE_TRY

	CListCtrl	   *pmyListCtrl;
	LVFINDINFO		info;

	info.flags = LVFI_STRING;
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);

	if(pmyListCtrl->GetHeaderCtrl()->GetItemCount() < 2)
	{
		pmyListCtrl->DeleteColumn(0);
		pmyListCtrl->InsertColumn(0, GetResString(IDS_DL_FILENAME), LVCFMT_LEFT, 240, -1);
		pmyListCtrl->InsertColumn(1, GetResString(IDS_DL_SOURCES), LVCFMT_LEFT, 60, 1);
	}

	pmyListCtrl->DeleteAllItems();

	CUpDownClient	   *pClient;
	int					iItemPos, iNameCount;
	CString				strNameCount, strFileName;
	POSITION			pos;

	for (int sl = 0; sl < SOURCESSLOTS; sl++)
	{
		if (!m_pFile->m_srcLists[sl].IsEmpty())
		{
			for (pos = m_pFile->m_srcLists[sl].GetHeadPosition(); pos != NULL; )
			{
				pClient = m_pFile->m_srcLists[sl].GetNext(pos);

				if (pClient->m_pReqPartFile == m_pFile)
				{
					strFileName = pClient->GetClientFilename();
					if (strFileName.GetLength() != 0)
					{
						info.psz = strFileName;
						if ((iItemPos = pmyListCtrl->FindItem(&info, -1)) == -1)
						{
							pmyListCtrl->InsertItem(0, strFileName);
							pmyListCtrl->SetItemText(0, 1, _T("1"));
							pmyListCtrl->SetItemData(0, 1);
						}
						else
						{
							iNameCount = _tstoi(pmyListCtrl->GetItemText(iItemPos, 1));
							iNameCount ++;
							strNameCount.Format(_T("%i"), iNameCount);
							pmyListCtrl->SetItemText(iItemPos, 1, strNameCount.GetString());
							pmyListCtrl->SetItemData(iItemPos, iNameCount);
						}
						pmyListCtrl->SortItems(CompareListNameItems, 11);
						m_bSortAscending[0] =true;
						m_bSortAscending[1] =false;
					}
				}
			}
		}
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::OnBnClickedRename()
{
	EMULE_TRY

	CString strNewFileName;
	m_ctrlFilename.GetWindowText(strNewFileName);

	m_pFile->SetFileName(strNewFileName.GetBuffer());
	m_pFile->SavePartFile();

	CFileDetails* pParent = (CFileDetails*)GetParent();
	if(pParent != NULL)
	{
		pParent->UpdateData();
	}

	//update a grapical list
	m_pFile->UpdateDisplayedInfo(true);
	g_eMuleApp.m_pSharedFilesList->UpdateItem((CKnownFile*)m_pFile);
	g_eMuleApp.m_pdlgEmule->m_wndTransfer.UpdateInfoHeader();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::OnBnClickedCleanup()
{
	EMULE_TRY

	CString strFilename = "";

	int iStart = 0;
	int iEnd = 0;
	int iSize = 0;

	m_ctrlFilename.GetSel(iStart, iEnd);

	iSize = iEnd - iStart;

	if(m_ctrlFilename.GetWindowTextLength() != iSize)
		m_ctrlFilename.ReplaceSel(strFilename.GetBuffer());

	m_ctrlFilename.GetWindowText(strFilename);
	m_ctrlFilename.SetWindowText(CleanupFilename(strFilename));

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::OnBnClickedFdsTakeover()
{
	EMULE_TRY

	CListCtrl* pmyListCtrl;
	int itemPosition;

	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);

	if(pmyListCtrl->GetSelectedCount() > 0)
	{
		POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition();
		itemPosition = pmyListCtrl->GetNextSelectedItem(pos);
		SetDlgItemText(IDC_FILENAME, pmyListCtrl->GetItemText(itemPosition, 0));
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::OnLvnColumnclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	m_bSortAscending[pNMLV->iSubItem] = !m_bSortAscending[pNMLV->iSubItem];
	////SetSortArrow(pNMLV->iSubItem, m_bSortAscending[pNMLV->iSubItem]);

	CListCtrl* pmyListCtrl;
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);

	pmyListCtrl->SortItems(&CompareListNameItems, pNMLV->iSubItem + ((m_bSortAscending[pNMLV->iSubItem]) ? 0 : 10));

	*pResult = 0;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult)
{
	OnBnClickedFdsTakeover();
	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::OnNMRclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	CListCtrl *pmyListCtrl = reinterpret_cast<CListCtrl*>(GetDlgItem(IDC_SOURCENAMES));
	POINT point;
	CTitleMenu	popupMenu;

	::GetCursorPos(&point);

	popupMenu.CreatePopupMenu();
	popupMenu.AppendMenu( MF_STRING |
		((pmyListCtrl->GetSelectionMark() == -1) ? MF_GRAYED : 0),
		MP_MESSAGE, GetResString(IDS_TAKEOVER) );
	popupMenu.AppendMenu(MF_STRING, MP_RESTORE, GetResString(IDS_SV_UPDATE));
	popupMenu.TrackPopupMenuEx(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this, NULL);

//	Local Menu objects are destroyed in their destructor

	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CFDSrcNames::OnCommand(WPARAM wParam,LPARAM lParam )
{
	CListCtrl* pmyListCtrl;
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);

	if(pmyListCtrl->GetSelectionMark() != -1)
	{
		switch (wParam)
		{
			case MP_MESSAGE:
			{
				OnBnClickedFdsTakeover();
				return true;
			}
			case MP_RESTORE:
			{
				FillSourcenameList();
				return true;
			}
		}
	}

	if(wParam == 2)
	{
		CPropertyPage::OnOK();
		return TRUE;
	}

	return CPropertyPage::OnCommand(wParam, lParam);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CALLBACK CFDSrcNames::CompareListNameItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	switch(lParamSort)
	{
		case 1:
			return (lParam1 - lParam2);
			break;

		case 11:
			return (lParam2 - lParam1);
			break;

		default:
			return 0;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CFDSrcNames::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	Update();

	m_ctrlFilename.SetWindowText(m_pFile->GetFileName());

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::Localize()
{
	static const int aiResTbl[][2] =
	{
		{ IDC_FDS_TAKEOVER, IDS_TAKEOVER },
		{ IDC_CLEANUP, IDS_CLEANUP },
		{ IDC_RENAME, IDS_RENAME }
	};

	if (GetSafeHwnd())
	{
		for (uint32 i = 0; i < ELEMENT_COUNT(aiResTbl); i++)
			SetDlgItemText(aiResTbl[i][0], GetResString(static_cast<UINT>(aiResTbl[i][1])));
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFDSrcNames::OnOK()
{
	OnBnClickedRename();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////