// EmClient.cpp
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "OpCode.h"
#include "TaskProcessorSockets.h"
#include "../EmEngine.h"
#include "../../OtherFunctions.h"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CEmClient::~CEmClient()
{
	if (closesocket(m_hSocket))
		AddDebugLogLine(false, "closesocket failed");
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
T_CLIENT_TYPE CEmClient_Peer::GetType() const
{
	return T_CLIENT_PEER;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
T_CLIENT_TYPE CEmClient_Server::GetType() const
{
	return T_CLIENT_SERVER;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
T_CLIENT_TYPE CEmClient_Web::GetType() const
{
	return T_CLIENT_WEB;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmClient::OnConnected(CEmEngine &rEngine)
{
	if (m_pOnCompletionTask != NULL)
	{
		m_pOnCompletionTask->m_iMessage = FD_CONNECT;
		rEngine.PushToSocketsTP(m_pOnCompletionTask);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmClient::OnAccepted(CEmEngine &rEngine)
{
	if (m_pOnCompletionTask != NULL)
	{
		m_pOnCompletionTask->m_iMessage = FD_ACCEPT;
		rEngine.PushToSocketsTP(m_pOnCompletionTask);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmClient::OnDisconnected(CEmEngine &rEngine)
{
	if (m_pOnCompletionTask != NULL)
	{
		m_pOnCompletionTask->m_iMessage = FD_CLOSE;
		rEngine.PushToSocketsTP(m_pOnCompletionTask);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// in the future - move webserver to this engine
//void CEmClient_Web::OnConnected(CEmEngine& stEngine)
//{
//	// say something...
//	char szSend[] = "GET / HTTP 1.1\r\n\r\n";
//	stEngine.m_stTcp.AllocSend(m_hSocket, szSend, sizeof(szSend) - 1);
//}
