//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


/******************************************************************
 *                      Based on eMule Morph                      *
 ******************************************************************/


#include "StdAfx.h"
#include "fakecheck.h"
#include "emule.h"
#include "otherfunctions.h"
#include "HttpDownloadDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////////////////////
CFakecheck::CFakecheck()
{
	m_sLastHit = _T("");
	LoadFromDatFile();
}

/////////////////////////////////////////////////////////////////////////////////////////////
CFakecheck::~CFakecheck()
{
	RemoveAllFakes();
}

/////////////////////////////////////////////////////////////////////////////////////////////
void CFakecheck::AddFake(CString Hash, uint32 Lenght, CString Realtitle)
{
	FakeMap::iterator it = m_mapFakes.find(Hash);

	if (it == m_mapFakes.end())
	{
		Fakes_Struct* newFilter = new Fakes_Struct();

		newFilter->Hash = Hash;
		newFilter->Lenght = Lenght;
		newFilter->RealTitle = Realtitle;
		m_mapFakes[Hash] = newFilter;
	}
	else
	{
//		g_eMuleApp.AddDebugLogLine(false, _T("%s: Duplicate hash %s (%s). Not adding."),__FUNCTION__,Hash,Realtitle);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////
INT CFakecheck::LoadFromDatFile()
{
	CString sbuffer, sbuffer2, sbuffer3, sbuffer4;
	int pos, fakecounter;
	CString Hash, Title;
	uint32 Lenght;
	char buffer[1024];
	int lenBuf = 1024;
	fakecounter = 0;
	RemoveAllFakes();
	FILE* readFile = fopen(CString(g_eMuleApp.m_pGlobPrefs->GetConfigDir()) + "fakes.dat", "r");
	if (readFile != NULL)
	{
		while (!feof(readFile))
		{
			if (fgets(buffer, lenBuf, readFile) == 0)
				break;
			sbuffer = buffer;
			if (sbuffer.GetAt(0) == '#' || sbuffer.GetAt(0) == '/' || sbuffer.GetLength() < 5)
				continue;
			pos = sbuffer.Find(',');
			if (pos == -1)
				continue;
			Hash = sbuffer.Left(pos).Trim();
			Hash.MakeUpper();
			int pos2 = sbuffer.Find(',', pos + 1);
			if (pos2 == -1)
				continue;
			sbuffer2 = sbuffer.Mid(pos + 1, pos2 - pos - 1).Trim();
			Lenght = _tstoi(sbuffer2);
			sbuffer2 = sbuffer.Mid(pos2 + 1, sbuffer.GetLength() - pos2 - 2);
			Title = sbuffer2;
			AddFake(Hash, Lenght, Title);
			fakecounter++;
		}
		fclose(readFile);
		return fakecounter;
	}
	else
	{
		return 0;
	}

}

/////////////////////////////////////////////////////////////////////////////////////////////
void CFakecheck::RemoveAllFakes()
{
	Fakes_Struct* search;

	map<CString, Fakes_Struct*>::const_iterator it;
	for (it = m_mapFakes.begin(); it != m_mapFakes.end(); ++it)
	{
		search = (*it).second;
		delete search;
	}

	m_mapFakes.clear();
}

/////////////////////////////////////////////////////////////////////////////////////////////
CString CFakecheck::GetFakeCheckComment(CString Hash2test, uint32 length)
{
	if (m_mapFakes.size() != 0)
	{
		Fakes_Struct* search;
		FakeMap::const_iterator it = m_mapFakes.upper_bound(Hash2test);
		it--;

		do
		{
			search = (*it).second;

			if ((search->Hash == Hash2test) && (search->Lenght == length))
			{
				m_sLastHit = search->RealTitle;
				return m_sLastHit;
			}

			it--;
		}
		while (it != m_mapFakes.begin());
	}

	return CString(_T(""));
}

/////////////////////////////////////////////////////////////////////////////////////////////
BOOL CFakecheck::DownloadFakeList()
{
//
//	Links to the unrar.dll file (http://www.rarlab.com/rar/UnRARDLL.exe)
	HINSTANCE hUnRARDLL = LoadLibrary(_T("unrar.dll"));

	if (hUnRARDLL != NULL)
	{
		(FARPROC&)pfnRAROpenArchiveEx	= GetProcAddress(hUnRARDLL, _T("RAROpenArchiveEx"));
		(FARPROC&)pfnRARCloseArchive	= GetProcAddress(hUnRARDLL, _T("RARCloseArchive"));
		(FARPROC&)pfnRARReadHeader		= GetProcAddress(hUnRARDLL, _T("RARReadHeader"));
		(FARPROC&)pfnRARProcessFile		= GetProcAddress(hUnRARDLL, _T("RARProcessFile"));
	}

	bool bCanUseRarSupport = !( (hUnRARDLL == NULL) ||
		                        (pfnRAROpenArchiveEx == NULL) || (pfnRARCloseArchive == NULL) ||
								(pfnRARReadHeader    == NULL) || (pfnRARProcessFile  == NULL) );

//
//	Some strings
	CString strBaseURL		= RemoveFileExtension(g_eMuleApp.m_pGlobPrefs->GetFakeListURL());
	CString strTxtFilePath	= g_eMuleApp.m_pGlobPrefs->GetAppDir()    + CString(_T("fakes.txt"));
	CString strRarFilePath	= g_eMuleApp.m_pGlobPrefs->GetAppDir()    + CString(_T("fakes.rar"));
	CString strDatFilePath	= g_eMuleApp.m_pGlobPrefs->GetConfigDir() + CString(_T("fakes.dat"));

//
//	Downloads the fakes.txt file
	CHttpDownloadDlg dlgDownload;
	
	dlgDownload.m_sURLToDownload		= strBaseURL + CString(_T(".txt"));
	dlgDownload.m_sFileToDownloadInto	= strTxtFilePath;

	if (dlgDownload.DoModal() != IDOK)
	{
		g_eMuleApp.AddLogLine(true, RGB_LOG_WARNING + GetResString(IDS_FAKE_CHECKUPERROR));

		return FALSE;
	}

//
//	Reads the fakes.txt file to get the latest version
	FILE* pFile;
	if ((pFile = fopen(strTxtFilePath, _T("r"))) == NULL)
	{
		g_eMuleApp.AddLogLine(true, RGB_LOG_WARNING + GetResString(IDS_FAKE_CHECKUPERROR));

		return FALSE;
	}

	char* strVersion = new char[5];
	_fgetts(strVersion, sizeof(strVersion), pFile);
	fclose(pFile);
	_tremove(strTxtFilePath);
	uint32 dwVersion = _tstoi(strVersion);
	delete [] strVersion;

//
//	If there is a new version, then we download the .rar file
	if (g_eMuleApp.m_pGlobPrefs->GetFakesDatVersion() < dwVersion)
	{
	//
	//	Creates a backup of the fake list, to restore it if an error occurs
		_tremove(strDatFilePath + _T(".bak"));
		_trename(strDatFilePath, strDatFilePath + _T(".bak"));

		if (bCanUseRarSupport)
		{
			g_eMuleApp.AddDebugLogLine(false, _T("RAR file support enabled (unrar.dll successfully loaded)"));

		//	Remove the fakes.rar file if it already exists on disk, before downloading the last version
			_tremove(strRarFilePath);

		//
		//	Tries to download the fakes.rar file
			dlgDownload.m_sURLToDownload		= strBaseURL + _T(".rar");
			dlgDownload.m_sFileToDownloadInto	= strRarFilePath;

			if (dlgDownload.DoModal() == IDOK)
			{
			//
			//	If the RAR file could be download, then we extract it
				bool bExtractSuccess = ExtractArchive(strRarFilePath, g_eMuleApp.m_pGlobPrefs->GetConfigDir());

				_tremove(strRarFilePath);

				if (!bExtractSuccess)
				{
				//
				//	The .rar file could not be extracted
					g_eMuleApp.AddLogLine(true, RGB_LOG_WARNING + GetResString(IDS_FAKE_CHECKUPERROR));
					_tremove(strDatFilePath);
					_trename(strDatFilePath + _T(".bak"), strDatFilePath);

					return FALSE;
				}

			//
			//	If the RAR file could be extracted, then we set the new version of the fake list
				g_eMuleApp.AddLogLine(true, RGB_LOG_SUCCESS + GetResString(IDS_FAKE_SUCCESS_UPDATE), g_eMuleApp.m_pGlobPrefs->GetFakesDatVersion(), dwVersion);
				g_eMuleApp.m_pGlobPrefs->SetFakesDatVersion(dwVersion);
				_tremove(strDatFilePath + _T(".bak"));

				return (LoadFromDatFile() > 0);
			}
		}

	//
	//	If we are here, it means we can't use RAR support (unrar.dll not found, etc.) or the RAR file
	//	could not be extracted or downloaded.
		else
		{
			g_eMuleApp.AddDebugLogLine(false, _T("RAR file support disabled (unrar.dll not found or failed to load)"));
		}

	//
	//	If the .rar file could not be download, we try to download the fakes.dat file
		dlgDownload.m_sURLToDownload		= strBaseURL + _T(".dat");
		dlgDownload.m_sFileToDownloadInto	= strDatFilePath;

		if (dlgDownload.DoModal() != IDOK)
		{
		//
		//	The .dat file could not be downloaded
			g_eMuleApp.AddLogLine(true, RGB_LOG_WARNING + GetResString(IDS_FAKE_CHECKUPERROR));
			_tremove(strDatFilePath);
			_trename(strDatFilePath + _T(".bak"), strDatFilePath);

			return FALSE;
		}

	//
	//	Sets the new version of the fake list
		g_eMuleApp.AddLogLine(true, RGB_LOG_SUCCESS + GetResString(IDS_FAKE_SUCCESS_UPDATE), g_eMuleApp.m_pGlobPrefs->GetFakesDatVersion(), dwVersion);
		g_eMuleApp.m_pGlobPrefs->SetFakesDatVersion(dwVersion);
		_tremove(strDatFilePath + _T(".bak"));
	}
	else
	{
		g_eMuleApp.AddLogLine(true, GetResString(IDS_FAKE_GOT_LATEST_VERSION), g_eMuleApp.m_pGlobPrefs->GetFakesDatVersion());
	}

//
//	Frees the DLL file
	if (hUnRARDLL != NULL)
	{
		FreeLibrary(hUnRARDLL);
	}

	return (LoadFromDatFile() > 0);
}


/////////////////////////////////////////////////////////////////////////////////////////////
BOOL CFakecheck::ExtractArchive(CString strArchiveName, CString strDestFolder)
{
	ASSERT(pfnRAROpenArchiveEx != NULL);
	ASSERT(pfnRARCloseArchive != NULL);
	ASSERT(pfnRARReadHeader != NULL);
	ASSERT(pfnRARProcessFile != NULL);

	struct RAROpenArchiveDataEx OpenArchiveData;

	memset2(&OpenArchiveData, 0, sizeof(OpenArchiveData));
	OpenArchiveData.ArcName		= strArchiveName.GetBuffer();
	OpenArchiveData.CmtBuf		= NULL;
	OpenArchiveData.OpenMode	= RAR_OM_EXTRACT;
	
	HANDLE hArcData = pfnRAROpenArchiveEx(&OpenArchiveData);

	if (OpenArchiveData.OpenResult != 0)
	{
		OutOpenArchiveError(OpenArchiveData.OpenResult, strArchiveName);
		return FALSE;
	}

	struct RARHeaderData HeaderData;
	HeaderData.CmtBuf = NULL;

	int iReadHeaderCode;
	while ((iReadHeaderCode = pfnRARReadHeader(hArcData, &HeaderData)) == 0)
	{
	//	The following line is important to support characters such as '', '', '',
	//	', '', '', ... to decompress fakes.dat in the correct directory.
		strDestFolder.AnsiToOem();

		int iProcessFileCode = pfnRARProcessFile(hArcData, RAR_EXTRACT, strDestFolder.GetBuffer(), NULL);
		
		if (iProcessFileCode != 0)
		{
			OutProcessFileError(iProcessFileCode);
			break;
		}
	}

	pfnRARCloseArchive(hArcData);

	if (iReadHeaderCode == ERAR_BAD_DATA)
	{
		return FALSE;
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////////////////////
void CFakecheck::OutOpenArchiveError(int iError, CString strArchiveName)
{
	switch(iError)
	{
		case ERAR_NO_MEMORY:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("Not enough memory to extract %s"), strArchiveName);
			break;
		}
		case ERAR_EOPEN:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("Cannot open %s"), strArchiveName);
			break;
		}
		case ERAR_BAD_ARCHIVE:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("%s is not RAR archive"), strArchiveName);
			break;
		}
		case ERAR_BAD_DATA:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("%s: archive header broken"), strArchiveName);
			break;
		}
		case ERAR_UNKNOWN:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("Unknown error when extracting %s"), strArchiveName);
			break;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////
void CFakecheck::OutProcessFileError(int iError)
{
	switch(iError)
	{
		case ERAR_UNKNOWN_FORMAT:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("fakes.rar: Unknown archive format"));
			break;
		}
		case ERAR_BAD_ARCHIVE:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("fakes.rar: Bad volume"));
			break;
		}
		case ERAR_ECREATE:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("fakes.rar: File create error"));
			break;
		}
		case ERAR_EOPEN:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("fakes.rar: Volume open error"));
			break;
		}
		case ERAR_ECLOSE:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("fakes.rar: File close error"));
			break;
		}
		case ERAR_EREAD:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("fakes.rar: Read error"));
			break;
		}
		case ERAR_EWRITE:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("fakes.rar: Write error"));
			break;
		}
		case ERAR_BAD_DATA:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("fakes.rar: CRC error"));
			break;
		}
		case ERAR_UNKNOWN:
		{
			g_eMuleApp.AddDebugLogLine(FALSE, _T("fakes.rar: Unknown error"));
			break;
		}
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
