//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "types.h"
#ifdef OLD_SOCKETS_ENABLED
#include "ListenSocket.h"
#endif //OLD_SOCKETS_ENABLED
#include <map>
#include <hash_map>

using namespace std;
#ifndef VS2002
	using namespace stdext;
#endif

struct IPRange_Struct{
   uint32           IPstart;
   uint32           IPend;
   byte				filter;
   CString			description;
   ~IPRange_Struct() {  }
};

class CIPFilter
{
public:
	CIPFilter();
	~CIPFilter();
	bool	AddBannedIPRange(uint32 IPfrom,uint32 IPto,byte filter, CString desc);
	void AddTemporaryBannedIP(uint32 IP) 		{ iplist_temporary[IP] = ::GetTickCount();}
	void	RemoveAllIPs();
	void RemoveOldIPs();
	
	int		LoadFromFile();
	void	SaveToFile();
	
	bool	IsFiltered(uint32 IP2test);
	bool	IsFiltered(uint32 IP2test,int level);
	bool IsTemporaryFiltered(uint32 IP2test);
	
	CString GetLastHit()				{ return lasthit;}
	uint16	BanCount()					{ return iplist.size(); }
private:
	CString lasthit;
	//CMutex m_Mutex;
	map<uint32,IPRange_Struct*> 	iplist;
	hash_map<uint32,uint32>			iplist_temporary;

	uint32	m_dwTicksToBan;
	int		m_iFilterLevel;
};
