// MuleToolBarCtrl.cpp : implementation file
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MuleToolbarCtrl.h"
#include "emule.h"
#include "EnBitmap.h"
#include "otherfunctions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#if (_WIN32_IE < 0x0500)
#define TBN_INITCUSTOMIZE       (TBN_FIRST - 23)
#define    TBNRF_HIDEHELP       0x00000001
#endif

BEGIN_MESSAGE_MAP(CMuleToolbarCtrl, CToolBarCtrl)
	ON_WM_SIZE()
	ON_NOTIFY_REFLECT(NM_RCLICK, OnNMRclick)
	ON_NOTIFY_REFLECT(TBN_QUERYDELETE, OnTbnQueryDelete)
	ON_NOTIFY_REFLECT(TBN_QUERYINSERT, OnTbnQueryInsert)
	ON_NOTIFY_REFLECT(TBN_GETBUTTONINFO, OnTbnGetButtonInfo)
	ON_NOTIFY_REFLECT(TBN_TOOLBARCHANGE, OnTbnToolbarChange)
	ON_NOTIFY_REFLECT(TBN_RESET, OnTbnReset)
	ON_NOTIFY_REFLECT(TBN_INITCUSTOMIZE, OnTbnInitCustomize)
END_MESSAGE_MAP()

IMPLEMENT_DYNAMIC(CMuleToolbarCtrl, CToolBarCtrl)

// CMuleToolbarCtrl

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CMuleToolbarCtrl::CMuleToolbarCtrl()
{
	m_bUseSpeedMeter = false;
	m_iLastPressedButton = -1;

	m_iToolbarLabelSettings = 4;

	m_oldcx = 0;
	m_oldcy = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CMuleToolbarCtrl::~CMuleToolbarCtrl()
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::Init(void)
{
	ModifyStyle(0, TBSTYLE_FLAT | CCS_ADJUSTABLE | CCS_NODIVIDER | ((g_eMuleApp.m_qwComCtrlVer >= MAKEDLLVERULL(6,0,0,0)) ? TBSTYLE_TRANSPARENT : 0));
	ChangeToolbarBitmap(g_eMuleApp.m_pGlobPrefs->GetToolbarBitmapSettings(), false);

//	Add button-text
	static const UINT s_adwResIdTbl[] = {
		IDS_MAIN_BTN_CONNECT, IDS_EM_SERVER, IDS_EM_TRANS, IDS_EM_SEARCH,
		IDS_EM_FILES, IDS_EM_MESSAGES, IDS_IRC, IDS_EM_STATISTIC, IDS_EM_PREFS
	};
	CString		strBarText;

	for (unsigned ui = 0; ui < ELEMENT_COUNT(s_adwResIdTbl); ui++)
	{
		strBarText += GetResString(s_adwResIdTbl[ui]);
		strBarText += _T('\0');
	}
	AddStrings(strBarText);

//	Add buttons
	for (int i = 0; i < MTB_NUMBUTTONS; i++)
	{
		m_buttonDefs[i].fsState	= TBSTATE_ENABLED;
		m_buttonDefs[i].fsStyle	= TBSTYLE_CHECK;	// TBSTYLE_CHECKGROUP;
		m_buttonDefs[i].iBitmap	= i;
		m_buttonDefs[i].idCommand = IDC_TOOLBARBUTTON + i;
		m_buttonDefs[i].iString	= i;

		switch (i)
		{
			case MTB_CONNECT: // Connect button
			case MTB_PREFS:
				m_buttonDefs[i].fsStyle = TBSTYLE_BUTTON;
				break;
			case MTB_SERVERS:
				m_buttonDefs[i].fsState |= TBSTATE_CHECKED;
		}
	}
	m_iLastPressedButton = IDC_TOOLBARBUTTON + MTB_SERVERS;

	TBBUTTON	sepButton;

	sepButton.idCommand = 0;
	sepButton.fsStyle = TBSTYLE_SEP;
	sepButton.fsState = TBSTATE_ENABLED;
	sepButton.iString = -1;
	sepButton.iBitmap = -1;

	CString		config = g_eMuleApp.m_pGlobPrefs->GetToolbarSettings();

	for (i = 0; i < config.GetLength(); i += 2)
	{
		int			iIndex = _tstoi(config.Mid(i,2));
		TBBUTTON	*pButton;

		if (iIndex == 99)
			pButton = &sepButton;
		else if (iIndex >= ARRSIZE(m_buttonDefs))
		//	Unknown button index, skip it
			continue;
		else
			pButton = &m_buttonDefs[iIndex];
		AddButtons(1, pButton);
	}

//	Recalc toolbar-size:
	Localize();		// at first we have to localize the button-text!!!
	//m_iToolbarLabelSettings = 4; // eklmn: move into constructor
	ChangeTextLabelStyle(g_eMuleApp.m_pGlobPrefs->GetToolbarLabelSettings(), false);
	SetBtnWidth();		// then calc and set the button width
	AutoSize();		// and finally call the original (but maybe obsolete) function

//	Add speed-meter to upper-right corner
	CRect		rClient;

	GetClientRect(&rClient);
	rClient.DeflateRect(7,7);

	rClient.left = rClient.right - rClient.Height() * 2;
	if (m_bUseSpeedMeter)
		m_ctrlSpeedMeter.CreateEx(WS_EX_STATICEDGE, NULL, NULL, WS_CHILD | WS_VISIBLE, rClient, this, 123);
	else
		m_ctrlSpeedMeter.CreateEx(WS_EX_STATICEDGE, NULL, NULL, WS_CHILD, rClient, this, 123);
	m_ctrlSpeedMeter.SetRange(0,100);

//	Resize speed-meter
	CRect		r;

	GetWindowRect(&r);
	OnSize(0,r.Width(),r.Height());
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::Localize(void)
{
	if(m_hWnd)
	{
		static const int	TBStringIDs[] = {IDS_EM_SERVER,IDS_EM_TRANS,IDS_EM_SEARCH,IDS_EM_FILES,IDS_EM_MESSAGES,IDS_IRC,IDS_EM_STATISTIC,IDS_EM_PREFS};
		TBBUTTONINFO		tbi;

		tbi.dwMask = TBIF_TEXT;
		tbi.cbSize = sizeof (TBBUTTONINFO);

		CString			buffer;

#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsConnected())
			buffer = GetResString(IDS_MAIN_BTN_DISCONNECT);
		else if(g_eMuleApp.m_pServerConnect->IsConnecting())
			buffer = GetResString(IDS_MAIN_BTN_CANCEL);
		else
#endif //OLD_SOCKETS_ENABLED
			buffer = GetResString(IDS_MAIN_BTN_CONNECT);
		buffer.Remove('&');
		_stprintf(m_tstrButtonTitles[0], _T("%s"), buffer);
		tbi.pszText = m_tstrButtonTitles[0];
		SetButtonInfo(IDC_TOOLBARBUTTON+MTB_CONNECT, &tbi);
		for (int i = 1; i < 9; i++)
		{
			buffer = GetResString(TBStringIDs[i-1]); // EC
			buffer.Remove('&');
			_stprintf(m_tstrButtonTitles[i], _T("%s"), buffer);
			tbi.pszText = m_tstrButtonTitles[i];
			SetButtonInfo(IDC_TOOLBARBUTTON + i, &tbi);
		}

		m_iToolbarLabelSettings = 4;
		ChangeTextLabelStyle(g_eMuleApp.m_pGlobPrefs->GetToolbarLabelSettings(), false);

		SetBtnWidth();
		AutoSize();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::OnSize(UINT nType, int cx, int cy)
{
	CToolBarCtrl::OnSize(nType, cx, cy);

	if ((!cx && !cy) || (cx==m_oldcx && cy==m_oldcy)) return;

	m_oldcx=cx; m_oldcy=cy;

	if (m_ctrlSpeedMeter.m_hWnd && m_bUseSpeedMeter)
	{
		CRect		rClient;

		GetClientRect(&rClient);
		rClient.DeflateRect(7,7);

		int		iHeight = rClient.Height();
		int		iLeft  = rClient.right - iHeight;

		CSize	csMaxSize;

		GetMaxSize(&csMaxSize);
		if (rClient.left + csMaxSize.cx + 7 > iLeft)
		{
			m_ctrlSpeedMeter.ShowWindow(SW_HIDE);
			return;
		}

		iLeft -= iHeight;
		if (iLeft <= rClient.left + csMaxSize.cx + 7)
			iLeft = rClient.left + csMaxSize.cx + 7;
		rClient.left = iLeft;

		m_ctrlSpeedMeter.SetWindowPos( NULL, rClient.left, rClient.top,
									   rClient.Width(), rClient.Height(),
									   SWP_NOZORDER | SWP_SHOWWINDOW );
	}

	SetBtnWidth();
	AutoSize();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::ShowSpeedMeter(bool bShow)
{
	m_bUseSpeedMeter = bShow;

	if (bShow)
	{
		if (!m_ctrlSpeedMeter.IsWindowVisible())
		{
			m_ctrlSpeedMeter.EnableWindow(true);

		//	Resize speed-meter
			CRect		r;

			GetWindowRect(&r);
			OnSize(0,r.Width(),r.Height());
		}
	}
	else
	{
		m_ctrlSpeedMeter.EnableWindow(false);
		m_ctrlSpeedMeter.ShowWindow(SW_HIDE);

		CRect		rInvalidate;

		m_ctrlSpeedMeter.GetWindowRect(&rInvalidate);
		ScreenToClient(rInvalidate);
		InvalidateRect(rInvalidate);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::SetBtnWidth()
{
	if (m_iToolbarLabelSettings == 1)
	{
		CDC		*pDC = GetDC();
		CFont	*pFnt = GetFont();
		CFont	*pOldFnt = pDC->SelectObject(pFnt);
		CRect	r(0,0,0,0);

	//	Calculate the max. possible button-size
		int		iCalcSize = 0;

		for (int i = 0; i < MTB_NUMBUTTONS; i++)
			if (!IsButtonHidden(IDC_TOOLBARBUTTON+i))
			{
				pDC->DrawText(m_tstrButtonTitles[i], -1, r, DT_SINGLELINE | DT_CALCRECT);
 				if (r.Width() > iCalcSize)
					iCalcSize = r.Width();
			}

		iCalcSize += 10;

		pDC->SelectObject(pOldFnt);
		ReleaseDC(pDC); // FoRcHa

		GetClientRect(&r);

		int		iMaxPossible = r.Width() / MTB_NUMBUTTONS;

	//	If the buttons are to big, reduze their size
		if (iCalcSize > iMaxPossible)
			iCalcSize = iMaxPossible;

		SetButtonWidth(iCalcSize, iCalcSize);
	}
	else if(m_iToolbarLabelSettings == 2)
	{
		CRect rcItem;
		GetItemRect(0, &rcItem); // includes the width of the text
		SetButtonSize(CSize(rcItem.Width(), 0));
		SetButtonWidth(0,0);
	}
	else
	{
		SetButtonSize(CSize(0,0));
		SetButtonWidth(0,0);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::OnNMRclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	POINT		point;
	CMenu		menuToolbar, menuBitmaps, menuTextLabels;

	GetCursorPos(&point);

	menuToolbar.CreatePopupMenu();

	menuBitmaps.CreateMenu();
	menuBitmaps.AppendMenu(MF_STRING,MP_SELECTTOOLBARBITMAP, GetResString(IDS_SELECTTOOLBARBITMAP));
	menuBitmaps.AppendMenu(MF_STRING,MP_SELECTTOOLBARBITMAPDIR, GetResString(IDS_SELECTTOOLBARBITMAPDIR));
	menuBitmaps.AppendMenu(MF_SEPARATOR);
	m_strBitmapPaths.RemoveAll();

	CString		strCurrBitmapSettings = g_eMuleApp.m_pGlobPrefs->GetToolbarBitmapSettings();
	bool		bChecked = false;
	UINT		dwFlags = MF_STRING;

	if (strCurrBitmapSettings == "")
	{
		dwFlags |= (MF_CHECKED | MF_DISABLED);
		bChecked = true;
	}
	menuBitmaps.AppendMenu(dwFlags, MP_TOOLBARBITMAP, GetResString(IDS_DEFAULT));
	m_strBitmapPaths.Add(_T(""));

	int		i = 1;

	if (g_eMuleApp.m_pGlobPrefs->GetToolbarBitmapFolderSettings() != "")
	{
		WIN32_FIND_DATA	FileData;
		HANDLE			hSearch;
		CString			strBitmapFileName;
		CString			strConfigDir = g_eMuleApp.m_pGlobPrefs->GetToolbarBitmapFolderSettings();

		strConfigDir += _T("\\");
		hSearch = ::FindFirstFile(strConfigDir + CString("*.eMuleToolbar.bmp"), &FileData);
		if (hSearch != INVALID_HANDLE_VALUE)
		{
			do
			{
				strBitmapFileName = FileData.cFileName;
				m_strBitmapPaths.Add(strConfigDir + strBitmapFileName);

				dwFlags = MF_STRING;
				if (!bChecked && strCurrBitmapSettings == m_strBitmapPaths[i])
				{
					dwFlags |= (MF_CHECKED | MF_DISABLED);
					bChecked = true;
				}
				menuBitmaps.AppendMenu(dwFlags, MP_TOOLBARBITMAP + i, strBitmapFileName.Left(strBitmapFileName.GetLength() - 17));
			} while ((++i < 50) && ::FindNextFile(hSearch, &FileData));

			::FindClose(hSearch);
		}
	}
	if (!bChecked)
	{
		menuBitmaps.AppendMenu(MF_STRING | MF_CHECKED | MF_DISABLED, MP_TOOLBARBITMAP + i, strCurrBitmapSettings);
		m_strBitmapPaths.Add(strCurrBitmapSettings);
	}
	menuToolbar.AppendMenu(MF_STRING|MF_POPUP, (UINT_PTR)menuBitmaps.m_hMenu, GetResString(IDS_TOOLBARSKINS));

	menuTextLabels.CreateMenu();
	menuTextLabels.AppendMenu(MF_STRING, MP_NOTEXTLABELS, GetResString(IDS_NOTEXTLABELS));
	menuTextLabels.AppendMenu(MF_STRING, MP_TEXTLABELS, GetResString(IDS_ENABLETEXTLABELS));
	menuTextLabels.AppendMenu(MF_STRING, MP_TEXTLABELSONRIGHT, GetResString(IDS_TEXTLABELSONRIGHT));

	UINT		dwPos = static_cast<UINT>(g_eMuleApp.m_pGlobPrefs->GetToolbarLabelSettings());

	menuTextLabels.CheckMenuItem(dwPos, MF_BYPOSITION | MF_CHECKED);
	menuTextLabels.EnableMenuItem(dwPos, MF_BYPOSITION | MF_DISABLED);
	menuToolbar.AppendMenu(MF_STRING|MF_POPUP, (UINT_PTR)menuTextLabels.m_hMenu, GetResString(IDS_TEXTLABELS));
	menuToolbar.AppendMenu(MF_STRING, MP_CUSTOMIZETOOLBAR, GetResString(IDS_CUSTOMIZETOOLBAR));
	menuToolbar.TrackPopupMenuEx(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this, NULL);

	*pResult = TRUE;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::OnTbnQueryDelete(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::OnTbnQueryInsert(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::OnTbnGetButtonInfo(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTOOLBAR		pNMTB = reinterpret_cast<LPNMTOOLBAR>(pNMHDR);

	if (pNMTB->iItem > 8)
	{
		*pResult = FALSE;
	}
	else
	{
		pNMTB->pszText = m_tstrButtonTitles[pNMTB->iItem];
		pNMTB->tbButton = m_buttonDefs[pNMTB->iItem];
		*pResult = TRUE;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::OnTbnToolbarChange(NMHDR *pNMHDR, LRESULT *pResult)
{
	TBBUTTON		buttoninfo;
	CString			config;

	for (int i = 0; i < GetButtonCount(); i++)
	{
		if (GetButton(i, &buttoninfo))
		{
			switch (buttoninfo.idCommand)
			{
				case 0:
					config += _T("99");
					break;
				default:
					config.AppendFormat(_T("%02u"), buttoninfo.idCommand - IDC_TOOLBARBUTTON);
					break;
			}
		}
	}
	g_eMuleApp.m_pGlobPrefs->SetToolbarSettings(config);
	Localize();
#ifdef OLD_SOCKETS_ENABLED
	g_eMuleApp.m_pdlgEmule->ShowConnectionState(g_eMuleApp.m_pServerConnect->IsConnected(),_T(""),true);
#endif //OLD_SOCKETS_ENABLED
	SetBtnWidth();
	AutoSize();
	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::ChangeToolbarBitmap(CString path, bool refresh)
{
	CImageList		imageList;
	CEnBitmap		Bitmap;

//	Free previous image list resources
	HIMAGELIST hImgLst = reinterpret_cast<HIMAGELIST>(::SendMessage(m_hWnd, TB_GETIMAGELIST, 0, 0));

	if (hImgLst)
		ImageList_Destroy(hImgLst);

	if (path != _T("") && Bitmap.LoadImage(path))
	{
	}
	else
	{
		Bitmap.LoadBitmap(IDB_TOOLBAR);
	}
	BITMAP		bm;

	Bitmap.GetBitmap(&bm);
	imageList.Create(bm.bmWidth/11, bm.bmHeight, ILC_COLOR32 | ILC_MASK, 11, 1);
	imageList.Add(&Bitmap, RGB(255,0,255));
	SetImageList(&imageList);
//	DonGato: force redraw of toolbar because if we don't the first time we change it
//		isn't refreshed at all. Don't know why... it might be a bug of CToolBarCtrl
	Invalidate(true);
	RedrawWindow();
//
	imageList.Detach();
	if (refresh)
		Refresh();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CMuleToolbarCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	switch (wParam)
	{
		case MP_SELECTTOOLBARBITMAPDIR:
			g_eMuleApp.m_pGlobPrefs->SetToolbarBitmapFolderSettings(BrowseFolder(m_hWnd,GetResString(IDS_SELECT_TOOLBARBITMAPDIR),g_eMuleApp.m_pGlobPrefs->GetToolbarBitmapFolderSettings()));
			break;

		case MP_CUSTOMIZETOOLBAR:
			Customize();
			break;

		case MP_SELECTTOOLBARBITMAP:
		{
			CFileDialog dialog(TRUE, _T("eMuleToolbar.bmp"), NULL, NULL, _T("*.eMuleToolbar.bmp|*.eMuleToolbar.bmp||"));
			if (IDOK == dialog.DoModal())
			{
				if(g_eMuleApp.m_pGlobPrefs->GetToolbarBitmapSettings()!=dialog.GetPathName())
				{
					g_eMuleApp.m_pGlobPrefs->SetToolbarBitmapSettings(dialog.GetPathName());
					ChangeToolbarBitmap(dialog.GetPathName(), true);
				}
			}
			break;
		}

		case MP_NOTEXTLABELS:
			ChangeTextLabelStyle(0,TRUE);
			g_eMuleApp.m_pGlobPrefs->SetToolbarLabelSettings(0);
			break;

		case MP_TEXTLABELS:
			ChangeTextLabelStyle(1,TRUE);
			g_eMuleApp.m_pGlobPrefs->SetToolbarLabelSettings(1);
			break;

		case MP_TEXTLABELSONRIGHT:
			ChangeTextLabelStyle(2,TRUE);
			g_eMuleApp.m_pGlobPrefs->SetToolbarLabelSettings(2);
			break;
		default:
			if(wParam >= MP_TOOLBARBITMAP && wParam <= MP_TOOLBARBITMAP+50)
				if(g_eMuleApp.m_pGlobPrefs->GetToolbarBitmapSettings()!=m_strBitmapPaths[wParam-MP_TOOLBARBITMAP])
				{
					g_eMuleApp.m_pGlobPrefs->SetToolbarBitmapSettings(m_strBitmapPaths[wParam-MP_TOOLBARBITMAP]);
					ChangeToolbarBitmap(m_strBitmapPaths[wParam-MP_TOOLBARBITMAP], true);
				}
	}

	return true;

	EMULE_CATCH

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::ChangeTextLabelStyle(int settings, bool refresh)
{
	if (m_iToolbarLabelSettings != settings)
	{
		switch (settings)
		{
			case 0:
				SetStyle(GetStyle() & ~TBSTYLE_LIST);
				SetMaxTextRows(0);
				break;
			case 1:
				SetStyle(GetStyle() & ~TBSTYLE_LIST);
				SetMaxTextRows(1);
				break;
			case 2:
				SetStyle(GetStyle() | TBSTYLE_LIST);
				SetMaxTextRows(1);
				break;
		}
		if ((m_iToolbarLabelSettings + settings) != 2) //if not changing between no labels and labels on right
		{
			for (int i = 0; i < MTB_NUMBUTTONS; i++)
			{
				TBBUTTONINFO		buttonInfo;

				buttonInfo.cbSize=sizeof(buttonInfo);
				buttonInfo.dwMask=TBIF_STYLE;
				GetButtonInfo(IDC_TOOLBARBUTTON + i, &buttonInfo);

				if (settings == 1)
					buttonInfo.fsStyle &= ~TBSTYLE_AUTOSIZE;
				else
					buttonInfo.fsStyle |= TBSTYLE_AUTOSIZE;
				SetButtonInfo(IDC_TOOLBARBUTTON + i, &buttonInfo);
			}
		}
		m_iToolbarLabelSettings = settings;
		if (refresh)
			Refresh();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::Refresh()
{
	SetBtnWidth();
	AutoSize();

	CRect		rToolbarRect;

	GetWindowRect(&rToolbarRect);

	static int	previousheight=0;

	if (previousheight == rToolbarRect.Height())
	{
		Invalidate();
		RedrawWindow();
	}
	else
	{
		previousheight=rToolbarRect.Height();
#ifdef USE_REBAR
		REBARBANDINFO	rbbi;
		CSize			sizeBar;

		GetMaxSize(&sizeBar);
		rbbi.cbSize = sizeof(rbbi);
		rbbi.fMask = RBBIM_SIZE | RBBIM_CHILDSIZE;
		rbbi.cxMinChild = 0;
		rbbi.cyMinChild = sizeBar.cy;
		rbbi.cx = 0;
		g_eMuleApp.m_pdlgEmule->m_ctlReBar.SetBandInfo(0, &rbbi);

		CRect		rReBarRect;

		g_eMuleApp.m_pdlgEmule->m_ctlReBar.GetWindowRect(&rReBarRect);

		CRect		rClientRect;

		g_eMuleApp.m_pdlgEmule->GetClientRect(&rClientRect);

		CRect		rStatusbarRect;

		g_eMuleApp.m_pdlgEmule->m_ctlStatusBar.GetWindowRect(&rStatusbarRect);
		rClientRect.top += rReBarRect.Height();
		rClientRect.bottom -= rStatusbarRect.Height();
#else
		CRect		rClientRect;

		g_eMuleApp.m_pdlgEmule->GetClientRect(&rClientRect);

		CRect		rStatusbarRect;

		g_eMuleApp.m_pdlgEmule->m_ctlStatusBar.GetWindowRect(&rStatusbarRect);
		rClientRect.top += rToolbarRect.Height();
		rClientRect.bottom -= rStatusbarRect.Height();
#endif
		CWnd		*wnds[] = {&g_eMuleApp.m_pdlgEmule->m_wndServer,&g_eMuleApp.m_pdlgEmule->m_wndTransfer,&g_eMuleApp.m_pdlgEmule->m_wndSharedFiles,&g_eMuleApp.m_pdlgEmule->m_dlgSearch,&g_eMuleApp.m_pdlgEmule->m_wndChat,&g_eMuleApp.m_pdlgEmule->m_wndIRC,&g_eMuleApp.m_pdlgEmule->m_dlgStatistics};

		for (int i = 0; i < 7; i++)
		{
			wnds[i]->SetWindowPos(NULL, rClientRect.left, rClientRect.top,rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
			g_eMuleApp.m_pdlgEmule->RemoveAnchor(wnds[i]->m_hWnd);
			g_eMuleApp.m_pdlgEmule->AddAnchor(wnds[i]->m_hWnd,TOP_LEFT,BOTTOM_RIGHT);
		}
		g_eMuleApp.m_pdlgEmule->Invalidate();
		g_eMuleApp.m_pdlgEmule->RedrawWindow();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::OnTbnReset(NMHDR *pNMHDR, LRESULT *pResult)
{
//	First get rid of old buttons
//	while saving their states
	for ( int i = GetButtonCount()-1; i >= 0 ; i-- )
	{
		TBBUTTON		Button;

		GetButton(i,&Button);
		for (int j= 0; j < MTB_NUMBUTTONS ; j++)
		{
			if ( m_buttonDefs[j].idCommand == Button.idCommand )
			{
				m_buttonDefs[j].fsState = Button.fsState;
				m_buttonDefs[j].fsStyle = Button.fsStyle;
				m_buttonDefs[j].iString = Button.iString;
			}
		}
		DeleteButton(i);
	}

	TBBUTTON		sepButton;

	sepButton.idCommand = 0;
	sepButton.fsStyle = TBSTYLE_SEP;
	sepButton.fsState = TBSTATE_ENABLED;
	sepButton.iString = -1;
	sepButton.iBitmap = -1;

//	Set default configuration
	for (i = 0; i < strDefaultToolbar.GetLength(); i += 2)
	{
		int		iIndex = _tstoi(strDefaultToolbar.Mid(i, 2));

		AddButtons(1, (iIndex == 99) ? &sepButton : &m_buttonDefs[iIndex]);
	}
//	Save new (default) configuration
	g_eMuleApp.m_pGlobPrefs->SetToolbarSettings(strDefaultToolbar);

	Localize();		// we have to localize the button-text
#ifdef OLD_SOCKETS_ENABLED
	g_eMuleApp.m_pdlgEmule->ShowConnectionState(g_eMuleApp.m_pServerConnect->IsConnected(), _T(""), true);
#endif //OLD_SOCKETS_ENABLED
	m_iToolbarLabelSettings = 4;
	ChangeTextLabelStyle(g_eMuleApp.m_pGlobPrefs->GetToolbarLabelSettings(), false);
	SetBtnWidth();		// then calc and set the button width
	AutoSize();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CMuleToolbarCtrl::OnTbnInitCustomize(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = TBNRF_HIDEHELP;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
