#pragma once

#include "preferences.h"
#include "afxwin.h"

// CPPgConnection dialog

class CPPgConnection : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgConnection)

public:
	CPPgConnection();
	virtual ~CPPgConnection();

	void SetPrefs(CPreferences* in_prefs) {	m_pPrefs = in_prefs; }
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	// Dialog Data
	enum { IDD = IDD_PPG_CONNECTION };
protected:
	// FoRcHa
	uint16 m_RQLimit;
	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}
	//

	CPreferences *m_pPrefs;
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	void LoadSettings(void);
	void EnableEditBoxes(BOOL bEnable = TRUE);
public:
	afx_msg void OnCbnSelchangeConType();		  	// DonGato
	afx_msg void OnSettingsChange()				{ SetModified(); }		//Cax2 ported from off dev
	afx_msg void OnBnClickedDisableXS();								// Tarod
	afx_msg void OnEnChangeUDPDisable();
	afx_msg void OnQueueChange();
	afx_msg void OnSpeedChange();							//Cax2 - no more strange settings!
	afx_msg void OnBnClickedDisableXSUpTo();						   // DonGato
	void Localize(void);
protected:
	CComboBox m_conprof; // DonGato
	BOOL limitQR;
	BOOL disableXS;
	BOOL enableXSUpTo;
	BOOL showOverhead;
	BOOL lancastEnable;
	BOOL limitlessDownload;
	BOOL scanFilter;
	CString xsUpTo;
	CString queueSize;
	CString maxCon;
	CString maxCon5;
	CString uploadCap;
	CString maxUp;
	CString downloadCap;
	CString maxDown;
	CString port;
	BOOL udpDisable;
	CString udpPort;
private:
	CButton limitQRCheck;
	CEdit udpPortEdit;
	CEdit xsUpToEdit;
	CEdit downloadCapEdit;
	CEdit uploadCapEdit;
	CEdit maxDownEdit;
	CEdit maxUpEdit;
	CEdit maxConEdit;
	CString conProfDesc;
	CString trFrmDesc;
	CString capacitiesDesc;
	CButton enableXsUpToCheck;
	CString kbS1Desc;
	CString kbS2Desc;
	CString limitsDesc;
	CButton lancastEnableCheck;
	CButton showOverheadCheck;
	CString xsSourcesDesc;
	CButton udpDisableCheck;
	CString maxCon5Desc;
	CString udpPortDesc;
	CString dCapDesc;
	CString uCapDesc;
	CButton disableXsCheck;
	CButton limitlessDownloadCheck;
	CButton scanFilterCheck;
	CString queueFrmDesc;
	CString queueSizeDesc;
	CString clientPortFrmDesc;
	CString maxConnFrmDesc;
};
