// PPgFiles.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgFiles.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgFiles dialog

IMPLEMENT_DYNAMIC(CPPgFiles, CPropertyPage)
CPPgFiles::CPPgFiles()
	: CPropertyPage(CPPgFiles::IDD)
	, dapEnable(FALSE)
	, slowComplete(FALSE)
	, uap(FALSE)
	, startPaused(FALSE)
	, startPausedOnComplete(FALSE)
	, autoClearCompleted(FALSE)
	, slowCompleteBlock(_T(""))
	, maxSourcePerFile(_T(""))
	, apHigh(_T(""))
	, apLow(_T(""))
	, seeShare(0)
	, hashPriority(0)
	, fileBufferSize(0)
	, fileBufferSizeDesc(_T(""))
	, seeMyShareDesc(_T(""))
	, apGrpDesc(_T(""))
	, apHighDesc(_T(""))
	, apLowDesc(_T(""))
	, apSources1Desc(_T(""))
	, apSources2Desc(_T(""))
	, slowCompleteKbDesc(_T(""))
	, hashingFrmDesc(_T(""))
	, maxSrcDesc(_T(""))
{
}

CPPgFiles::~CPPgFiles()
{
}

void CPPgFiles::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_DAP_ENABLE, dapEnable);
	DDX_Check(pDX, IDC_SLOWCOMPLETE, slowComplete);
	DDX_Check(pDX, IDC_UAP, uap);
	DDX_Check(pDX, IDC_START_PAUSED, startPaused);
	DDX_Check(pDX, IDC_START_PAUSED_ON_COMPLETE, startPausedOnComplete);
	DDX_Check(pDX, IDC_AUTO_CLEAR_COMPLETED, autoClearCompleted);
	DDX_Text(pDX, IDC_SLOWCOMPLETE_BLOCK, slowCompleteBlock);
	DDX_Text(pDX, IDC_MAXSOURCEPERFILE, maxSourcePerFile);
	DDX_Text(pDX, IDC_AP_HIGH, apHigh);
	DDX_Text(pDX, IDC_AP_LOW, apLow);
	DDX_Radio(pDX, IDC_SEESHARE1, seeShare);
	DDX_Radio(pDX, IDC_HASHPRIO_STANDARD, hashPriority);
	DDX_Slider(pDX, IDC_FILEBUFFERSIZE, fileBufferSize);
	DDX_Control(pDX, IDC_FILEBUFFERSIZE, fileBufferSizeSlider);
	DDX_Text(pDX, IDC_FILEBUFFERSIZE_LBL, fileBufferSizeDesc);
	DDX_Control(pDX, IDC_SLOWCOMPLETE_BLOCK, slowCompleteBlockEdit);
	DDX_Control(pDX, IDC_AP_HIGH, apHighEdit);
	DDX_Control(pDX, IDC_AP_LOW, apLowEdit);
	DDX_Text(pDX, IDC_SEEMYSHARE_FRM, seeMyShareDesc);
	DDX_Control(pDX, IDC_SEESHARE1, seeEverybodyRadio);
	DDX_Control(pDX, IDC_SEESHARE2, seeFriendRadio);
	DDX_Control(pDX, IDC_SEESHARE3, seeNooneRadio);
	DDX_Control(pDX, IDC_HASHPRIO_STANDARD, hashStandardRadio);
	DDX_Control(pDX, IDC_HASHPRIO_LOWER, hashLowerRadio);
	DDX_Control(pDX, IDC_HASHPRIO_IDLE, hashIdleRadio);
	DDX_Text(pDX, IDC_AP_GRP, apGrpDesc);
	DDX_Text(pDX, IDC_AP_HIGH_LBL, apHighDesc);
	DDX_Text(pDX, IDC_AP_LOW_LBL, apLowDesc);
	DDX_Control(pDX, IDC_DAP_ENABLE, dapEnableCheck);
	DDX_Control(pDX, IDC_UAP, uapCheck);
	DDX_Control(pDX, IDC_START_PAUSED, startPausedCheck);
	DDX_Control(pDX, IDC_START_PAUSED_ON_COMPLETE, startPausedOnCompleteCheck);
	DDX_Control(pDX, IDC_AUTO_CLEAR_COMPLETED, autoClearCompletedCheck);
	DDX_Text(pDX, IDC_AP_SOURCES1, apSources1Desc);
	DDX_Text(pDX, IDC_AP_SOURCES2, apSources2Desc);
	DDX_Text(pDX, IDC_SLOWCOMPLETE_KB, slowCompleteKbDesc);
	DDX_Text(pDX, IDC_HASHING_FRM, hashingFrmDesc);
	DDX_Text(pDX, IDC_MAXSRC_LBL, maxSrcDesc);
	DDX_Control(pDX, IDC_SLOWCOMPLETE, slowCompleteCheck);
}

BEGIN_MESSAGE_MAP(CPPgFiles, CPropertyPage)
	ON_BN_CLICKED(IDC_SEESHARE1, OnSettingsChange)
	ON_BN_CLICKED(IDC_SEESHARE2, OnSettingsChange)
	ON_BN_CLICKED(IDC_SEESHARE3, OnSettingsChange)
	ON_BN_CLICKED(IDC_HASHPRIO_STANDARD, OnSettingsChange)
	ON_BN_CLICKED(IDC_HASHPRIO_LOWER, OnSettingsChange)
	ON_BN_CLICKED(IDC_HASHPRIO_IDLE, OnSettingsChange)
	ON_EN_CHANGE(IDC_AP_HIGH, OnSettingsChange)
	ON_EN_CHANGE(IDC_AP_LOW, OnSettingsChange)
	ON_BN_CLICKED(IDC_UAP, OnSettingsChange)
	ON_BN_CLICKED(IDC_DAP_ENABLE, OnBnClickedDAP)
	ON_BN_CLICKED(IDC_START_PAUSED, OnSettingsChange)
	ON_BN_CLICKED(IDC_START_PAUSED_ON_COMPLETE, OnSettingsChange)
	ON_BN_CLICKED(IDC_AUTO_CLEAR_COMPLETED, OnSettingsChange)
	ON_EN_CHANGE(IDC_MAXSOURCEPERFILE, OnSettingsChange)
	ON_EN_KILLFOCUS(IDC_MAXSOURCEPERFILE, OnSourcesChange)
	ON_BN_CLICKED(IDC_SLOWCOMPLETE, OnBnClickedSlowComplete)
	ON_EN_CHANGE(IDC_SLOWCOMPLETE_BLOCK, OnSettingsChange)
	ON_WM_HSCROLL()
END_MESSAGE_MAP()

BOOL CPPgFiles::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgFiles::LoadSettings(void)
{
	switch(m_pPrefs->CanSeeShares())
	{
		case SEE_SHARE_EVERYBODY:
			seeShare = 0;
			break;
		case SEE_SHARE_FRIENDS:
			seeShare = 1;
			break;
		case SEE_SHARE_NOONE:
		default:
			seeShare = 2;
			break;
	}

	switch(m_pPrefs->GetHashingPriority())
	{
		case HASH_PRIORITY_IDLE:
			hashPriority = 2;
			break;
		case HASH_PRIORITY_LOWER:
			hashPriority = 1;
			break;
		case HASH_PRIORITY_STANDARD:
		default:
			hashPriority = 0;
			break;
	}

	uap = m_pPrefs->IsUAPEnabled();

	dapEnable = m_pPrefs->IsDAPEnabled();

	apHigh.Format(_T("%d"), m_pPrefs->PriorityHigh());
	apLow.Format(_T("%d"), m_pPrefs->PriorityLow());

	if(m_pPrefs->GetMaxSourcePerFile() == 0xFFFF)
		maxSourcePerFile = _T("99999");
	else
		maxSourcePerFile.Format(_T("%d"), m_pPrefs->GetMaxSourcePerFile());

	startPaused = m_pPrefs->StartDownloadPaused();
	startPausedOnComplete = m_pPrefs->DownloadPausedOnComplete();
	slowComplete = m_pPrefs->SlowComplete();
	autoClearCompleted = m_pPrefs->IsAutoClearCompleted();

	fileBufferSizeSlider.SetRange(1,100,true);
	fileBufferSize = m_pPrefs->GetFileBufferSize();

	slowCompleteBlock.Format(_T("%d"), m_pPrefs->SlowCompleteBlockSize());

	UpdateData(FALSE);

	OnBnClickedDAP();
	OnBnClickedSlowComplete();
	SetModified(FALSE);
}

BOOL CPPgFiles::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		switch(seeShare)
		{
			case 0:
				m_pPrefs->SetCanSeeShares(SEE_SHARE_EVERYBODY);
				break;
			case 1:
				m_pPrefs->SetCanSeeShares(SEE_SHARE_FRIENDS);
				break;
			case 2:
			default:
				m_pPrefs->SetCanSeeShares(SEE_SHARE_NOONE);
				break;
		}

		switch(hashPriority)
		{
			case 2:
				m_pPrefs->SetHashingPriority(HASH_PRIORITY_IDLE);
				g_eMuleApp.m_fileHashControl.SetProcessingPriority(ePIdle);
				break;
			case 1:
				m_pPrefs->SetHashingPriority(HASH_PRIORITY_LOWER);
				g_eMuleApp.m_fileHashControl.SetProcessingPriority(ePLower);
				break;
			case 0:
			default:
				m_pPrefs->SetHashingPriority(HASH_PRIORITY_STANDARD);
				g_eMuleApp.m_fileHashControl.SetProcessingPriority(ePStandard);
				break;
		}

		if(!maxSourcePerFile.IsEmpty())
		{
			int mspf = _tstoi(maxSourcePerFile);
			m_pPrefs->SetMaxSourcePerFile( (mspf != 0) ? mspf : 10);
		}

		m_pPrefs->SetUAPEnabled(uap);
		m_pPrefs->SetDAPEnabled(dapEnable);
		m_pPrefs->SetStartDownloadPaused(startPaused);
		m_pPrefs->SetDownloadPausedOnComplete(startPausedOnComplete);
		m_pPrefs->SetAutoClearCompleted(autoClearCompleted);

		m_pPrefs->SetPriorityHigh(_tstoi(apHigh));
		m_pPrefs->SetPriorityLow(_tstoi(apLow));
		if(m_pPrefs->PriorityLow() < m_pPrefs->PriorityHigh())
		{
			m_pPrefs->SetPriorityLow( m_pPrefs->PriorityHigh()*2);
			apLow.Format(_T("%d"),m_pPrefs->PriorityLow());
		}

		m_pPrefs->SetFileBufferSize(fileBufferSize);

		m_pPrefs->SetSlowComplete(slowComplete);
		m_pPrefs->SetSlowCompleteBlockSize(_tstoi(slowCompleteBlock));
		if (m_pPrefs->SlowCompleteBlockSize() > 1024)
		{
			m_pPrefs->SetSlowCompleteBlockSize(1024);
			slowCompleteBlock.Format(_T("%d"),m_pPrefs->SlowCompleteBlockSize());
		}

		UpdateData(FALSE);
		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgFiles::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_FILES));
		seeMyShareDesc = GetResString(IDS_PW_SHARE);
		seeEverybodyRadio.SetWindowText(GetResString(IDS_PW_EVER));
		seeFriendRadio.SetWindowText(GetResString(IDS_PW_FRIENDS));
		seeNooneRadio.SetWindowText(GetResString(IDS_PW_NOONE));
		apGrpDesc = GetResString(IDS_AP_GRP);
		apHighDesc = GetResString(IDS_AP_HIGH_LBL);
		apLowDesc = GetResString(IDS_AP_LOW_LBL);
		dapEnableCheck.SetWindowText(GetResString(IDS_ENABLED));
		uapCheck.SetWindowText(GetResString(IDS_UAP));
		startPausedCheck.SetWindowText(GetResString(IDS_START_PAUSED));
		startPausedOnCompleteCheck.SetWindowText(GetResString(IDS_START_PAUSED_ON_COMPLETE));
		autoClearCompletedCheck.SetWindowText(GetResString(IDS_AUTO_CLEAR_COMPLETED));
		apSources1Desc = GetResString(IDS_SOURCES_PF_FILES);
		apSources2Desc = GetResString(IDS_SOURCES_PF_FILES);
		slowCompleteCheck.SetWindowText(GetResString(IDS_SLOWCOMPLETE));
		slowCompleteKbDesc = GetResString(IDS_KBYTES);
		hashingFrmDesc = GetResString(IDS_HASHING_FRM);
		maxSrcDesc = GetResString(IDS_PW_MAXSOURCES);
		hashStandardRadio.SetWindowText(GetResString(IDS_HASHPRIO_STANDARD));
		hashLowerRadio.SetWindowText(GetResString(IDS_HASHPRIO_LOWER));
		hashIdleRadio.SetWindowText(GetResString(IDS_HASHPRIO_IDLE));
		fileBufferSizeDesc.Format(GetResString(IDS_FILEBUFFERSIZE), fileBufferSize*30000);

		UpdateData(FALSE);
	}
}

void CPPgFiles::OnSourcesChange()
{
	UpdateData(TRUE);

	uint16 num = 10;
	if(!maxSourcePerFile.IsEmpty())
	{
		num = _tstoi(maxSourcePerFile);
		if (num < 10)
			num = 10;
	}
	if (num != m_pPrefs->GetMaxSourcePerFile())
	{
		maxSourcePerFile.Format(_T("%u"),num);
		UpdateData(FALSE);
	}
}

void CPPgFiles::OnBnClickedDAP()
{
	UpdateData(TRUE);
	apHighEdit.EnableWindow(dapEnable);
	apLowEdit.EnableWindow(dapEnable);

	SetModified();
}

void CPPgFiles::OnBnClickedSlowComplete()
{
	UpdateData(TRUE);
	slowCompleteBlockEdit.EnableWindow(slowComplete);

	SetModified();
}

void CPPgFiles::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if (pScrollBar == (CScrollBar*) &fileBufferSizeSlider)
	{
		SetModified(TRUE);
		UpdateData(TRUE);
		fileBufferSizeDesc.Format( GetResString(IDS_FILEBUFFERSIZE), fileBufferSize * 30000 );//netwolf: increased FileBufferSize
		UpdateData(FALSE);
	}
}
