// PPgGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgGeneral.h"
#include ".\ppggeneral.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgGeneral dialog

IMPLEMENT_DYNAMIC(CPPgGeneral, CPropertyPage)

//#region message map
BEGIN_MESSAGE_MAP(CPPgGeneral, CPropertyPage)
	ON_EN_CHANGE(IDC_NICK, OnSettingsChange)
	ON_EN_CHANGE(IDC_TOOLTIPDELAY, OnSettingsChange)
	ON_CBN_SELCHANGE(IDC_LANGS, OnSettingsChange)
	ON_BN_CLICKED(IDC_BEEPER, OnSettingsChange)
	ON_BN_CLICKED(IDC_SPLASHON, OnSettingsChange)
	ON_BN_CLICKED(IDC_NOTIFY, OnSettingsChange)
	ON_BN_CLICKED(IDC_ONLINESIG, OnSettingsChange)
	ON_BN_CLICKED(IDC_LOGTOFILE, OnSettingsChange)
	ON_BN_CLICKED(IDC_MULTIPLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_DC_CLIENT, OnSettingsChange)
	ON_BN_CLICKED(IDC_VERBOSE, OnSettingsChange)
	ON_BN_CLICKED(IDC_UPLOAD_LOG, OnSettingsChange)
	ON_BN_CLICKED(IDC_MP_STANDARD, OnSettingsChange)
	ON_BN_CLICKED(IDC_MP_HIGH, OnSettingsChange)
	ON_BN_CLICKED(IDC_WEBSVEDIT , OnBnClickedEditWebservices)
	ON_BN_CLICKED(IDC_ED2KFIX, OnBnClickedEd2kfix)
	ON_BN_CLICKED(IDC_AUTOTAKEED2KLINKS, OnBnClickedAutoTakeED2KLinks)
	ON_BN_CLICKED(IDC_FAKE_CHECKUPDATEONSTART, OnSettingsChange)
	ON_BN_CLICKED(IDC_FAKE_UPDATE, OnBnClickedFakeUpdate)
	ON_EN_CHANGE(IDC_FAKE_LIST_URL, OnSettingsChange)
	ON_WM_HSCROLL()
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_3DDEPTH, On3DDepth)
	ON_BN_CLICKED(IDC_WATCH_CLIPBOARD, OnSettingsChange)
END_MESSAGE_MAP()
//#endregion

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CPPgGeneral::CPPgGeneral()
	: CPropertyPage(CPPgGeneral::IDD),
	  beepOnErrors(FALSE),
	  showSplashscreen(FALSE),
	  allowMultipleInstances(FALSE),
	  onlineSignature(FALSE),
	  writeLogToFile(FALSE),
	  debugLog(FALSE),
	  uploadLog(FALSE),
	  doubleClickClientDetails(FALSE),
	  autoTakeEd2kLinks(FALSE),
	  userNick(_T("")),
	  tooltipDelay(_T("")),
	  mainProcess(0),
	  updateFakeList(FALSE),
	  watchClipboard(FALSE)
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CPPgGeneral::~CPPgGeneral()
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::DoDataExchange(CDataExchange *pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LANGS, languageCombo);
	DDX_Control(pDX, IDC_PREVIEW, m_3DPreview);
	DDX_Control(pDX, IDC_3DDEPTH, threeDSlider);
	DDX_Control(pDX, IDC_NICK, userNickEdit);
	DDX_Control(pDX, IDC_BEEPER, beepOnErrorsCheck);
	DDX_Control(pDX, IDC_SPLASHON, showSplashscreenCheck);
	DDX_Control(pDX, IDC_MULTIPLE, allowMultipleInstancesCheck);
	DDX_Control(pDX, IDC_ONLINESIG, onlineSignatureCheck);
	DDX_Control(pDX, IDC_LOGTOFILE, writeLogToFileCheck);
	DDX_Control(pDX, IDC_VERBOSE, debugLogCheck);
	DDX_Control(pDX, IDC_UPLOAD_LOG, uploadLogCheck);
	DDX_Control(pDX, IDC_DC_CLIENT, doubleClickClientDetailsCheck);
	DDX_Control(pDX, IDC_ED2KFIX, ed2kFixButton);
	DDX_Control(pDX, IDC_AUTOTAKEED2KLINKS, autoTakeEd2kLinksCheck);
	DDX_Check(pDX, IDC_AUTOTAKEED2KLINKS, autoTakeEd2kLinks);
	DDX_Check(pDX, IDC_BEEPER, beepOnErrors);
	DDX_Check(pDX, IDC_SPLASHON, showSplashscreen);
	DDX_Check(pDX, IDC_MULTIPLE, allowMultipleInstances);
	DDX_Check(pDX, IDC_ONLINESIG, onlineSignature);
	DDX_Check(pDX, IDC_LOGTOFILE, writeLogToFile);
	DDX_Check(pDX, IDC_VERBOSE, debugLog);
	DDX_Check(pDX, IDC_UPLOAD_LOG, uploadLog);
	DDX_Check(pDX, IDC_DC_CLIENT, doubleClickClientDetails);
	DDX_Text(pDX, IDC_TOOLTIPDELAY, tooltipDelay);
	DDX_Text(pDX, IDC_NICK, userNick);
	DDX_Control(pDX, IDC_NICK_FRM, nickDesc);
	DDX_Control(pDX, IDC_LANG_FRM, languageDesc);
	DDX_Control(pDX, IDC_MISC_FRM, miscDesc);
	DDX_Control(pDX, IDC_TOOLTIPDELAY_LBL, tooltipDelayDesc);
	DDX_Control(pDX, IDC_3DDEP, threeDDepDesc);
	DDX_Radio(pDX, IDC_MP_STANDARD, mainProcess);
	DDX_Control(pDX, IDC_MP_STANDARD, standardProcessRadio);
	DDX_Control(pDX, IDC_MP_HIGH, highProcessRadio);
	DDX_Control(pDX, IDC_MAINPROCESS, mainProcessDesc);
	DDX_Control(pDX, IDC_WEBSVEDIT, webSvEditButton);
	DDX_Check(pDX, IDC_FAKE_CHECKUPDATEONSTART, updateFakeList);
	DDX_Control(pDX, IDC_FAKE_CHECKUPDATEONSTART, updateFakeListCheck);
	DDX_Control(pDX, IDC_FAKE_UPDATE, updateFakeListButton);
	DDX_Control(pDX, IDC_FAKE_LIST_URL_LBL, updateFakeListURLLabel);
	DDX_Text(pDX, IDC_FAKE_LIST_URL, updateFakeListURL);
	DDX_Control(pDX, IDC_WATCH_CLIPBOARD, watchClipboardCheck);
	DDX_Check(pDX, IDC_WATCH_CLIPBOARD, watchClipboard);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CPPgGeneral::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	userNickEdit.SetLimitText(MAX_NICK_LENGTH);

	ed2kFixButton.EnableWindow(!CheckIsRegistrySet());
	LoadSettings();
	DrawPreview();
	Localize();

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::LoadLanguagesCombo(void)
{
	static const WORD wLangs[] =
	{
		MAKELANGID(LANG_BASQUE,SUBLANG_DEFAULT),  // Basque
		MAKELANGID(LANG_CATALAN,SUBLANG_DEFAULT),  // Catalonian
		MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_SIMPLIFIED), // Chinese (simplified)
		MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_TRADITIONAL), // Chinese (traditional)
		MAKELANGID(LANG_DANISH,SUBLANG_DEFAULT),  // Danish
		MAKELANGID(LANG_DUTCH,SUBLANG_DEFAULT),  // Dutch
		MAKELANGID(LANG_ENGLISH,SUBLANG_DEFAULT),  // English
		MAKELANGID(LANG_FINNISH,SUBLANG_DEFAULT),  // Finnish
		MAKELANGID(LANG_FRENCH,SUBLANG_DEFAULT),  // French
		MAKELANGID(LANG_GERMAN,SUBLANG_DEFAULT),  // German
		MAKELANGID(LANG_GREEK,SUBLANG_DEFAULT),  // Greek
		MAKELANGID(LANG_HEBREW,SUBLANG_DEFAULT),  // Hebrew
		MAKELANGID(LANG_ITALIAN,SUBLANG_DEFAULT),  // Italian
		MAKELANGID(LANG_KOREAN,SUBLANG_DEFAULT),  // Korean
		MAKELANGID(LANG_LITHUANIAN,SUBLANG_DEFAULT),  // Lithuanian
		MAKELANGID(LANG_NORWEGIAN,SUBLANG_NORWEGIAN_BOKMAL), //Norwegian (Bokmal)
		MAKELANGID(LANG_POLISH,SUBLANG_DEFAULT),  // Polish
		MAKELANGID(LANG_PORTUGUESE,SUBLANG_PORTUGUESE),  //Portuguese (Portugal)
		MAKELANGID(LANG_PORTUGUESE,SUBLANG_PORTUGUESE_BRAZILIAN), // Portuguese (Brazilian)
		MAKELANGID(LANG_ROMANIAN,SUBLANG_DEFAULT),  // Romanian
		MAKELANGID(LANG_RUSSIAN,SUBLANG_DEFAULT),  // Russian
		MAKELANGID(LANG_SPANISH,SUBLANG_SPANISH),  // Spanish
		MAKELANGID(LANG_TURKISH,SUBLANG_DEFAULT)  // Turkish
	};

	CString szLang;
	for(int i = 0; i < sizeof(wLangs) / sizeof(WORD); i++)
	{
		GetLocaleInfo(wLangs[i], LOCALE_SLANGUAGE, szLang.GetBuffer(128), 128);
		szLang.ReleaseBuffer();
		switch(PRIMARYLANGID(wLangs[i]))			//Cax2 no sublangs in brackets for the following languages
		{
			case	LANG_ENGLISH:
			case 	LANG_GERMAN:
			case 	LANG_FRENCH:
			case 	LANG_SPANISH:
			case 	LANG_DUTCH:
			case	LANG_ITALIAN:
			{
				int iBracket = szLang.Find('(');
				if(iBracket > 0)
					szLang.Delete(iBracket, szLang.GetLength() - iBracket);
				break;
			}
		}
		languageCombo.SetItemData(languageCombo.AddString(szLang), wLangs[i]);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::LoadSettings(void)
{
	userNick = m_pPrefs->GetUserNick();

	LoadLanguagesCombo();
	for(int i = 0; i != languageCombo.GetCount(); i++)
	{
		if(languageCombo.GetItemData(i) == m_pPrefs->GetLanguageID())
		{
			languageCombo.SetCurSel(i);
			break;
		}
	}

	beepOnErrors = m_pPrefs->IsErrorBeepEnabled();
	showSplashscreen = m_pPrefs->UseSplashScreen();
	allowMultipleInstances = m_pPrefs->GetMultiple();
	onlineSignature = m_pPrefs->IsOnlineSignatureEnabled();
	writeLogToFile = m_pPrefs->LogToFile();
	debugLog = m_pPrefs->GetVerbose();
	uploadLog = m_pPrefs->LogUploadToFile();
	doubleClickClientDetails = m_pPrefs->GetDetailsOnClick();
	autoTakeEd2kLinks = m_pPrefs->AutoTakeED2KLinks();

	switch(m_pPrefs->GetMainProcessPriority())
	{
		case 0:
			mainProcess = 0;
			break;
		case 1:
			mainProcess = 1;
			break;
		default:
			mainProcess = 1;
			break;
	}

	//FakeCheck
	updateFakeList = m_pPrefs->IsUpdateFakeStartupEnabled();	// Changed by DropF
	updateFakeListURL = m_pPrefs->GetFakeListURL();				// Added by DropF

	watchClipboard = m_pPrefs->IsWatchClipboard4ED2KLinks();

	tooltipDelay.Format(_T("%d"), m_pPrefs->GetToolTipDelay());

	threeDSlider.SetRange(-5, 5, true);
	int tmp = m_pPrefs->Get3DDepth();
	if (tmp > 10)
		tmp = tmp - 256;
	threeDSlider.SetPos(tmp);

	UpdateData(FALSE);

	SetModified(FALSE);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CPPgGeneral::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		if (!userNick.IsEmpty())
			m_pPrefs->SetUserNick(userNick);

		int cs = languageCombo.GetCurSel();
		if (cs != CB_ERR)
		{
			WORD byNewLang = languageCombo.GetItemData(cs);
			if (m_pPrefs->GetLanguageID() != byNewLang)
			{
				m_pPrefs->SetLanguageID( byNewLang);
				if (g_eMuleApp.m_pGlobPrefs->IsNTBased())
				{
					SetThreadLocale(byNewLang);
				}
				g_eMuleApp.m_pdlgEmule->m_dlgPreferences.Localize();
				g_eMuleApp.m_pdlgEmule->m_dlgStatistics.Localize();
				g_eMuleApp.m_pdlgEmule->m_wndServer.Localize();
				g_eMuleApp.m_pdlgEmule->m_wndTransfer.Localize();
				g_eMuleApp.m_pdlgEmule->m_dlgSearch.Localize();
				g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.Localize();
				g_eMuleApp.m_pdlgEmule->m_wndChat.Localize();
				g_eMuleApp.m_pdlgEmule->Localize();
				g_eMuleApp.m_pdlgEmule->m_wndIRC.Localize();
			}
		}

		m_pPrefs->SetErrorBeepEnabled(beepOnErrors);
		m_pPrefs->SetUseSplashScreen(showSplashscreen);
		m_pPrefs->SetOnlineSignatureEnabled(onlineSignature);
		m_pPrefs->SetLogToFile(writeLogToFile);
		m_pPrefs->SetDetailsOnClick(doubleClickClientDetails);
		m_pPrefs->SetMultiple(allowMultipleInstances);
		m_pPrefs->Set3DDepth(((CSliderCtrl*)GetDlgItem(IDC_3DDEPTH))->GetPos());
		m_pPrefs->SetAutoTakeED2KLinks(autoTakeEd2kLinks);
		if (m_pPrefs->GetVerbose() != (bool)debugLog)
		{
			m_pPrefs->SetVerbose(debugLog);
			g_eMuleApp.m_pdlgEmule->m_wndServer.ToggleDebugWindow();
			if(debugLog)
				AddDebugLogLine(false, _T("Debug log is active"));
		}
		m_pPrefs->SetLogUploadToFile(uploadLog);
		//FakeCheck
		m_pPrefs->SetUpdateFakeStartup(updateFakeList);	// Changed by DropF
		m_pPrefs->SetFakeListURL(updateFakeListURL.Trim());	// Added by DropF

		m_pPrefs->SetWatchClipboard4ED2KLinks(watchClipboard);

		int td = _tstoi(tooltipDelay);
		if(td > 60)
			td = 60;
		m_pPrefs->SetToolTipDelay(td);

		g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ttip.SetDelayTime(TTDT_INITIAL, g_eMuleApp.m_pGlobPrefs->GetToolTipDelay()*1000+25); // DonGato: 25 reduce flickering

		if(mainProcess == 0)
			m_pPrefs->SetMainProcessPriority(0);
		else
			m_pPrefs->SetMainProcessPriority(1);

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_GENERAL));
		nickDesc.SetWindowText(GetResString(IDS_PW_NICK));
		languageDesc.SetWindowText(GetResString(IDS_PW_LANG));
		miscDesc.SetWindowText(GetResString(IDS_PW_MISC));
		beepOnErrorsCheck.SetWindowText(GetResString(IDS_PW_BEEP));
		showSplashscreenCheck.SetWindowText(GetResString(IDS_PW_SPLASH));
		tooltipDelayDesc.SetWindowText(GetResString(IDS_PW_TOOL));
		onlineSignatureCheck.SetWindowText(GetResString(IDS_PREF_ONLINESIG));
		writeLogToFileCheck.SetWindowText(GetResString(IDS_LOGTOFILE));
		allowMultipleInstancesCheck.SetWindowText(GetResString(IDS_MULTIPLE));
		doubleClickClientDetailsCheck.SetWindowText(GetResString(IDS_DC_CLIENT));
		threeDDepDesc.SetWindowText(GetResString(IDS_3DDEP));
		debugLogCheck.SetWindowText(GetResString(IDS_VERBOSE));
		uploadLogCheck.SetWindowText(GetResString(IDS_UPLOAD_LOG));
		mainProcessDesc.SetWindowText(GetResString(IDS_MAINPROCESS_LBL));
		standardProcessRadio.SetWindowText(GetResString(IDS_HASHPRIO_STANDARD));
		highProcessRadio.SetWindowText(GetResString(IDS_PRIOHIGH));
		webSvEditButton.SetWindowText(GetResString(IDS_WEBSVEDIT));
		ed2kFixButton.SetWindowText(GetResString(IDS_ED2KLINKFIX));
		autoTakeEd2kLinksCheck.SetWindowText(GetResString(IDS_AUTOTAKEED2KLINKS));
		updateFakeListButton.SetWindowText(GetResString(IDS_SV_UPDATE));
		updateFakeListCheck.SetWindowText(GetResString(IDS_FAKE_CHECKUPDATEONSTART));
		updateFakeListURLLabel.SetWindowText(GetResString(IDS_FAKE_LIST_URL_LBL));
		watchClipboardCheck.SetWindowText(GetResString(IDS_WATCH_CLIPBOARD));
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SetModified(TRUE);
	UpdateData(false);
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::OnPaint()
{
	CPropertyPage::OnPaint();
	DrawPreview();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::DrawPreview()
{
	m_3DPreview.SetSliderPos(threeDSlider.GetPos());
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::On3DDepth(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	DrawPreview();
	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::OnBnClickedEditWebservices()
{
	ShellExecute(NULL, _T("open"), g_eMuleApp.m_pGlobPrefs->GetTxtEditor(), _T("\"")+CString(g_eMuleApp.m_pGlobPrefs->GetConfigDir())+_T("webservices.dat\""), NULL, SW_SHOW);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::OnBnClickedEd2kfix()
{
	Ask4RegFix();
	ed2kFixButton.EnableWindow(!CheckIsRegistrySet());
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::OnBnClickedFakeUpdate()
{
	g_eMuleApp.m_pFakeCheck->DownloadFakeList();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
