//	PreferencesDlg.cpp : implementation file
//

//#region headers
#include "stdafx.h"
#include "emule.h"
#include "PreferencesDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif
//#endregion headers

//#region message map
BEGIN_MESSAGE_MAP(CPreferencesDlg, CPropertySheet)
	ON_WM_DESTROY()
	ON_MESSAGE(WM_SBN_SELCHANGED, OnSlideBarSelChanged)
	ON_COMMAND(ID_APPLY_NOW, OnApplyNow)
	ON_COMMAND(IDOK, OnOk)
END_MESSAGE_MAP()
//#endregion

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CPreferencesDlg::CPreferencesDlg()
{
	m_bIsVisible = false;

	EnableStackedTabs(FALSE);

//
//	WARNING: Pages must be added with the same order as the slidebar group items.
	AddPage(&m_proppageGeneral);		// <-- General pages
	AddPage(&m_proppageDirectories);
	AddPage(&m_proppageFiles);
	AddPage(&m_proppageStats);
	AddPage(&m_proppageWindow);
	AddPage(&m_proppageDownload);
	AddPage(&m_proppageConnection);		// <-- Connection pages
	AddPage(&m_proppageProxy);
	AddPage(&m_proppageServer);
	AddPage(&m_proppageHTTPD);
	AddPage(&m_proppageSMTP);			// <-- Messaging pages
	AddPage(&m_proppageIRC);
	AddPage(&m_proppageMessaging);
	AddPage(&m_proppageNotify);
	AddPage(&m_proppageAdvanced);		// <-- Advanced pages
	AddPage(&m_proppageBackup);
	AddPage(&m_proppageModPT);
	AddPage(&m_proppageScheduler);
	AddPage(&m_proppageShortcuts);
	AddPage(&m_proppageSorting);

	m_dwActiveWnd = 0;

	m_imageList.Create(16, 16, ILC_COLOR32 | ILC_MASK, 0, 10);
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_GENERAL), 16, 16));			//  0
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_CONNECTION), 16, 16));		//  1
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_PROXY), 16, 16));			//  2
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SERVER), 16, 16));			//  3
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_ADVANCED), 16, 16));		//  4
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_BACKUP), 16, 16));			//  5
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_FOLDERS), 16, 16));			//  6
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_FILES), 16, 16));			//  7
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_IRC), 16, 16));				//  8
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_WEBSERVER), 16, 16));		//  9
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_STATISTICS), 16, 16));		// 10
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_MPENDING), 16, 16));				// 11
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_NOTIFICATIONS), 16, 16));	// 12
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SMTP), 16, 16));			// 13
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_MODPT), 16, 16));			// 14
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SCHEDULER), 16, 16));		// 15
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SHORTCUTS),16,16));			// 16
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SORTING), 16, 16));			// 17
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_WINDOW), 16, 16));			// 18
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_DOWNLOAD), 16, 16));		// 19
	LoadImgLstIcon(NULL, 0, 0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CPreferencesDlg::~CPreferencesDlg()
{
	m_imageList.DeleteImageList();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
INT_PTR CPreferencesDlg::DoModal()
{
	if (!m_bIsVisible)
	{
		m_bIsVisible = true;
		return CPropertySheet::DoModal();
	}
	else
	{
		return FALSE;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPreferencesDlg::OnDestroy()
{
	m_bIsVisible = false;
	CPropertySheet::OnDestroy();
	m_dwActiveWnd = GetActiveIndex();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPreferencesDlg::OnApplyNow()
{
	Default();

	m_pPrefs->Save();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPreferencesDlg::OnOk()
{
	Default();

	m_pPrefs->Save();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CPreferencesDlg::OnInitDialog()
{
	m_slideBar.CreateEx(WS_EX_CLIENTEDGE, WS_CHILD | WS_VISIBLE | WS_BORDER, CRect(0, 0, 0, 0), this, IDC_PREFS_SLIDEBAR);
	m_slideBar.SetImageList(&m_imageList);
	m_slideBar.SetHAlignCaption(DT_CENTER);

//
//	Sets a bold font for the group buttons
	CFont* pGroupFont = m_slideBar.GetGroupFont();
	ASSERT_VALID(pGroupFont);
	LOGFONT logFont;
	//memzero(&logFont, sizeof(LOGFONT));
	pGroupFont->GetLogFont(&logFont);
	logFont.lfWeight *= 2;
	if (logFont.lfWeight > FW_BLACK)
	{
		logFont.lfWeight = FW_BLACK;
	}
	pGroupFont->DeleteObject();
	pGroupFont->CreateFontIndirect(&logFont);
	ASSERT_VALID(pGroupFont);

	BOOL bResult = CPropertySheet::OnInitDialog();

	SetActivePage(m_dwActiveWnd);

	Localize();

	m_slideBar.SetFocus();

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CPreferencesDlg::OnSlideBarSelChanged(WPARAM wParam, LPARAM lParam)
{
	int iCurrentGlobalSel	= m_slideBar.GetGlobalSelectedItem();

	SetActivePage(iCurrentGlobalSel);

	CListBoxST* pListBox = m_slideBar.GetGroupListBox(m_slideBar.GetSelectedGroupIndex());
	ASSERT_VALID(pListBox);

	CString strCurrentItemText;
	pListBox->GetText(pListBox->GetCurSel(), strCurrentItemText);

	CString strCurrentGroupText = m_slideBar.GetGroupName(m_slideBar.GetSelectedGroupIndex());
	strCurrentGroupText.Remove('&');

	CString strTitle = GetResString(IDS_EM_PREFS);
	strTitle.Remove('&');
	SetWindowText(strTitle + _T(" -> ") + strCurrentGroupText + _T(" -> ") + strCurrentItemText);

	pListBox->SetFocus();

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPreferencesDlg::Localize()
{
	m_proppageGeneral.Localize();
	m_proppageDirectories.Localize();
	m_proppageFiles.Localize();
	m_proppageStats.Localize();
	m_proppageDownload.Localize();
	m_proppageWindow.Localize();
	m_proppageConnection.Localize();
	m_proppageProxy.Localize();
	m_proppageServer.Localize();
	m_proppageHTTPD.Localize();
	m_proppageSMTP.Localize();
	m_proppageIRC.Localize();
	m_proppageMessaging.Localize();
	m_proppageNotify.Localize();
	m_proppageAdvanced.Localize();
	m_proppageBackup.Localize();
	m_proppageModPT.Localize();
	m_proppageScheduler.Localize();
	m_proppageShortcuts.Localize();
	m_proppageSorting.Localize();

	m_slideBar.ResetContent();

//
//	General group
	int iGroup = m_slideBar.AddGroup(GetResString(IDS_PW_GENERAL)/*, 0*/);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_GENERAL), iGroup, 0);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_DIR), iGroup, 6);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_FILES), iGroup, 7);
	m_slideBar.AddGroupItem(GetResString(IDS_STATSSETUPINFO), iGroup, 10);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_WINDOW), iGroup, 18);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_DOWNLOAD_WND), iGroup, 19);

//
//	Connexion group
	iGroup = m_slideBar.AddGroup(GetResString(IDS_PW_CONNECTION)/*, 1*/);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_CONNECTION), iGroup, 1);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_PROXY), iGroup, 2);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_SERVER), iGroup, 3);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_HTTPD), iGroup, 9);

//
//	Messaging group
	iGroup = m_slideBar.AddGroup(GetResString(IDS_PW_IM_OPTIONS)/*, 11*/);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_SMTP), iGroup, 13);
	m_slideBar.AddGroupItem(GetResString(IDS_IRC), iGroup, 8);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_IM_OPTIONS), iGroup, 11);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_EKDEV_OPTIONS), iGroup, 12);

//
//	Advanced group
	iGroup = m_slideBar.AddGroup(GetResString(IDS_PW_ADVANCED)/*, 4*/);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_ADVANCED), iGroup, 4);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_BACKUP), iGroup, 5);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_MODPT), iGroup, 14);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_SCHEDULER), iGroup, 15);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_SHORTCUTS), iGroup, 16);
	m_slideBar.AddGroupItem(GetResString(IDS_PW_SORTING), iGroup, 17);

//
//	Determines the width needed to the slidebar, and its position
	int width = m_slideBar.GetGreaterStringWidth();
	CRect rectOld;
	int xoffset;
	int yoffset;

	width += 60;
	m_slideBar.GetWindowRect(rectOld);

	if (IsWindowVisible())
	{
		yoffset = 0;
		xoffset = width - rectOld.Width();
	}
	else
	{
		xoffset = width - rectOld.Width() + 10;
		GetActivePage()->GetWindowRect(rectOld);
		ScreenToClient (rectOld);
		yoffset = -rectOld.top;
	}

//
//	Resizes the Preferences window
	GetWindowRect(rectOld);
	SetWindowPos(NULL, 0, 0, rectOld.Width() + xoffset, rectOld.Height() + yoffset, SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
	CTabCtrl* tab = GetTabControl();
	tab->GetWindowRect (rectOld);
	ScreenToClient (rectOld);
	tab->SetWindowPos(NULL, rectOld.left + xoffset, rectOld.top + yoffset, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	CPropertyPage* activepage = GetActivePage();
	activepage->GetWindowRect(rectOld);
	ScreenToClient (rectOld);
	activepage->SetWindowPos(NULL, rectOld.left + xoffset, rectOld.top + yoffset, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	GetClientRect(rectOld);
	m_slideBar.SetWindowPos(NULL, 6, 6, width, rectOld.Height() - 12, SWP_NOZORDER | SWP_NOACTIVATE);
	int _PropSheetButtons[] = {IDOK, IDCANCEL, ID_APPLY_NOW, IDHELP };
	CWnd* PropSheetButton;
	for (int i = 0; i < sizeof (_PropSheetButtons) / sizeof(_PropSheetButtons[0]); i++)
	{
		if (PropSheetButton = GetDlgItem(_PropSheetButtons[i]))
		{
			PropSheetButton->GetWindowRect (rectOld);
			ScreenToClient (rectOld);
			PropSheetButton->SetWindowPos (NULL, rectOld.left + xoffset, rectOld.top + yoffset, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
		}
	}
	tab->ShowWindow(SW_HIDE);
	m_slideBar.SelectGlobalItem(GetActiveIndex());
	OnSlideBarSelChanged(NULL, NULL);
	CenterWindow();
	Invalidate();
	RedrawWindow();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
