#pragma once

#include "PPgGeneral.h"
#include "PPgConnection.h"
#include "PPgProxy.h"
#include "PPgServer.h"
#include "PPgAdvanced.h"
#include "PPgBackup.h"
#include "PPgDownload.h"
#include "PPgDirectories.h"
#include "PPgFiles.h"
#include "PPgIRC.h"
#include "PPgHTTPD.h"
#include "PPgStats.h"
#include "PPgMessaging.h"
#include "PPgNotify.h"
#include "PPgSMTP.h"
#include "PPgModPT.h"
#include "PPgScheduler.h"
#include "PPgShortcuts.h"
#include "PPgSorting.h"
#include "PPgWindow.h"
#include "otherfunctions.h"
#include "ListBoxST.h"
#include "SlideBar.h"

// CPreferencesDlg

#define IDC_PREFS_SLIDEBAR	111

class CPreferencesDlg : public CPropertySheet
{
public:
	CPPgGeneral			m_proppageGeneral;
	CPPgConnection		m_proppageConnection;
	CPPgProxy			m_proppageProxy;
	CPPgServer			m_proppageServer;
	CPPgAdvanced		m_proppageAdvanced;
	CPPgBackup			m_proppageBackup;
	CPPgDirectories		m_proppageDirectories;
	CPPgDownload		m_proppageDownload;
	CPPgFiles			m_proppageFiles;
	CPPgIRC				m_proppageIRC;
	CPPgHTTPD			m_proppageHTTPD;
	CPPgStats			m_proppageStats;
	CPPgMessaging		m_proppageMessaging;
	CPPgNotify			m_proppageNotify;
	CPPgSMTP			m_proppageSMTP;
	CPPgModPT			m_proppageModPT;
	CPPgScheduler		m_proppageScheduler;
	CPPgShortcuts		m_proppageShortcuts;
	CPPgSorting			m_proppageSorting;
	CPPgWindow			m_proppageWindow;
	CPreferences	   *m_pPrefs;
	CSlideBar	 		m_slideBar;
	CButton				m_groupBoxBtn;
	CImageList			m_imageList;

protected:
	UINT				m_dwActiveWnd;

private:
	bool				m_bIsVisible;

public:
						CPreferencesDlg();
	virtual			   ~CPreferencesDlg();
	INT_PTR				CPreferencesDlg::DoModal();
	void				Localize();
	void				SetPrefs(CPreferences *pPrefs)
	{
		m_pPrefs = pPrefs;
		m_proppageGeneral.SetPrefs(pPrefs);
		m_proppageConnection.SetPrefs(pPrefs);
		m_proppageDownload.SetPrefs(pPrefs);
		m_proppageProxy.SetPrefs(pPrefs);
		m_proppageServer.SetPrefs(pPrefs);
		m_proppageAdvanced.SetPrefs(pPrefs);
		m_proppageBackup.SetPrefs(pPrefs);
		m_proppageDirectories.SetPrefs(pPrefs);
		m_proppageFiles.SetPrefs(pPrefs);
		m_proppageIRC.SetPrefs(pPrefs);
		m_proppageHTTPD.SetPrefs(pPrefs);
		m_proppageStats.SetPrefs(pPrefs);
		m_proppageMessaging.SetPrefs(pPrefs);
		m_proppageNotify.SetPrefs(pPrefs);
		m_proppageSMTP.SetPrefs(pPrefs);
		m_proppageModPT.SetPrefs(pPrefs);
		m_proppageScheduler.SetPrefs(pPrefs);
		m_proppageShortcuts.SetPrefs(pPrefs);
		m_proppageSorting.SetPrefs(pPrefs);
		m_proppageWindow.SetPrefs(pPrefs);
	}

	afx_msg void		OnApplyNow();
	afx_msg void		OnOk();
	afx_msg void		OnDestroy();
	afx_msg LRESULT		OnSlideBarSelChanged(WPARAM wParam, LPARAM lParam);
	virtual BOOL		OnInitDialog();

	DECLARE_MESSAGE_MAP()

};
