//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#pragma once
#include "SharedFileList.h"
#include "knownfile.h"
#include "types.h"
#include "MuleListCtrl.h"
#include "ShellContextMenu.h"

//--- its for "better" sorting ---
#include "listControlSorter.h"
#include "Loggable.h"

//--- we have two different items ---
class	sfl_itemdata
{
public:
	bool		isFile;
	bool		isOpen;
	uint16		part;
	uint16		parts;
	CKnownFile	*knownFile;
};

class CSharedFileList;
class CSharedFilesCtrl : public CMuleListCtrl, public CLoggable
{
	DECLARE_DYNAMIC(CSharedFilesCtrl)

public:
	CSharedFilesCtrl();
	virtual ~CSharedFilesCtrl();
	void	Init();
	void	ShowFileList(CSharedFileList* in_sflist);
	void	AddFile(CKnownFile *file);
	void	RemoveFile(CKnownFile* toremove);
	void	UpdateFile(CKnownFile* file, uint32 pos, bool resort=true);
	void	UpdateItem(CKnownFile* toupdate, bool resort=true);
	void	SortInit(int sortCode);
	void	Localize();
	void	ShowFilesCount();
	void	SetColoring(byte mode);
	void	SetDisplay(byte mode, bool redraw);
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual BOOL DeleteAllItems();
	void	UpdateOfferedItems();
	bool	m_allYaKnow;
	void	ShowKnownList();

protected:
	static int CALLBACK SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	static double CompleteSourcesCmpValue(CKnownFile* item, bool second);
	afx_msg	void OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg	void OnDoubleClick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGetDispInfo(NMHDR* pNMHDR, LRESULT* pResult);

	virtual BOOL	OnWndMsg(UINT iMessage,WPARAM wParam, LPARAM lParam, LRESULT *pResult);

	DECLARE_MESSAGE_MAP()
private:
	bool			DrawStatusBarFile(CDC* dc, RECT* rect, const CFileStatistic& statistic);
	bool			DrawStatusBarPart(CDC* dc, RECT* rect, const CFileStatistic& statistic, uint16 part);
	void			ShowFile(CKnownFile *file, bool resort=true);
	void			ShowFile(CKnownFile *file, uint32 itemnr, bool resort=true);

	CListCtrlSorter		m_listSorter;
	static	bool		m_sortParts;
	COLORREF(*GetTrafficColor)(double);// yes kids, thats a function pointer :)
	byte			m_display;
	byte			m_display_atpts;
	byte			m_display_atpte;
	byte			m_display_atbts;
	byte			m_display_atbte;
	byte			m_display_sbts;
	byte			m_display_sbte;

	void	TraffiGram(CDC* dc, RECT* rect, const CFileStatistic& statistic, int use, double bpp, uint32 start=0);
	bool	m_trafficgram;

//	For fast prio-sorting
	static	byte	m_p2p[8];	//eklmn: extra place for new priority JUMPSTART,...

//	Make it Win9x compatible by using only one bitmap, brush...?
	CDC		cdcStatus; 
	CPen	pen;
	CBrush	brush;
	CBrush*	m_pOldBrush;
	CBitmap status;

	int		m_statusWidth;
	CShellContextMenu *m_pSCM;

public:
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
};

// Part Traffic 
COLORREF	GetTrafficColor0(double f);	/// rainbow (exp)
COLORREF	GetTrafficColor1(double f);	/// rainbow (lin)
COLORREF	GetTrafficColor2(double f);	/// blue
COLORREF	GetTrafficColor3(double f);	/// pink
