//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "afxinet.h"
#include "emule.h"
#include "emuleDlg.h"
#ifdef OLD_SOCKETS_ENABLED
#include "sockets.h"
#endif //OLD_SOCKETS_ENABLED
#include "knownfilelist.h"
#include "knownfile.h"
#include "ServerList.h"
#include "opcodes.h"
#include "SharedFileList.h"
#include "ED2KLink.h"
#include "math.h"
#include "Splashscreen.h"
#pragma comment(lib, "winmm.lib")
#include "Mmsystem.h"
#include "enbitmap.h"
#include "HTRichEditCtrl.h"
#include <comdef.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

const static UINT		UWM_ARE_YOU_EMULE = RegisterWindowMessage(_T(EMULE_GUID));

BEGIN_MESSAGE_MAP(CEmuleDlg, CTrayDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_CLOSE()

	ON_COMMAND(MP_CONNECT, StartConnection)
	ON_COMMAND(MP_DISCONNECT, CloseConnection)
	ON_COMMAND(MP_RESTORE, RestoreWindow)
	ON_COMMAND(MP_EXIT, OnClose )

	ON_MESSAGE(WM_TASKBARNOTIFIERCLICKED, OnTaskbarNotifierClicked)
	ON_MESSAGE(WM_COPYDATA, OnWMData)
	ON_MESSAGE(TM_FINISHEDHASHING,OnFileHashed)
	ON_MESSAGE(WEB_CONNECT_TO_SERVER, OnWebServerConnect)
	ON_MESSAGE(WEB_REMOVE_SERVER, OnWebServerRemove)
	ON_MESSAGE(WEB_ADD_TO_STATIC, OnWebServerAddToStatic)
	ON_MESSAGE(WEB_REMOVE_FROM_STATIC, OnWebServerRemoveFromStatic)
	ON_MESSAGE(WEB_CLEAR_COMPLETED, OnWebServerClearCompleted)
	ON_MESSAGE(WEB_FILE_RENAME, OnWebServerFileRename)
	ON_MESSAGE(WEB_SHARED_FILES_RELOAD, OnWebSharedFilesReload)
//	ON_MESSAGE(WM_TASK_UI, OnProcessTaskUI)
	ON_REGISTERED_MESSAGE(UWM_ARE_YOU_EMULE, OnAreYouEmule)

	ON_WM_QUERYENDSESSION()
	ON_WM_TIMER()
	ON_WM_NCDESTROY()
END_MESSAGE_MAP()

//Lucas - 08-Jan Define settig the Timer ID to be used.
//Could be interesting to standarize the TIMER_IDs (there are many already)
#define INIT_TIMER_ID 1234 // This is a magic number...

// CEmuleDlg Dialog

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CEmuleDlg::CEmuleDlg(CWnd* pParent /*=NULL*/)
	: CTrayDialog(CEmuleDlg::IDD, pParent)
{
	EMULE_TRY

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hiconMyTray = NULL;
	m_bReady = false;
	m_bStartUpMinimized = false;
	m_iFilesToBeHashed = 0;

	lastuprate = 0;
	lastdownrate = 0;
	g_eMuleApp.m_app_state = g_eMuleApp.APP_STATE_RUNNING;
	m_iStatus = 0;
	m_hiconConn[0] = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_NOTCONNECTED),IMAGE_ICON,16,16,0);
	m_hiconConn[1] = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_CONNECTED),IMAGE_ICON,16,16,0);
	m_hiconConn[2] = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_CONNECTEDHIGH),IMAGE_ICON,16,16,0);
	m_hiconTrans[0] = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_UP0),IMAGE_ICON,16,16,0);
	m_hiconTrans[1] = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_UP1),IMAGE_ICON,16,16,0);
	m_hiconTrans[2] = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DOWN0),IMAGE_ICON,16,16,0);
	m_hiconTrans[3] = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DOWN1),IMAGE_ICON,16,16,0);
	m_hiconIM[0] = 0;
	m_hiconIM[1] = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_MESSAGE),IMAGE_ICON,16,16,0);
	m_hiconIM[2] = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_MPENDING),IMAGE_ICON,16,16,0);
	m_hiconSourceTray = (HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TRAYICON),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	m_hiconSourceTrayLowID = (HICON)LoadImage(AfxGetInstanceHandle() ,MAKEINTRESOURCE(IDI_TRAYICON_LOWID),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	m_hiconSourceTrayGrey = (HICON)LoadImage(AfxGetInstanceHandle() ,MAKEINTRESOURCE(IDI_TRAYICON_GREY),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	m_hiconUsers = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_USERS),IMAGE_ICON,16,16,0);
	m_pSystrayDlg = NULL;
	m_astrMissedLogLines.RemoveAll();
	m_astrMissedDebugLogLines.RemoveAll();

	m_strDebugLogFilePath.Format(_T("%sdebug.log"), g_eMuleApp.m_pGlobPrefs->GetAppDir());
	m_strLogFilePath.Format(_T("%seMule.log"), g_eMuleApp.m_pGlobPrefs->GetAppDir());

#ifdef NEW_SOCKETS
//	m_pEngineData = new CEngineData(*g_eMuleApp.m_pEngine);
#endif //NEW_SOCKETS

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CEmuleDlg::~CEmuleDlg()
{
	EMULE_TRY

	if (m_hiconMyTray)
		DestroyIcon(m_hiconMyTray);

	::DestroyIcon(m_hIcon);
	::DestroyIcon(m_hiconConn[0]);
	::DestroyIcon(m_hiconConn[1]);
	::DestroyIcon(m_hiconConn[2]);
	::DestroyIcon(m_hiconTrans[0]);
	::DestroyIcon(m_hiconTrans[1]);
	::DestroyIcon(m_hiconTrans[2]);
	::DestroyIcon(m_hiconTrans[3]);
	::DestroyIcon(m_hiconIM[1]);
	::DestroyIcon(m_hiconIM[2]);
	::DestroyIcon(m_hiconSourceTray);
	::DestroyIcon(m_hiconSourceTrayLowID);
	::DestroyIcon(m_hiconSourceTrayGrey);
	::DestroyIcon(m_hiconUsers);

	if (m_hiconMyTray)
	{
		DestroyIcon(m_hiconMyTray);
	}
	m_wndServer.DestroyWindow();
	m_wndSharedFiles.DestroyWindow();
	m_dlgSearch.DestroyWindow();
	m_wndChat.DestroyWindow();
	m_wndTransfer.DestroyWindow();
	m_dlgStatistics.DestroyWindow();
	m_wndIRC.DestroyWindow();

#ifdef NEW_SOCKETS
//	if (m_pEngineData)
//		delete m_pEngineData;
#endif //NEW_SOCKETS

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::DoDataExchange(CDataExchange *pDX)
{
	CTrayDialog::DoDataExchange(pDX);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnAreYouEmule(WPARAM, LPARAM)
{
	return UWM_ARE_YOU_EMULE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
DWORD WINAPI CheckCurrentVersionAtInet(void *)
{
	EMULE_TRY

	CString strUrl;
	BOOL bNTBased = FALSE;
	WORD wWinVer = DetectWinVersion(bNTBased);
	strUrl.Format(
		_T("http://emuleplus.servehttp.com/get_version.php?version=%i&language=%i&os=%i&nt=%i&webserver=%i&lancast=%i&mobilemule=%i&cpu=%i"),
		CURRENT_PLUS_VERSION,
		g_eMuleApp.m_pGlobPrefs->GetLanguageID(),
		wWinVer, bNTBased,
		g_eMuleApp.m_pGlobPrefs->GetWSIsEnabled(),
		g_eMuleApp.m_pGlobPrefs->GetLancastEnabled(),
		g_eMuleApp.m_pGlobPrefs->IsMMServerEnabled(),
		(int)get_cpu_type());

	bool bDone = false;
	HINTERNET hOpen = InternetOpen(_T("eMule"), INTERNET_OPEN_TYPE_PRECONFIG , NULL, NULL, 0);
	if(hOpen)
	{
		HINTERNET hURL = InternetOpenUrl(hOpen, strUrl, _T(""), NULL, INTERNET_FLAG_NO_CACHE_WRITE, NULL);
		if (hURL)
		{
			TCHAR pBuf[2000];
			DWORD dwSize;
			if(InternetReadFile(hURL, pBuf, 1000, &dwSize))
			{
				pBuf[dwSize] = 0;
				// utf8? convert!
				if(pBuf[0] == (TCHAR)0xEF && pBuf[1] == (TCHAR)0xBB && pBuf[2] == (TCHAR)0xBF)
				{
					WCHAR pNewBuf[2000];
					int iBytes;
					if(iBytes = MultiByteToWideChar(CP_UTF8, 0, pBuf, dwSize, pNewBuf, 1000))
					{
						pNewBuf[iBytes] = 0; dwSize = iBytes;
						_tcscpy(pBuf, (TCHAR*)(_bstr_t(pNewBuf+1)));
					}
				}
				if(pBuf[0] == 'O' && pBuf[1] == 'K') // everything allright
				{
					CString strOut(pBuf + 2);
					g_eMuleApp.m_pdlgEmule->AddLogLine(true, RGB_LOG_NOTICE + strOut);
					g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false,
						RGB_LOG_NOTICE + _T("Anonymous statistical data sent to eMule Plus home site: Version=%i Language=%i OS=%i NT=%i Webserver=%i Lancast=%i MobileMule=%i CPU=%i"),
						CURRENT_PLUS_VERSION,
						g_eMuleApp.m_pGlobPrefs->GetLanguageID(),
						wWinVer, bNTBased,
						g_eMuleApp.m_pGlobPrefs->GetWSIsEnabled(),
						g_eMuleApp.m_pGlobPrefs->GetLancastEnabled(),
						g_eMuleApp.m_pGlobPrefs->IsMMServerEnabled(),
						(int)get_cpu_type());
					g_eMuleApp.m_pGlobPrefs->SetAutoCheckLastTime(time(NULL));
					bDone = true;
				}
			}
		}
	}
//	if(!bDone)
//		maybe add log line "couldn't check latest version"?


	EMULE_CATCH2

	return 0;
}
*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
DWORD WINAPI CheckCurrentVersionAtInet(void *)
{
	EMULE_TRY

	CString strUrl;
	BOOL bNTBased = FALSE;
	WORD wWinVer = DetectWinVersion(bNTBased);
	strUrl.Format( _T("http://plus.go.dyndns.org/get_version.php?version=%i&language=%i"),
				   CURRENT_PLUS_VERSION, g_eMuleApp.m_pGlobPrefs->GetLanguageID() );

	bool bDone = false;
	HINTERNET hOpen = InternetOpen(_T("eMule"), INTERNET_OPEN_TYPE_PRECONFIG , NULL, NULL, 0);
	if(hOpen)
	{
		HINTERNET hURL = InternetOpenUrl(hOpen, strUrl, _T(""), NULL, INTERNET_FLAG_NO_CACHE_WRITE, NULL);
		if (hURL)
		{
			TCHAR pBuf[2000];
			DWORD dwSize;
			if(InternetReadFile(hURL, pBuf, 1000, &dwSize))
			{
				pBuf[dwSize] = 0;
				// utf8? convert!
				if(pBuf[0] == (TCHAR)0xEF && pBuf[1] == (TCHAR)0xBB && pBuf[2] == (TCHAR)0xBF)
				{
					WCHAR pNewBuf[2000];
					int iBytes;
					if(iBytes = MultiByteToWideChar(CP_UTF8, 0, pBuf, dwSize, pNewBuf, 1000))
					{
						pNewBuf[iBytes] = 0; dwSize = iBytes;
						_tcscpy(pBuf, (TCHAR*)(_bstr_t(pNewBuf+1)));
					}
				}
				if(pBuf[0] == 'O' && pBuf[1] == 'K') // everything allright
				{
					CString strOut(pBuf + 2);
					g_eMuleApp.m_pdlgEmule->AddLogLine(true, RGB_LOG_NOTICE + strOut);
					g_eMuleApp.m_pGlobPrefs->SetAutoCheckLastTime(time(NULL));
					bDone = true;
				}
			}
		}
	}
//	if(!bDone)
//		maybe add log line "couldn't check latest version"?


	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CEmuleDlg::OnInitDialog()
{
	EMULE_TRY

	CTrayDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu	*pSysMenu = GetSystemMenu(FALSE);

	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, GetResString(IDS_ABOUTBOX));
	}

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

//	Set font
	m_fontDefault.CreatePointFont(g_eMuleApp.m_pGlobPrefs->GetFontSize(),g_eMuleApp.m_pGlobPrefs->GetUsedFont());

//	Set tool bar
	m_ctlToolBar.Create(WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, CRect(0,0,0,0), this, IDC_TOOLBAR);
	m_ctlToolBar.Init();
	m_ctlToolBar.ShowSpeedMeter(g_eMuleApp.m_pGlobPrefs->GetShowToolbarSpeedMeter());

	int		iMaxRange = g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate();

	if (g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate() > iMaxRange)
		iMaxRange = g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate();
	m_ctlToolBar.SetSpeedMeterRange(iMaxRange, 0);

#ifdef USE_REBAR
//	set rebar
	REBARBANDINFO	rbbi;
	CSize			sizeBar;

	m_ctlToolBar.GetMaxSize(&sizeBar);
	m_ctlReBar.Create( WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_BORDER | RBS_BANDBORDERS
					 | /*RBS_AUTOSIZE |*/ RBS_VARHEIGHT | CCS_NODIVIDER | CCS_TOP,
					   CRect(0, 0, 0, 0),
					   this,
					   AFX_IDW_REBAR);

//	Insert the tool bar into the rebar
	rbbi.cbSize       = sizeof(REBARBANDINFO);
	rbbi.fMask        = RBBIM_SIZE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE;
	rbbi.cxMinChild   = 0;
	rbbi.cyMinChild   = sizeBar.cy;
	rbbi.cx           = 0;
	rbbi.fStyle       = RBBS_NOGRIPPER | RBBS_BREAK;
	rbbi.hwndChild    = (HWND) m_ctlToolBar;
	m_ctlReBar.InsertBand(-1, &rbbi);

//	Insert address bar
	/*
	CComboBoxEx *combo = new CComboBoxEx();
	CRect rcAddress;
	combo->Create(WS_CHILD | WS_CLIPCHILDREN | WS_TABSTOP | CCS_NODIVIDER | CBS_DROPDOWN, CRect(0, 0, 0, 200), this, AFX_IDW_TOOLBAR + 1);
	combo->GetWindowRect(&rcAddress);
	rbbi.cbSize       = sizeof(REBARBANDINFO);
	rbbi.fMask        = RBBIM_SIZE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE | RBBIM_TEXT;
	rbbi.cxMinChild   = 0;
	rbbi.cyMinChild   = rcAddress.Height();
	rbbi.cx           = 0;
	rbbi.fStyle       = RBBS_NOGRIPPER | RBBS_BREAK;
	rbbi.hwndChild    = combo->GetSafeHwnd();
	rbbi.lpText       = _T("Address");
	m_ctlReBar.InsertBand(-1, &rbbi);
	 */
#endif

//	Set window title
	SetWindowText(_T("eMule Plus v") CURRENT_VERSION_LONG);

	m_wndTaskbarNotifier.Create(this);

	CEnBitmap		m_imgTaskbar;

	VERIFY(m_imgTaskbar.LoadImage(IDR_POPUP,_T("JPG")));
	m_wndTaskbarNotifier.SetBitmap(&m_imgTaskbar, 255, 0, 255);
	m_wndTaskbarNotifier.SetTextFont(_T("Arial"),g_eMuleApp.m_pGlobPrefs->NotificationFontSize(),TN_TEXT_NORMAL,TN_TEXT_UNDERLINE);
	m_wndTaskbarNotifier.SetTextColor(RGB(255,255,230),RGB(255,255,255));
	m_wndTaskbarNotifier.SetTextRect(CRect(14,40,m_wndTaskbarNotifier.m_nBitmapWidth-14,m_wndTaskbarNotifier.m_nBitmapHeight-14));

	// set m_ctlStatusBar
	m_ctlStatusBar.Create(WS_CHILD|WS_VISIBLE|CCS_BOTTOM|SBARS_SIZEGRIP|SBT_TOOLTIPS,CRect(0,0,0,0), this, IDC_STATUSBAR) ;	//Cax2 status bar tooltip
	m_ctlStatusBar.EnableToolTips(true);
	ResizeStatusBar();
	m_ctlStatusBar.SetIcon(SB_NUMUSERS, m_hiconUsers);

	// create dialog pages
	m_dlgPreferences.SetPrefs(g_eMuleApp.m_pGlobPrefs);
	m_wndServer.Create(IDD_SERVER);
	m_wndSharedFiles.Create(IDD_FILES);
	m_dlgSearch.Create(IDD_SEARCH);
	m_wndChat.Create(IDD_CHAT);
	m_wndTransfer.Create(IDD_TRANSFER);
	m_dlgStatistics.Create(IDD_STATISTICS);
	m_wndIRC.Create(IDD_IRC);
	m_pdlgActive = &m_wndTransfer;

	CRect rClientRect;
	GetClientRect(&rClientRect);
#ifdef USE_REBAR
	CRect rReBarRect;
	m_ctlReBar.GetWindowRect(&rReBarRect);
	CRect rStatusbarRect;
	m_ctlStatusBar.GetWindowRect(&rStatusbarRect);
	rClientRect.top += rReBarRect.Height();
	rClientRect.bottom -= rStatusbarRect.Height();
#else
	CRect rToolbarRect;
	m_ctlToolBar.GetWindowRect(&rToolbarRect);
	CRect rStatusbarRect;
	m_ctlStatusBar.GetWindowRect(&rStatusbarRect);
	rClientRect.top += rToolbarRect.Height();
	rClientRect.bottom -= rStatusbarRect.Height();
#endif
	m_wndServer.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_wndTransfer.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
								rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_wndSharedFiles.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
								rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_dlgSearch.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_wndChat.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_wndIRC.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	m_dlgStatistics.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
								rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);

	// set updateintervall of graphic rate display (in seconds)
	ShowConnectionState(false);

	// anchors
	AddAnchor(m_wndServer,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_wndTransfer,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_wndSharedFiles,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_dlgSearch,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_wndChat,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_wndIRC,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_ctlStatusBar,BOTTOM_LEFT,BOTTOM_RIGHT);
	AddAnchor(m_dlgStatistics,TOP_LEFT,BOTTOM_RIGHT);
#ifdef USE_REBAR
	AddAnchor(m_ctlReBar,TOP_LEFT, TOP_RIGHT);
#else
	AddAnchor(m_ctlToolBar,TOP_LEFT, TOP_RIGHT);
#endif

	m_dlgStatistics.ShowInterval();
//	Set Tray icon
	TraySetMinimizeToTray(g_eMuleApp.m_pGlobPrefs->DoMinToTray());
	TrayMinimizeToTrayChanged();

//	Update Categories
	m_dlgSearch.UpdateCatTabs();

	m_wndServer.ShowWindow(SW_SHOW);
	m_pdlgActive = &m_wndServer;

	g_eMuleApp.m_pGlobPrefs->SetSmartIdState(1);

//	Restore saved window placement
	WINDOWPLACEMENT wp;wp.length=sizeof(wp);
	wp=g_eMuleApp.m_pGlobPrefs->GetEmuleWindowPlacement();
	SetWindowPlacement(&wp);

	Localize();

#ifdef OLD_SOCKETS_ENABLED
	g_eMuleApp.m_pMMServer->Init();
#endif //OLD_SOCKETS_ENABLED

//	SplashScreen
	if (g_eMuleApp.m_pGlobPrefs->UseSplashScreen() && !g_eMuleApp.m_pGlobPrefs->GetStartMinimized())
	{
		CSplashScreen splash(this);
		splash.DoModal();
	}

	if (!SetTimer(INIT_TIMER_ID,300,NULL))
		AfxMessageBox(GetResString(IDS_ERR_FAILEDTIMER));

//	Set proper Scheduler Shift if option is set
	if (g_eMuleApp.m_pGlobPrefs->IsSCHEnabled())
	{
		CTime curr_t = CTime::GetCurrentTime();
		uint32 secs = curr_t.GetSecond() + 60*curr_t.GetMinute() + 60*60*curr_t.GetHour();
		bool bShift1;

		if (g_eMuleApp.m_pGlobPrefs->GetSCHShift1() > g_eMuleApp.m_pGlobPrefs->GetSCHShift2())
		{
			if (secs > g_eMuleApp.m_pGlobPrefs->GetSCHShift1())
				bShift1 = true;
			else if (secs < g_eMuleApp.m_pGlobPrefs->GetSCHShift2())
				bShift1 = true;
			else
				bShift1 = false;
		}
		else
		{
			if (secs > g_eMuleApp.m_pGlobPrefs->GetSCHShift1() && secs < g_eMuleApp.m_pGlobPrefs->GetSCHShift2())
				bShift1 = true;
			else
				bShift1 = false;
		}

		if(bShift1)
		{
		//	Switching to Shift1 speeds
			g_eMuleApp.m_pUploadQueue->SCHShift1UploadCheck();
			g_eMuleApp.m_pGlobPrefs->SetMaxUpload(g_eMuleApp.m_pGlobPrefs->GetSCHShift1Upload());
			g_eMuleApp.m_pGlobPrefs->SetMaxDownload(g_eMuleApp.m_pGlobPrefs->GetSCHShift1Download());
			g_eMuleApp.m_pGlobPrefs->SetMaxConnections(g_eMuleApp.m_pGlobPrefs->GetSCHShift1conn());
			g_eMuleApp.m_pGlobPrefs->SetMaxDownloadConperFive(g_eMuleApp.m_pGlobPrefs->GetSCHShift15sec());

			CString MessageText;
			MessageText.Format( _T("SCHEDULER: switching to Shift 1 (Max Upload:%i Max Download:%i Max Connections:%i Max In 5 secs:%i)"),
								g_eMuleApp.m_pGlobPrefs->GetSCHShift1Upload(),
								g_eMuleApp.m_pGlobPrefs->GetSCHShift1Download(),
								g_eMuleApp.m_pGlobPrefs->GetSCHShift1conn(),
								g_eMuleApp.m_pGlobPrefs->GetSCHShift15sec() );
			g_eMuleApp.AddDebugLogLine(false, MessageText);
		}
		else
		{
            int dayOfWeek = curr_t.GetDayOfWeek();

			if ((dayOfWeek==2 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptMon())
				|| (dayOfWeek==3 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptTue())
				|| (dayOfWeek==4 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptWed())
				|| (dayOfWeek==5 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptThu())
				|| (dayOfWeek==6 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptFri())
				|| (dayOfWeek==7 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptSat())
				|| (dayOfWeek==1 && g_eMuleApp.m_pGlobPrefs->IsSCHExceptSun()))
           	{
               	g_eMuleApp.AddDebugLogLine(false, CString("SCHEDULER: day excepted!"));
			}
			else
			{
			//	Switching to Shift2 speeds
				g_eMuleApp.m_pUploadQueue->SCHShift2UploadCheck();
				g_eMuleApp.m_pGlobPrefs->SetMaxUpload(g_eMuleApp.m_pGlobPrefs->GetSCHShift2Upload());
				g_eMuleApp.m_pGlobPrefs->SetMaxDownload(g_eMuleApp.m_pGlobPrefs->GetSCHShift2Download());
				g_eMuleApp.m_pGlobPrefs->SetMaxConnections(g_eMuleApp.m_pGlobPrefs->GetSCHShift2conn());
				g_eMuleApp.m_pGlobPrefs->SetMaxDownloadConperFive(g_eMuleApp.m_pGlobPrefs->GetSCHShift25sec());

				CString MessageText;
				MessageText.Format( _T("SCHEDULER: switching to Shift 2 (Max Upload:%i Max Download:%i Max Connections:%i Max In 5 secs:%i)"),
									g_eMuleApp.m_pGlobPrefs->GetSCHShift2Upload(),
									g_eMuleApp.m_pGlobPrefs->GetSCHShift2Download(),
									g_eMuleApp.m_pGlobPrefs->GetSCHShift2conn(),
									g_eMuleApp.m_pGlobPrefs->GetSCHShift25sec() );
				g_eMuleApp.AddDebugLogLine(false, MessageText);
			}
		}
	}

	return TRUE;

	EMULE_CATCH2

	return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnTimer(UINT_PTR nIDEvent)
{
	EMULE_TRY

	if (nIDEvent == INIT_TIMER_ID)
	{
		switch (m_iStatus)
		{
			case 0:	// State 0 - 300ms after InitDialog()
				m_iStatus++;
				m_bReady = true;
				g_eMuleApp.m_pSharedFilesList->SetOutputCtrl(&m_wndSharedFiles.m_ctlSharedFilesList);
				break;

			case 1:	// State 1 - 300ms after the end of State 0
				m_iStatus++;
				g_eMuleApp.m_pServerList->Init();
				break;

			case 2:	// State 2 - 300ms after the server list is init'ed.
				KillTimer(nIDEvent);
				m_iStatus++;
			//	Read in all the .met files and make them available for sharing
				g_eMuleApp.m_pDownloadQueue->Init();
#ifdef OLD_SOCKETS_ENABLED
				if (!g_eMuleApp.m_pListenSocket->StartListening())
					AddLogLine(false, RGB_LOG_ERROR + GetResString(IDS_MAIN_SOCKETERROR), g_eMuleApp.m_pGlobPrefs->GetPort());
				if (!g_eMuleApp.m_pClientUDPSocket->Create())
			   		AddLogLine(false, RGB_LOG_ERROR + GetResString(IDS_MAIN_SOCKETERROR), g_eMuleApp.m_pGlobPrefs->GetUDPPort());
#endif //OLD_SOCKETS_ENABLED

			//	display own userhash
				AddLogLine(false, _T("%s: %s"), GetResString(IDS_INFLST_USER_USERHASH), HashToString(g_eMuleApp.m_pGlobPrefs->GetUserHash()));

			//	display eMule Plus version
				AddLogLine(true, IDS_MAIN_READY, CURRENT_VERSION_LONG);

			//	Display used optimization
				UINT		dwResStrId;

				switch (get_cpu_type())
				{
					case 1:
						dwResStrId = IDS_OPTIMIZATION_NO;
						break;
					case 2:
						dwResStrId = IDS_OPTIMIZATION_MMX;
						break;
					case 3:
						dwResStrId = IDS_OPTIMIZATION_AMD;
						break;
					case 4:
					case 5:
						dwResStrId = IDS_OPTIMIZATION_SSE;
						break;
				}
				AddLogLine(false, GetResString(dwResStrId));

			//	Start server anyway, but you'll get response
			//		only if it's enabled in preferences.
				g_eMuleApp.m_pWebServer->StartServer();

			//	Process ed2k link
				if (g_eMuleApp.m_pstrPendingLink)
				{
					OnWMData(NULL,(LPARAM) &g_eMuleApp.m_sendStruct);
					delete g_eMuleApp.m_pstrPendingLink;
				}

			//	Connect to server
				if (g_eMuleApp.m_pGlobPrefs->DoAutoConnect() && !g_eMuleApp.m_pGlobPrefs->AutoServerlist())
					OnBnClickedButton2();

			//	Get current version from internet, if one week elapsed
			//  Don't put lower elapse value, we don't need DDoS attacks! ;)
			//	(later move this to new engine)
				if(g_eMuleApp.m_pGlobPrefs->IsAutoCheckForNewVersion() &&
					(time(NULL) - g_eMuleApp.m_pGlobPrefs->GetAutoCheckLastTime()) > 7*24*60*60)
				{
					DWORD dwThread = 0;
					HANDLE hThread = CreateThread(NULL, 0, CheckCurrentVersionAtInet, (void *)NULL, 0, &dwThread);
					if (hThread)
						VERIFY(CloseHandle(hThread));
				}

			//	Start one second timer to update session time
				if (SetTimer(INIT_TIMER_ID, 1000, NULL) == 0)
					AfxMessageBox(GetResString(IDS_ERR_FAILEDTIMER));
				break;

			case 3:	// State 3 - 1sec after connect
			//	Show the session time in the status bar once a second.
				ShowSessionTime();
				break;

			default:
				AddDebugLogLine(true,_T("Timer called with no reason"));
		}
	}
	CTrayDialog::OnTimer(nIDEvent);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	EMULE_TRY

	switch(nID & 0xFFF0)
	{
		case IDM_ABOUTBOX:
		{
			CAboutDlg		dlgAbout;

			dlgAbout.DoModal();
			break;
		}
		case SC_CLOSE:
			if(g_eMuleApp.m_pGlobPrefs->GetCloseToTray())
			{
				TrayShow();
				ShowWindow(SW_HIDE);
			}
			else
				CTrayDialog::OnSysCommand(nID, lParam);
			break;
		//v- eklmn: bugfix(12): improved output in m_ctlStatusBar (update only tray or window)
		case SC_MINIMIZE:
		case SC_MINIMIZETRAY:
		case SC_RESTORE:
		case SC_MAXIMIZE:
			CTrayDialog::OnSysCommand(nID, lParam);
			ShowTransferRate(true);
			break;
		//^- eklmn: bugfix(12): improved output in m_ctlStatusBar (update only tray or window)
		default:
			CTrayDialog::OnSysCommand(nID, lParam);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnPaint()
{
	EMULE_TRY

	if (!m_bStartUpMinimized)
	{
		m_bStartUpMinimized=true;

		if (g_eMuleApp.m_pGlobPrefs->GetStartMinimized())
			OnCancel();
	}

	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CTrayDialog::OnPaint();
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
HCURSOR CEmuleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnBnClickedButton2()
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pServerConnect->IsConnected())
	{
	// Connect if not currently connected
		if (!g_eMuleApp.m_pServerConnect->IsConnecting())
			StartConnection();
		else
		{
			g_eMuleApp.m_pServerConnect->StopConnectionTry();
			ShowConnectionState(false);
		}
	}
	else
	// Disconnect if currently connected
		CloseConnection();
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OutputLogText(const CString& strLogText, bool bDebug)
{
	EMULE_TRY

	CString strLine = strLogText;
	CString strPart;
	long iTagStart, iTagEnd, iIndex, iRed, iGreen, iBlue;
	COLORREF crColor = GetSysColor(COLOR_WINDOWTEXT);

	while( strLine != _T("") )
	{
		iTagStart = strLine.Find(_T("<COLOR="));
		iTagEnd = strLine.Find(_T('>'));
		if (( iTagStart != -1 ) && ( iTagEnd != -1 ))
		{
			bool bColorFound = false;
			COLORREF crNewColor = crColor;
			strPart = strLine.Mid(iTagStart + 7, iTagEnd - iTagStart - 7);
			if (strPart != _T(""))
			{
				if (strPart == _T("Default"))
				{
					crNewColor = GetSysColor(COLOR_WINDOWTEXT);
					bColorFound = true;
				}
				else
				{
					iIndex = strPart.Find(_T(','));
					if (iIndex != -1)
					{
						iRed = _tstoi(strPart.Left(iIndex));
						strPart.Delete(0, iIndex + 1);
						iIndex = strPart.Find(_T(','));
						if (iIndex != -1)
						{
							iGreen = _tstoi(strPart.Left(iIndex));
							strPart.Delete(0, iIndex + 1);
							iBlue = _tstoi(strPart);
							crNewColor = RGB(iRed, iGreen, iBlue);
							bColorFound = true;
						}
					}
				}
			}
			if (bColorFound)
			{
				if (iTagStart > 0)
				{
					strPart = strLine.Left(iTagStart);
					if (bDebug)
						m_wndServer.debugbox->AppendText(strPart, crColor);
					else
						m_wndServer.logbox->AppendText(strPart, crColor);
				}
				crColor = crNewColor;
				strLine.Delete(0, iTagEnd + 1);
			}
		}
		else
		{
			if (bDebug)
				m_wndServer.debugbox->AppendText(strLine, crColor);
			else
				m_wndServer.logbox->AppendText(strLine, crColor);
			strLine = _T("");
		}
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::AddLogText(bool addtostatusbar,const CString& txt, bool bDebug)
{
	EMULE_TRY

	CString strCleanLine = txt;
	int iTagStart = 0;
	while( iTagStart != -1 )
	{
		iTagStart = strCleanLine.Find(_T("<COLOR="), iTagStart);
		if ( iTagStart != -1 )
		{
			int iTagEnd = strCleanLine.Find(_T('>'), iTagStart + 7);
			if ( iTagEnd != -1 )
				strCleanLine.Delete(iTagStart, iTagEnd - iTagStart + 1);
		}
	}

	if (addtostatusbar)
	{
		if (m_ctlStatusBar.m_hWnd && g_eMuleApp.m_app_state != CEmuleApp::APP_STATE_SHUTINGDOWN)
		{
			m_ctlStatusBar.SetText(strCleanLine,SB_MESSAGETEXT,0);
			m_ctlStatusBar.SetTipText(SB_MESSAGETEXT,strCleanLine);
		}
		else
			AfxMessageBox(strCleanLine);
	}

	CString strLogLine = txt;

	strLogLine.Remove(_T('\r'));
	strLogLine.TrimRight(_T('\n'));
	strLogLine.TrimRight(_T(' '));
	strLogLine.TrimLeft(_T('\n'));
	if (strLogLine.GetLength() > 0)
	{
		COleDateTime		currentTime(COleDateTime::GetCurrentTime());
		CString			strLogLine2, strTime = currentTime.Format();

		strTime += _T(": ");
		strLogLine2.Format(_T("%s%s%s%s\n"), RGB_DARK_BLUE, strTime, RGB_DEFAULT, strLogLine);
		
		//save to file
		if (g_eMuleApp.m_pGlobPrefs->LogToFile())
		{
			FILE *LogFile = _tfopen((bDebug) ? m_strDebugLogFilePath : m_strLogFilePath, "a");
			
			if (LogFile != NULL)
			{
				strTime += strCleanLine;
				strTime += _T('\n');
				_fputts(strTime, LogFile);
				fclose(LogFile);
			}
		}
		// only when data save to file output them into GUI
		if (bDebug)
		{
			if(::IsWindow(m_wndServer.m_ctrlBoxSwitcher.m_hWnd))
			{
				if (m_astrMissedDebugLogLines.GetSize() > 0)
				{
					for (int i = 0; i < m_astrMissedDebugLogLines.GetSize(); i++)
						OutputLogText(m_astrMissedDebugLogLines[i], bDebug);
					m_astrMissedDebugLogLines.RemoveAll();
				}
				OutputLogText(strLogLine2, bDebug);
				if(m_wndServer.m_ctrlBoxSwitcher.GetCurSel() != 2)
					m_wndServer.m_ctrlBoxSwitcher.SetItemState(2, TCIS_HIGHLIGHTED, TCIS_HIGHLIGHTED);
			}
			else
				m_astrMissedDebugLogLines.Add(strLogLine2);
		}
		else
		{
			if(::IsWindow(m_wndServer.m_ctrlBoxSwitcher.m_hWnd))
			{
				if (m_astrMissedLogLines.GetSize() > 0)
				{
					for (int i = 0; i < m_astrMissedLogLines.GetSize(); i++)
						OutputLogText(m_astrMissedLogLines[i], bDebug);
					m_astrMissedLogLines.RemoveAll();
				}
				OutputLogText(strLogLine2, bDebug);
				if(m_wndServer.m_ctrlBoxSwitcher.GetCurSel() != 0)
					m_wndServer.m_ctrlBoxSwitcher.SetItemState(0, TCIS_HIGHLIGHTED, TCIS_HIGHLIGHTED);
			}
			else
				m_astrMissedLogLines.Add(strLogLine2);
			ShowNotifier(strCleanLine, TBN_LOG, false, g_eMuleApp.m_pGlobPrefs->GetUseLogNotifier());
		}
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::AddServerMessageLine(LPCTSTR line)
{
	EMULE_TRY

	CString strLine = line;

	strLine.Remove(_T('\r'));
	strLine.TrimRight(_T('\n'));
	strLine.TrimRight(_T(' '));
	strLine.TrimLeft(_T('\n'));
	if ((strLine.GetLength() > 0) && (::IsWindow(m_wndServer.m_ctrlBoxSwitcher.m_hWnd)))
	{
		COleDateTime	currentTime(COleDateTime::GetCurrentTime());
		CString			strTime = currentTime.Format();

		strTime += _T(": ");
		m_wndServer.m_pctlServerMsgBox->AppendText(strTime, RGB(0,0,128));
		strLine += _T('\n');
		m_wndServer.m_pctlServerMsgBox->AppendText(strLine);
		if(m_wndServer.m_ctrlBoxSwitcher.GetCurSel() != 1)
			m_wndServer.m_ctrlBoxSwitcher.SetItemState(1, TCIS_HIGHLIGHTED, TCIS_HIGHLIGHTED);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::AddBugReport(LPCTSTR strFunctionName, LPCTSTR sFile, long nLine, CString msg)
{
	EMULE_TRY

	if(g_eMuleApp.m_pGlobPrefs->GetBugReport())
	{
		CString sOut;

		sOut.Format(_T("%s%s: EXCEPTION! (%s) Report to eMule Plus developers. Line %ld in file %s"),
			RGB_LOG_ERROR, strFunctionName, msg, nLine, sFile);
		AddDebugLogLine(false, sOut);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowConnectionState()
{
#ifdef OLD_SOCKETS_ENABLED
	ShowConnectionState( g_eMuleApp.m_pServerConnect->IsConnected() ,_T(""));
#endif //OLD_SOCKETS_ENABLED
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowConnectionState(bool bConnected)
{
	ShowConnectionState(bConnected,_T(""));
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowConnectionState(bool bConnected, CString server,bool iconOnly)
{
	EMULE_TRY

	if(g_eMuleApp.m_app_state == g_eMuleApp.APP_STATE_SHUTINGDOWN)
		return;

	if (bConnected)
	{
		TCHAR szBuf[200];
		_stprintf(szBuf, _T("%s"), GetResString(IDS_MAIN_BTN_DISCONNECT));
		LPTSTR pszBuf;
		TBBUTTONINFO tbi;
		LPTBBUTTONINFO lptbbi;
		pszBuf = szBuf;
		lptbbi = &tbi;
		tbi.dwMask = TBIF_IMAGE | TBIF_TEXT;
		tbi.cbSize = sizeof (TBBUTTONINFO);
		tbi.iImage = 9;
		tbi.pszText = pszBuf;
		tbi.cchText = sizeof (szBuf);
		m_ctlToolBar.SetButtonInfo(IDC_TOOLBARBUTTON+0, lptbbi);
		//TOOLTIP: GetResString(IDS_MAIN_BTN_DISCONNECT_TOOLTIP)
		m_ctlToolBar.AutoSize();

#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsLowID())
			m_ctlStatusBar.SetIcon(SB_SERVER,m_hiconConn[1]);
		 else
			m_ctlStatusBar.SetIcon(SB_SERVER,m_hiconConn[2]);
#endif //OLD_SOCKETS_ENABLED

		if (!iconOnly) {
			m_ctlStatusBar.SetText(GetResString(IDS_MAIN_CONNECTEDTO) + _T(' ') + CString(server),SB_MESSAGETEXT,0);
			m_ctlStatusBar.SetTipText(SB_MESSAGETEXT,m_ctlStatusBar.GetText(0));
			m_ctlStatusBar.SetTipText(SB_SERVER,server);
			m_ctlStatusBar.SetText(server,SB_SERVER,0);
		}
	}
	else
	{
#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsConnecting())
		{
			TCHAR szBuf[200];
			_stprintf(szBuf, _T("%s"), GetResString(IDS_MAIN_BTN_CANCEL));
			LPTSTR pszBuf;
			TBBUTTONINFO tbi;
			LPTBBUTTONINFO lptbbi;
			pszBuf = szBuf;
			lptbbi = &tbi;
			tbi.dwMask = TBIF_IMAGE | TBIF_TEXT;
			tbi.cbSize = sizeof (TBBUTTONINFO);
			tbi.iImage = 10;
			tbi.pszText = pszBuf;
			tbi.cchText = sizeof (szBuf);
			m_ctlToolBar.SetButtonInfo(IDC_TOOLBARBUTTON+0, lptbbi);
			//TOOLTIP: GetResString(IDS_MAIN_BTN_CONNECT_TOOLTIP)

			m_ctlStatusBar.SetIcon(SB_SERVER,m_hiconConn[0]);
			if (!iconOnly) {
				m_ctlStatusBar.SetText(GetResString(IDS_CONNECTING),SB_SERVER,0);
				m_ctlStatusBar.SetTipText(SB_SERVER,_T(""));
			}
			ShowUserCount(0,0);

		}
		else
		{
			TCHAR szBuf[200];
			_stprintf(szBuf, _T("%s"), GetResString(IDS_MAIN_BTN_CONNECT));
			LPTSTR pszBuf;
			TBBUTTONINFO tbi;
			LPTBBUTTONINFO lptbbi;
			pszBuf = szBuf;
			lptbbi = &tbi;
			tbi.dwMask = TBIF_IMAGE | TBIF_TEXT;
			tbi.cbSize = sizeof (TBBUTTONINFO);
			tbi.iImage = 0;
			tbi.pszText = pszBuf;
			tbi.cchText = sizeof (szBuf);
			m_ctlToolBar.SetButtonInfo(IDC_TOOLBARBUTTON+0, lptbbi);
			//TOOLTIP: GetResString(IDS_CONNECTTOANYSERVER)
			//m_ctlToolBar.AutoSize();

			m_ctlStatusBar.SetIcon(SB_SERVER,m_hiconConn[0]);
			if (!iconOnly) {
				m_ctlStatusBar.SetText(GetResString(IDS_NOTCONNECTED),SB_SERVER,0);
				AddLogLine(false, IDS_DISCONNECTED);
				m_ctlStatusBar.SetTipText(SB_SERVER,_T(""));
			}
			ShowUserCount(0,0);
		}
#endif //OLD_SOCKETS_ENABLED

	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowSessionTime()
{
	uint32		dwRunTimeSecs = static_cast<uint32>((::GetTickCount() - g_eMuleApp.stat_starttime) / 1000);
	CTimeSpan	runTime(static_cast<__time64_t>(dwRunTimeSecs));
	CString		strBuffer;
	unsigned	uiDays, uiHours, uiMinutes;

	uiHours = static_cast<unsigned>(runTime.GetHours());
	uiMinutes = static_cast<unsigned>(runTime.GetMinutes());
	uiDays = static_cast<unsigned>(runTime.GetDays());

	if (uiDays == 0)
	{
		strBuffer.Format("%02u:%02u:%02u", uiHours, uiMinutes, runTime.GetSeconds());
	}
	else
	{
		strBuffer.Format( "%2u %s %02u:%02u", uiDays,
			GetResString((uiDays == 1) ? IDS_LONGDAY : IDS_LONGDAYS), uiHours, uiMinutes );
	}

	m_ctlStatusBar.SetText(strBuffer, SB_SESSIONTIME, 0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowUserCount(uint32 users_toshow, uint32 files_toshow)
{
	EMULE_TRY

	if(g_eMuleApp.m_app_state == g_eMuleApp.APP_STATE_SHUTINGDOWN)
		return;

	uint32 totaluser, totalfile;
	totaluser = totalfile = 0;
	if( users_toshow || files_toshow )
	 	g_eMuleApp.m_pServerList->GetUserFileStatus( totaluser, totalfile );
	CString sBuffer; // kuchin
	sBuffer.Format(_T("%u                                "),users_toshow);		//Cax2 spaces needed to activate tooltip
	m_ctlStatusBar.SetText(sBuffer,SB_NUMUSERS,0);
#ifdef OLD_SOCKETS_ENABLED
	if(g_eMuleApp.m_pServerConnect->IsConnected())
	{
		sBuffer.Format(_T("%s: %u (%s) | %s: %u (%s)"), GetResString(IDS_UUSERS), users_toshow, CastItoIShort(totaluser), GetResString(IDS_FILES), files_toshow, CastItoIShort(totalfile));
		m_ctlStatusBar.SetTipText(SB_NUMUSERS,sBuffer);
	} else {
		m_ctlStatusBar.SetTipText(SB_NUMUSERS,GetResString(IDS_STATS_WAITCONN));
	}
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowMessageState(byte iconnr)
{
	EMULE_TRY

	m_ctlStatusBar.SetIcon(SB_MESSAGESTATUS,m_hiconIM[iconnr]);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//v- eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
void CEmuleDlg::ShowTransferRate(bool bUpdateAll)
{
	EMULE_TRY

	CString sBuffer, sUpload, sDownload;

	//Cax2 - more detailed upload speed: 5 sec average instead of 40 sec average....
	// eklmn: calculate only once
	double lastuprate_kB = static_cast<double>(g_eMuleApp.m_pUploadQueue->GetDataRateShown())/1024.0;
	double lastdownrate_kB = static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDataRate())/1024.0;

	double lastuprateoverhead_kB = static_cast<double>(g_eMuleApp.m_pUploadQueue->GetUpDataRateOverhead())/1024.0;
	double lastdownrateoverhead_kB = static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDownDataRateOverhead())/1024.0;

	//string preparation doesn't depend on output
	if (g_eMuleApp.m_pGlobPrefs->ShowOverhead()) {
		sBuffer.Format(GetResString(IDS_UPDOWNLONG),lastuprate_kB, lastuprateoverhead_kB, lastdownrate_kB, lastdownrateoverhead_kB);
		sUpload.Format(_T("%.2f (%.2f)"),lastuprate_kB, lastuprateoverhead_kB);
		sDownload.Format(_T("%.2f (%.2f)"),lastdownrate_kB, lastdownrateoverhead_kB);
	}
	else {
		sBuffer.Format(GetResString(IDS_UPDOWN),lastuprate_kB, lastdownrate_kB);
		sUpload.Format(_T("%.2f"),lastuprate_kB);
		sDownload.Format(_T("%.2f"),lastdownrate_kB);
	}

	// set SpeedMeterValues if option is activated
	if(g_eMuleApp.m_pGlobPrefs->GetShowToolbarSpeedMeter())
		m_ctlToolBar.SetSpeedMeterValues((int)lastuprate_kB, (int)lastdownrate_kB);

	// update window only
	if( IsWindowVisible() || bUpdateAll) {
		m_ctlStatusBar.SetText(sUpload,SB_UPLOADRATE,0);
		m_ctlStatusBar.SetText(sDownload,SB_DOWNLOADRATE,0);
		m_ctlStatusBar.SetIcon(SB_UPLOADRATE,m_hiconTrans[(lastuprate_kB)?1:0]);
		m_ctlStatusBar.SetIcon(SB_DOWNLOADRATE,m_hiconTrans[(lastdownrate_kB)?3:2]);

		m_wndTransfer.UpdateDownloadHeader();
		m_wndTransfer.UpdateUploadHeader();
	}

	// update tray only
	if(TrayIsVisible() || bUpdateAll) {
		// set trayicon-icon
		int iMaxValue = g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate();
		if(iMaxValue < g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate())
			iMaxValue = g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate();

		int DownRateProcent = (int)ceil((lastdownrate_kB*100)/g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate());
		if (DownRateProcent>100) DownRateProcent=100;

/*		// DbT:ShowServer (&SyruS)
		CString sServer;
#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsConnecting())
			sServer = GetResString(IDS_CONNECTING);
		else if (g_eMuleApp.m_pServerConnect->IsConnected())
			sServer.Format(_T("%s: %s"),GetResString(IDS_SERVER),g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetListName());
		else
			sServer = GetResString(IDS_NOTCONNECTED);
#endif //OLD_SOCKETS_ENABLED

		if(sServer.GetLength() >= 38) sServer= sServer.Left(35) + _T("...");
		// Workaround problem with tooltip on Win9x
		if(!(LOBYTE(g_eMuleApp.m_pGlobPrefs->GetWindowsVersion()) == 0x04))
			sServer.Append(_T("\n")+sBuffer);
		else
			sServer.Append(_T(" | ")+sBuffer);
		// DbT:End

		TraySetToolTip(sServer);
*/
		TraySetToolTip(sBuffer);

		//eklmn: it's better to do TrayUpdate here, cause of TrayToolTip
		UpdateTrayIcon(DownRateProcent);
	}
	if (!TrayIsVisible() && g_eMuleApp.m_pGlobPrefs->ShowRatesOnTitle())
	{
		CString		strTitle;

		strTitle.Format(_T("(U:%.1f D:%.1f) eMule Plus v") CURRENT_VERSION_LONG, lastuprate_kB, lastdownrate_kB);
		SetWindowText(strTitle);
	}

	EMULE_CATCH2
}
// ^-eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnCancel()
{
	EMULE_TRY

	if (g_eMuleApp.m_pGlobPrefs->DoMinToTray())
	{
		TrayShow();
		ShowWindow(SW_HIDE);
	}
	else
	{
		ShowWindow(SW_MINIMIZE);
	}

	ShowTransferRate(); //eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::SetActiveDialog(CDialog* dlg)
{
	EMULE_TRY

	if(dlg == m_pdlgActive)
		return;
	m_pdlgActive->ShowWindow(SW_HIDE);
	dlg->ShowWindow(SW_SHOW);
	dlg->SetFocus();
	m_pdlgActive = dlg;
	if (dlg==&m_wndTransfer)
 	{
		m_wndTransfer.UpdateCatTabTitles();
		m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+2);
	}
	else if (dlg==&m_wndServer) m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+1);
	else if (dlg==&m_dlgSearch) m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+3);
	else if (dlg==&m_wndSharedFiles) m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+4);
	else if (dlg==&m_wndChat) {m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+5); g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.ShowChat();}
	else if (dlg==&m_wndIRC) m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+6);
	else if (dlg==&m_dlgStatistics) {m_ctlToolBar.PressMuleButton(IDC_TOOLBARBUTTON+7);m_dlgStatistics.ShowStatistics();}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnSize(UINT nType,int cx,int cy)
{
	EMULE_TRY

	CTrayDialog::OnSize(nType,cx,cy);
	ResizeStatusBar();

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ResizeStatusBar()
{
	CRect rect;
	m_ctlStatusBar.GetClientRect(&rect);

	int		iWidths[SB_NUMSBPARTS] =
	{
		0,105,22,70,70,70,260,
	};

	int		iRightEdges[SB_NUMSBPARTS];

	if (g_eMuleApp.m_pGlobPrefs->ShowOverhead())
	{
		iWidths[SB_UPLOADRATE] = 105;
		iWidths[SB_DOWNLOADRATE] = 105;
		iWidths[SB_SERVER] = 190;
	}
//
//	Calculate the right edges given the widths
	iRightEdges[SB_NUMSBPARTS-1] = -1;	//Indicates right edge of the status bar
	iRightEdges[SB_NUMSBPARTS-2] = rect.right - iWidths[SB_NUMSBPARTS-1];
	for (int i = SB_NUMSBPARTS-3; i >= 0; i--)
	{
		iRightEdges[i] = iRightEdges[i+1] - iWidths[i+1];
	}
//	Set the status bar part sizes
	m_ctlStatusBar.SetParts(SB_NUMSBPARTS, iRightEdges);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWMData(WPARAM wParam,LPARAM lParam)
{
	EMULE_TRY

	tagCOPYDATASTRUCT* data = (tagCOPYDATASTRUCT*)lParam;
	if (data->dwData == OP_ED2KLINK)
	{
		FlashWindow(true);
		if(g_eMuleApp.m_pGlobPrefs->IsBringToFront())
		{
			if (IsIconic())
			{
				ShowWindow(SW_SHOWNORMAL);
			}
			else if (TrayHide())
			{
				ShowWindow(SW_SHOW);
			}
			else
			{
				SetForegroundWindow();
			}
		}
		try
		{
			CString link2;
			link2 = CString((char*)data->lpData,data->cbData);
			link2.Replace(_T("%7c"),_T("|"));
			CString link(URLDecode(link2));
			CED2KLink* pLink = CED2KLink::CreateLinkFromUrl(link);
			_ASSERT( pLink != NULL );
			switch (pLink->GetKind())
			{
				case CED2KLink::kFile:
				{
					CED2KFileLink* pFileLink = pLink->GetFileLink();
					_ASSERT(pFileLink != NULL);
					g_eMuleApp.m_pDownloadQueue->AddFileLinkToDownload(pFileLink);
					break;
				}
				case CED2KLink::kServerList:
				{
					CED2KServerListLink* pListLink = pLink->GetServerListLink();
					_ASSERT( pListLink != NULL );
					CString strAddress = pListLink->GetAddress();
					if(strAddress.GetLength() != 0)
						g_eMuleApp.m_pdlgEmule->m_wndServer.UpdateServerMetFromURL(strAddress);
					break;
				}
				case CED2KLink::kServer:
				{
					CString defName;
					CED2KServerLink* pSrvLink = pLink->GetServerLink();
					_ASSERT( pSrvLink != NULL );
					CServer* pSrv = new CServer(pSrvLink->GetPort(),pSrvLink->GetIP());		// netwolf 07.05.03 support non-ip ed2k server link
					_ASSERT( pSrv != NULL );
					pSrvLink->GetDefaultName(defName);
					pSrv->SetListName(defName.GetBuffer());

					// Barry - Default all new servers to high priority
					pSrv->SetPreference(CServer::SERVERPRIORITY_HIGH);

					if (!g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.AddServer(pSrv,true))
						delete pSrv;
					else
						AddLogLine(true, GetResString(IDS_SERVERADDED), pSrv->GetListName());
					break;
				}
				default:
					break;
			}
			delete pLink;
		}
		catch(...)
		{
			OUTPUT_DEBUG_TRACE();
			AddLogLine(true, IDS_LINKNOTADDED);
		}
	}
	else if (data->dwData==OP_CLCOMMAND)
	{
		// command line command received
		CString clcommand;
		clcommand= (char*)data->lpData;
		clcommand.MakeLower();
		AddLogLine(true, _T("CLI: %s"),clcommand);

		if (clcommand=="connect")
		{
			StartConnection();
			return true;
		}
#ifdef OLD_SOCKETS_ENABLED
		if (clcommand=="disconnect")
		{
			g_eMuleApp.m_pServerConnect->Disconnect();
			return true;
		}
#endif //OLD_SOCKETS_ENABLED
		if (clcommand=="resume")
		{
			g_eMuleApp.m_pDownloadQueue->StartNextFile(CCat::GetAllCatType());
			return true;
		}
		if (clcommand=="exit")
		{
			OnClose();
			return true;
		}
		if (clcommand=="reload")
		{
			g_eMuleApp.m_pSharedFilesList->Reload();
			return true;
		}
		if (clcommand=="restore")
		{
			RestoreWindow();
			return true;
		}
		if (clcommand=="preferences")
		{
			g_eMuleApp.m_pGlobPrefs->Save();
			return true;
		}
		if (clcommand.Left(7).MakeLower()=="limits=" && clcommand.GetLength()>8)
		{
			CString	down=_T("");
			CString	up=clcommand.Mid(7);

			int pos=up.Find(',');
			if (pos>0)
			{
				down=up.Mid(pos+1);
				up=up.Left(pos);
			}
			if (down.GetLength() > 0)
				g_eMuleApp.m_pGlobPrefs->SetMaxDownload(_tstoi(down));
			if (up.GetLength() > 0)
				g_eMuleApp.m_pGlobPrefs->SetMaxUpload(_tstoi(up));

			return true;
		}

		if (clcommand == "help" || clcommand == "/?")
		{
			// show usage
			return true;
		}

		if (clcommand == "status")
		{
			CString	pString;

			// todo: output to console

			pString.Format(_T("%sstatus.log"),g_eMuleApp.m_pGlobPrefs->GetAppDir());
			FILE* file = _tfopen(pString , _T("w"));

#ifdef OLD_SOCKETS_ENABLED
			if (g_eMuleApp.m_pServerConnect->IsConnected())
				pString = GetResString(IDS_CONNECTED);
			else if (g_eMuleApp.m_pServerConnect->IsConnecting())
				pString = GetResString(IDS_CONNECTING);
			else
				pString = GetResString(IDS_DISCONNECTED);
#else
			pString = _T("");
#endif //OLD_SOCKETS_ENABLED

			pString += _T('\n');
			pString.AppendFormat(GetResString(IDS_UPDOWN), static_cast<double>(g_eMuleApp.m_pUploadQueue->GetDataRate())/1024.0, static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDataRate())/1024.0);

			_ftprintf(file, _T("%s\n%s"), pString, g_eMuleApp.m_pDownloadList->GetPartFilesStatusString());

			fclose(file);
			return true;
		}
		// show "unknown command";
	}
	return true;

	EMULE_CATCH2

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnFileHashed(WPARAM wParam,LPARAM lParam)
{
	EMULE_TRY

	CKnownFile	   *pNewKnownFile = reinterpret_cast<CKnownFile*>(lParam);

	if (wParam != 0)
	{
		CPartFile	   *pPartFile = reinterpret_cast<CPartFile*>(wParam);

		pPartFile->PartFileHashFinished(pNewKnownFile);
	}
	else
	{
		if (m_iFilesToBeHashed > 0)
			m_iFilesToBeHashed--;

		g_eMuleApp.m_pSharedFilesList->m_pKnownFileList->SafeAddKnownFile(pNewKnownFile);
		g_eMuleApp.m_pSharedFilesList->SafeAddKnownFile(pNewKnownFile);
		AddLogLine(false, RGB_LOG_DIMMED + GetResString(IDS_HASBEENHASHED), pNewKnownFile->GetFileName(), m_iFilesToBeHashed);
	}
	return true;

	EMULE_CATCH2;

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnClose()
{
	EMULE_TRY

	if ( (g_eMuleApp.m_app_state == g_eMuleApp.APP_STATE_RUNNING) &&
		g_eMuleApp.m_pGlobPrefs->IsConfirmExitEnabled() &&
		( IDNO == MessageBox( GetResString(IDS_MAIN_EXIT), GetResString(IDS_MAIN_EXITTITLE),
		MB_YESNO | MB_DEFBUTTON2 ) ) )
	{
		return;
	}
	// we should call this before changing the state to APP_STATE_SHUTINGDOWN because
	// otherwise any log message inside this function (and there are few) will produce
	// message box
#ifdef OLD_SOCKETS_ENABLED
	if ( g_eMuleApp.m_pServerConnect->IsConnected() )
		g_eMuleApp.m_pServerConnect->Disconnect();
#endif //OLD_SOCKETS_ENABLED

	g_eMuleApp.m_app_state = g_eMuleApp.APP_STATE_SHUTINGDOWN;

	g_eMuleApp.OnlineSig(); // Added By Bouc7

	WINDOWPLACEMENT wp;wp.length=sizeof(wp);GetWindowPlacement(&wp);
	g_eMuleApp.m_pGlobPrefs->SetWindowLayout(wp);

//sometimes application closing is long process....
	ShowWindow(SW_HIDE);

    // obaldin: disable redraws while shutting down
    // should take care of some crashes on exit
	m_wndTransfer.m_ctlDownloadList.SetRedraw(false);
	m_wndTransfer.m_ctlUploadList.SetRedraw(false);
	m_wndTransfer.m_ctlQueueList.SetRedraw(false);
	m_wndTransfer.m_ctlClientList.SetRedraw(false);
	m_dlgSearch.m_ctlSearchList.SetRedraw(false);
	m_wndSharedFiles.m_ctlSharedFilesList.SetRedraw(false);
	m_wndIRC.serverChannelList.SetRedraw(false);
	m_wndTransfer.m_ctlInfoList.SetRedraw(false);
	m_wndChat.chatselector.SetRedraw(false);
	m_dlgStatistics.SetRedraw(false);
	m_wndTransfer.SetRedraw(false);
	m_dlgSearch.SetRedraw(false);
	m_wndSharedFiles.SetRedraw(false);
	m_wndIRC.SetRedraw(false);
	m_wndChat.SetRedraw(false);
	//SetRedraw(false);  // is it enough to do only this, or do we need everything before too??

	m_wndTransfer.m_ctlDownloadList.SaveSettings(CPreferences::TABLE_DOWNLOAD);
	m_wndTransfer.m_ctlUploadList.SaveSettings(CPreferences::TABLE_UPLOAD);
	m_wndTransfer.m_ctlQueueList.SaveSettings(CPreferences::TABLE_QUEUE);
	m_wndTransfer.m_ctlClientList.SaveSettings(CPreferences::TABLE_CLIENTLIST);
	m_dlgSearch.m_ctlSearchList.SaveSettings(CPreferences::TABLE_SEARCH);
	m_wndSharedFiles.m_ctlSharedFilesList.SaveSettings(CPreferences::TABLE_SHARED);
	m_wndServer.m_ctlServerList.SaveSettings(CPreferences::TABLE_SERVER);
	m_wndIRC.serverChannelList.SaveSettings(CPreferences::TABLE_IRC);

	g_eMuleApp.m_pGlobPrefs->Add2TotalDownloaded(g_eMuleApp.stat_sessionReceivedBytes);
	g_eMuleApp.m_pGlobPrefs->Add2TotalUploaded(g_eMuleApp.stat_sessionSentBytes);
	g_eMuleApp.m_pGlobPrefs->SetDetailColumnWidth(m_wndTransfer.GetDetailColumnWidth());
	g_eMuleApp.m_pGlobPrefs->Save();

	g_eMuleApp.m_pdlgEmule->m_dlgSearch.SaveSearchStrings();

	// Barry - Restore old registry if required
	if (g_eMuleApp.m_pGlobPrefs->AutoTakeED2KLinks())
		RevertReg();

    // obaldin: do we still need te following? Now that we disable the redraws?
    m_wndSharedFiles.m_ctlSharedFilesList.DeleteAllItems();
    m_wndTransfer.m_ctlClientList.DeleteAllItems();
	m_wndTransfer.m_ctlUploadList.DeleteAllItems();
	m_wndTransfer.m_ctlQueueList.DeleteAllItems();
    m_wndTransfer.m_ctlDownloadList.DeleteAllItems();
	m_wndChat.chatselector.DeleteAllItems();
	m_dlgSearch.m_ctlSearchList.DeleteAllItems();
	m_wndSharedFiles.m_ctlSharedFilesList.DeleteAllItems();

	// All dialog windows created should be destroyed
	m_wndServer.DestroyWindow();
	m_wndTransfer.DestroyWindow();
	m_dlgSearch.DestroyWindow();
	m_wndSharedFiles.DestroyWindow();
	m_wndIRC.DestroyWindow();
	m_wndChat.DestroyWindow();
	m_dlgStatistics.DestroyWindow();

	g_eMuleApp.m_pClientList->DeleteAll();
	g_eMuleApp.m_pKnownFilesList->Save();	//Cax2 - moved here, should avoid crashes when closing & downloading.

	delete g_eMuleApp.m_pFakeCheck; //FakeCheck

	CTrayDialog::OnCancel();

	//N@boleo (Backup feature)
	if (g_eMuleApp.m_pGlobPrefs->GetAutoBackup())
	{
		g_eMuleApp.m_pdlgEmule->RunBackupNow(true);
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnTrayRButtonUp(CPoint pt)
{
	EMULE_TRY

	if(m_pSystrayDlg)
	{
		m_pSystrayDlg->BringWindowToTop();
		return;
	}

	m_pSystrayDlg = new CMuleSystrayDlg(this,pt,
									g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate(),
									g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate(),
									g_eMuleApp.m_pGlobPrefs->GetMaxUpload(),
									g_eMuleApp.m_pGlobPrefs->GetMaxDownload());
	if(m_pSystrayDlg)
	{
		UINT nResult = m_pSystrayDlg->DoModal();
		delete m_pSystrayDlg;
		m_pSystrayDlg = NULL;
		switch(nResult)
		{
			case IDC_TOMAX:
				QuickSpeedOther(MP_QS_UA);
				break;
			case IDC_TOMIN:
				QuickSpeedOther(MP_QS_PA);
				break;
			case IDC_RESTORE:
				RestoreWindow();
				break;
			case IDC_CONNECT:
				StartConnection();
				break;
			case IDC_DISCONNECT:
				CloseConnection();
				break;
			case IDC_EXIT:
				OnClose();
				break;
			case IDC_PREFERENCES:
			{
				static int iOpen = 0;
				if(!iOpen)
				{
					iOpen = 1;
					m_dlgPreferences.DoModal();
					iOpen = 0;
				}
				break;
			}
			default:
				break;
		}
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	StartConnection() initiates a connection attempt to a server.
void CEmuleDlg::StartConnection()
{
	EMULE_TRY

	AddLogLine(true, IDS_CONNECTING);
//	If there's more than one server selected in the server list...
	if (m_wndServer.m_ctlServerList.GetSelectedCount() > 1)
	{
		m_wndServer.m_ctlServerList.PostMessage(WM_COMMAND,MP_CONNECTTO,0L);
	}
	else
	{
#ifdef OLD_SOCKETS_ENABLED
		g_eMuleApp.m_pServerConnect->ConnectToAnyServer();
#endif //OLD_SOCKETS_ENABLED
	}
	ShowConnectionState(false);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::CloseConnection()
{
	EMULE_TRY

	if( !g_eMuleApp.m_pGlobPrefs->IsConfirmDisconnectEnabled() ||
		( MessageBox(GetResString(IDS_BACKUP_SURE), GetResString(IDS_IRC_DISCONNECT),
		MB_ICONQUESTION | MB_YESNO | MB_DEFBUTTON2) == IDYES ) )
	{
#ifdef OLD_SOCKETS_ENABLED
		g_eMuleApp.m_pServerConnect->Disconnect();
#endif //OLD_SOCKETS_ENABLED
		g_eMuleApp.OnlineSig();
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::RestoreWindow()
{
	EMULE_TRY

	if (TrayIsVisible())
		TrayHide();
	ShowWindow(SW_SHOW);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::ShowStatistics()
{
	m_dlgStatistics.ShowStatistics();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::UpdateTrayIcon(int procent)
{
	EMULE_TRY

	//HICON m_hiconMyTray;
	//if (m_hiconMyTray!=NULL) DestroyIcon(m_hiconMyTray);
	// set the limits of where the bar color changes (low-high)
	int pLimits16[1] = {100};

	// set the corresponding color for each level
	COLORREF pColors16[1] = { RGB(1,255,1) };

	// start it up
#ifdef OLD_SOCKETS_ENABLED
	if(g_eMuleApp.m_pServerConnect->IsConnected() && !g_eMuleApp.m_pServerConnect->IsLowID())
		m_trayMeterIcon.Init(m_hiconSourceTray,100,1,1,16,16, RGB(37,97,37));
	else if(g_eMuleApp.m_pServerConnect->IsConnected() && g_eMuleApp.m_pServerConnect->IsLowID())
		m_trayMeterIcon.Init(m_hiconSourceTrayLowID,100,1,1,16,16, RGB(37,97,37));
	else
#endif //OLD_SOCKETS_ENABLED
		m_trayMeterIcon.Init(m_hiconSourceTrayGrey,100,1,1,16,16, RGB(37,97,37));

	// load our limit and color info
	m_trayMeterIcon.SetColorLevels(pLimits16,pColors16,1);

	// generate the icon (destroy these icon using DestroyIcon())
	int pVals16[1] = {procent};

	m_hiconMyTray = m_trayMeterIcon.Create(pVals16);
	ASSERT (m_hiconMyTray != NULL);
	if (m_hiconMyTray)
		TraySetIcon(m_hiconMyTray);
	TrayUpdate();

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CEmuleDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	EMULE_TRY

	CTrayDialog::OnCreate(lpCreateStruct);
	/*if (g_eMuleApp.m_pGlobPrefs->UseSplashScreen()){
		ModifyStyleEx(0,WS_EX_LAYERED);
		SetLayeredWindowAttributes(0, 0, LWA_ALPHA);
	}*/
	return 0;

	EMULE_CATCH2

	return -1;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//START - enkeyDEV(kei-kun) -TaskbarNotifier-
void CEmuleDlg::ShowNotifier(CString Text, int MsgType, bool ForceSoundOFF, bool bMsgEnabled)
{
	EMULE_TRY

	bool ShowIt = false;

	Text.Replace("&", "&&");

    if (bMsgEnabled)
	{
		m_wndTaskbarNotifier.Show(Text, MsgType, 500,g_eMuleApp.m_pGlobPrefs->NotificationDisplayTime());
		ShowIt = true;
	}

    if (g_eMuleApp.m_pGlobPrefs->GetUseSoundInNotifier() && !ForceSoundOFF && ShowIt == true)
        PlaySound(g_eMuleApp.m_pGlobPrefs->GetNotifierWavSoundPath(), NULL, SND_FILENAME | SND_NOSTOP | SND_NOWAIT | SND_ASYNC);

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnTaskbarNotifierClicked(WPARAM wParam,LPARAM lParam)
{
	EMULE_TRY

	int msgType = TBN_NULL;
	msgType = m_wndTaskbarNotifier.GetMessageType();
    switch(msgType)
	{
		case TBN_CHAT:
			RestoreWindow();
			SetActiveDialog(&m_wndChat);
			SetFocus();
			break;
		case TBN_DLOAD:
			RestoreWindow();
			SetActiveDialog(&m_wndTransfer);
			SetFocus();
			break;
		case TBN_DLOAD_ADD:
			RestoreWindow();
			SetActiveDialog(&m_wndTransfer);
			SetFocus();
			break;
		case TBN_IMPORTANTEVENT:
			RestoreWindow();
			SetActiveDialog(&m_wndServer);
			SetFocus();
			break;
		case TBN_LOG:
			RestoreWindow();
			SetActiveDialog(&m_wndServer);
			SetFocus();
			break;
	}
    return 0;

	EMULE_CATCH2

	return -1;
}
//END - enkeyDEV(kei-kun) -TaskbarNotifier-
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::Localize()
{
	EMULE_TRY

	if(m_hWnd)
	{
		m_ctlToolBar.Localize();
		// start added by InterCeptor (localization) 30.10.02
		if (!m_ctlStatusBar)
			return;

#ifdef OLD_SOCKETS_ENABLED
		if(g_eMuleApp.m_pServerConnect->IsConnected())
			ShowUserCount(g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetNumUsers(),g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetFiles());
		else
#endif //OLD_SOCKETS_ENABLED
		{
			CString buffer;
			buffer.Format(_T("0                                ")); //Cax2 spaces needed to activate tooltip
			m_ctlStatusBar.SetTipText(SB_NUMUSERS,GetResString(IDS_STATS_WAITCONN));
			m_ctlStatusBar.SetText(buffer,SB_NUMUSERS,0);
			m_ctlStatusBar.SetTipText(SB_SERVER,_T(""));
#ifdef OLD_SOCKETS_ENABLED
			if(g_eMuleApp.m_pServerConnect->IsConnecting())
				m_ctlStatusBar.SetText(GetResString(IDS_CONNECTING),SB_SERVER,0);
			else
#endif //OLD_SOCKETS_ENABLED
				m_ctlStatusBar.SetText(GetResString(IDS_NOTCONNECTED),SB_SERVER,0);
		}
		ShowTransferRate(true);	//eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
		// end added by InterCeptor (localization) 30.10.02
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	DisConnect() toggles the server connection on and off.
void CEmuleDlg::DisConnect()
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pServerConnect->IsConnected())
	{
	//	Connect if not currently connected
		if (!g_eMuleApp.m_pServerConnect->IsConnecting())
		{
			StartConnection();
		}
		else
		{
			g_eMuleApp.m_pServerConnect->StopConnectionTry();
			ShowConnectionState(false);
		}
	}
	else
#endif //OLD_SOCKETS_ENABLED
	{
	//	Disconnect if currently connected
		CloseConnection();
	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CEmuleDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	switch (wParam)
	{
		case IDC_TOOLBARBUTTON + MTB_CONNECT:
			DisConnect();
			break;
		case IDC_TOOLBARBUTTON + MTB_SERVERS:
			SetActiveDialog(&m_wndServer);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_TRANSFER:
			SetActiveDialog(&m_wndTransfer);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_SEARCH:
			SetActiveDialog(&m_dlgSearch);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_SHAREDFILES:
			SetActiveDialog(&m_wndSharedFiles);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_MESSAGES:
			SetActiveDialog(&m_wndChat);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_IRC:
			SetActiveDialog(&m_wndIRC);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_STATISTICS:
			SetActiveDialog(&m_dlgStatistics);
			m_ctlToolBar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + MTB_PREFS:
			m_ctlToolBar.PressButton(wParam,TRUE);
			m_dlgPreferences.DoModal();
			m_ctlToolBar.PressButton(wParam,FALSE);
			break;
		default:
			break;
	}

	return CTrayDialog::OnCommand(wParam, lParam);

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::QuickSpeedOther(UINT nID)
{
	EMULE_TRY

	switch (nID) {
		case MP_QS_PA: g_eMuleApp.m_pGlobPrefs->SetMaxUpload((uint16)(1)); g_eMuleApp.m_pGlobPrefs->SetMaxDownload((uint16)(1)); break ;
		case MP_QS_UA: g_eMuleApp.m_pGlobPrefs->SetMaxUpload((uint16)(g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate())); g_eMuleApp.m_pGlobPrefs->SetMaxDownload((uint16)(g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate())); break ;

	}

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CEmuleDlg::GetRecMaxUpload()
{
	EMULE_TRY

	if (g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate()<7) return 0;
	if (g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate()<15) return g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate()-3;
	return (g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate()-4);

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CEmuleDlg::OnQueryEndSession()
{
	EMULE_TRY

	if (!CTrayDialog::OnQueryEndSession())
		return FALSE;

	if ( g_eMuleApp.m_app_state == g_eMuleApp.APP_STATE_DONE )
	{
		return TRUE;
	}
	else if ( g_eMuleApp.m_app_state   ==   g_eMuleApp.APP_STATE_RUNNING)
   	{
		g_eMuleApp.m_app_state = g_eMuleApp.APP_STATE_SHUTINGDOWN;
   		//Cax2 don't ask for confirmation when receiving a shutdown message...
		// [Lord KiRon]
		//EndDialog(0);
		CDialog::OnCancel(); // for some reason EndDialog() causes sometimes assertion in Window main loop
		// [/Lord KiRon]
		return TRUE;	//MooseTea fix
   	}

	EMULE_CATCH2

   	return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerConnect(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	g_eMuleApp.m_pServerConnect->ConnectToServer(*(CServer*)wParam);
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerRemove(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RemoveServer((CServer*)wParam); // sivka's bugfix

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerAddToStatic(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.StaticServerFileAppend((CServer*)wParam);
	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerRemoveFromStatic(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.StaticServerFileRemove((CServer*)wParam);

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerClearCompleted(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	if(!wParam)
	{
		EnumCategories eCatID = static_cast<_EnumCategories>(lParam);
		g_eMuleApp.m_pDownloadList->ClearCompleted(eCatID);
	}
	else
	{
		uchar* pFileHash = reinterpret_cast<uchar*>(lParam);
		g_eMuleApp.m_pDownloadList->ClearCompleted(pFileHash);
		delete[] pFileHash;
	}

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebServerFileRename(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	CString sNewName = ((LPCTSTR)(lParam));

	((CPartFile*)wParam)->SetFileName(sNewName);
	((CPartFile*)wParam)->SavePartFile();
	((CPartFile*)wParam)->UpdateDisplayedInfo(true);
	g_eMuleApp.m_pSharedFilesList->UpdateItem((CKnownFile*)((CPartFile*)wParam));
	g_eMuleApp.m_pdlgEmule->m_wndTransfer.UpdateInfoHeader();

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnProcessTaskUI(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

#ifdef NEW_SOCKETS
/*	CTask *pTask = (CTask*)wParam;
	if(pTask)
	{
		if(pTask->ProcessForUI(*g_eMuleApp.m_pEngine))
			delete pTask;
	}*/
#endif //NEW_SOCKETS

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CEmuleDlg::OnWebSharedFilesReload(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	g_eMuleApp.m_pSharedFilesList->Reload(true);

	EMULE_CATCH2

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Barry - To find out if app is running or shutting/shut down
bool CEmuleDlg::IsRunning()
{
	return (g_eMuleApp.m_app_state == CEmuleApp::APP_STATE_RUNNING);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::OnNcDestroy()
{
	//see KB138681 [TwoBottle Mod]
	AfxGetApp()->m_pMainWnd = NULL;
	CTrayDialog::OnNcDestroy();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CEmuleDlg::TrayShow(void)
{
//	Set trayicon-icon
	int DownRateProcent = (int)ceil((lastdownrate/10.24)/g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate());
	if (DownRateProcent>100)
		DownRateProcent=100;

	UpdateTrayIcon(DownRateProcent);

	return CTrayDialog::TrayShow();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::RunBackupNow(bool automated)
{
	if (g_eMuleApp.m_pGlobPrefs->GetBackupDatFiles())
		BackupFromAppDir("*.dat",automated);
	if (g_eMuleApp.m_pGlobPrefs->GetBackupMetFiles())
		BackupFromAppDir("*.met",automated);
	if (g_eMuleApp.m_pGlobPrefs->GetBackupIniFiles())
		BackupFromAppDir("*.ini",automated);
	if (g_eMuleApp.m_pGlobPrefs->GetBackupPartMetFiles())
		BackupFromTempDir("*.part.met",automated);
	if (g_eMuleApp.m_pGlobPrefs->GetBackupPartFiles())
	{
		if (!automated)
		{
			if (MessageBox(GetResString(IDS_BACKUP_LONGTIME),GetResString(IDS_BACKUP_SURE),MB_ICONQUESTION|MB_YESNO)== IDYES)
				BackupFromTempDir("*.part",automated);
		}
		else
		{
			BackupFromTempDir("*.part",automated);
		}
	}
	if (!automated)
		MessageBox(GetResString(IDS_BACKUP_SUCCESS),GetResString(IDS_BACKUP_COMPLETE),MB_OK);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::BackupFromAppDir(LPCSTR extensionToBack,bool automated)
{
	CString szConfigDirPath = CString(g_eMuleApp.m_pGlobPrefs->GetConfigDir());
	CString buffer;
	buffer.Format(_T("%s\\"),g_eMuleApp.m_pGlobPrefs->GetBackupDir());
	char szBackupPath[MAX_PATH];
	lstrcpy(szBackupPath,buffer);

	// Create a new directory if one does not exist
	if(!PathFileExists(szBackupPath))
		CreateDirectory(szBackupPath, NULL);

	//Copying files
	BackupFiles(extensionToBack,automated,szConfigDirPath,szBackupPath);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::BackupFromTempDir(LPCSTR extensionToBack, bool automated)
{
	CString szTempPath = CString(g_eMuleApp.m_pGlobPrefs->GetTempDir());
	CString buffer;
	buffer.Format(_T("%s\\Temp\\"),g_eMuleApp.m_pGlobPrefs->GetBackupDir());
	char szBackupTempSubPath[MAX_PATH];
	lstrcpy(szBackupTempSubPath,buffer);

	// Create a new directory if one does not exist
	if(!PathFileExists(szBackupTempSubPath))
		CreateDirectory(szBackupTempSubPath, NULL);

	BackupFiles(extensionToBack,automated,szTempPath,szBackupTempSubPath);

	//Additional Temp dirs backup
	int iTempDir = 1;

	for (POSITION pos = g_eMuleApp.m_pGlobPrefs->m_tempDirList.GetHeadPosition(); pos != NULL; )
	{
		CString strSearchPath(g_eMuleApp.m_pGlobPrefs->m_tempDirList.GetNext(pos).GetBuffer());

		buffer.Format(_T("%s\\Temp[%i]\\"),g_eMuleApp.m_pGlobPrefs->GetBackupDir(),iTempDir);
		lstrcpy(szBackupTempSubPath,buffer);

		if(!PathFileExists(szBackupTempSubPath))
			CreateDirectory(szBackupTempSubPath, NULL);

		BackupFiles(extensionToBack,automated,strSearchPath,szBackupTempSubPath);

		char tempDir[1060];
		char tempLog[1060];
		sprintf(tempDir,"%sbackup.log", szBackupTempSubPath);
		sprintf(tempLog,"Backed-up directory: %s",strSearchPath);
		FILE* LogFile = _tfopen(tempDir, _T("w+"));
		if ( LogFile != NULL )
	 	{
 			fwrite(tempLog, sizeof(char), strlen(tempLog), LogFile);
 			fclose(LogFile);
	 	}

		iTempDir++;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmuleDlg::BackupFiles(LPCSTR extensionToBack,bool automated, CString szPath, CString szBackupPath)
{
	WIN32_FIND_DATA fileData;
	HANDLE hSearch;
	BOOL fFinished = FALSE;
	BOOL finderror = FALSE;
	BOOL error = FALSE;
	BOOL overWrite = TRUE;
	char buffer[200];
	char szNewPath[MAX_PATH];

	// Start searching for files in the directory.
	SetCurrentDirectory(szPath);

	hSearch = FindFirstFile(extensionToBack, &fileData);

	if (hSearch == INVALID_HANDLE_VALUE)
	{
		finderror = TRUE;
	}

	// Copy each file to the backup directory
	while (!fFinished && !finderror)
	{
		lstrcpy(szNewPath,szBackupPath);
		lstrcat(szNewPath,fileData.cFileName);

		if (PathFileExists(szNewPath))
		{
			if (!automated)
			{
				if (!g_eMuleApp.m_pGlobPrefs->GetBackupOverwrite())
				{
					sprintf(buffer,GetResString(IDS_BACKUP_EXIST),fileData.cFileName);
					if (MessageBox(buffer,GetResString(IDS_BACKUP_OVER),MB_ICONQUESTION|MB_YESNO)== IDYES)
						overWrite = TRUE;
					else
						overWrite = FALSE;
				}
			}
			else
			{
				overWrite = TRUE;
			}
		}
		if (overWrite)
			CopyFile(fileData.cFileName, szNewPath, FALSE);
		if (!automated)
			AddDebugLogLine(false, _T("Backup %s done"), szNewPath);

		if (!FindNextFile(hSearch, &fileData))
		{
			if (GetLastError() == ERROR_NO_MORE_FILES)
			{
				fFinished = TRUE;
			}
			else
			{
				error = TRUE;
			}
		}

	}
	// Close the search handle.
	if (!FindClose(hSearch))
	{
		finderror = TRUE;
	}
	if (error)
	{
		AddDebugLogLine(false, RGB_LOG_ERROR + _T("%s : %s "), GetResString(IDS_BACKUP_ERROR2), GetResString(IDS_BACKUP_ERROR));
		if(!automated)
			MessageBox(GetResString(IDS_BACKUP_ERROR), GetResString(IDS_BACKUP_ERROR2), MB_OK);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
