//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// emuleDlg.h : Headerdatei
//
#pragma once
#ifdef OLD_SOCKETS_ENABLED
#include "sockets.h"
#endif //OLD_SOCKETS_ENABLED
#include "afxcmn.h"
#include "afxwin.h"
#include "serverlistctrl.h"
#include "knownfilelist.h"
#include "TransferWnd.h"
#include "ServerWnd.h"
#include "Preferencesdlg.h"
#include "SharedFilesWnd.h"
#include "SearchDlg.h"
#include "ChatWnd.h"
#include "traydialog.h"
#include "BtnST.h"
#include "StatisticsDlg.h"
#include "MeterIcon.h"
#include "MuleToolBarCtrl.h"
#include "PreferencesDlg.h"
#include "afxdlgs.h"
#include "aboutdlg.h"
#include "ThemeHelperST.h"
#include "IrcWnd.h"
#include "TaskbarNotifier.h"
#include "WebServer.h"
#include "MuleSystrayDlg.h"
#include "loggable.h"

#define MP_RESTORE		4001
#define MP_CONNECT		4002
#define MP_DISCONNECT	4003
#define MP_EXIT			4004

#define RGB_DEFAULT				CString("<COLOR=Default>")
#define RGB_ALICE_BLUE			CString("<COLOR=240,248,255>")
#define RGB_ANTIQUE_WHITE		CString("<COLOR=250,235,215>")
#define RGB_AQUAMARINE			CString("<COLOR=127,255,212>")
#define RGB_AQUA				CString("<COLOR=51,204,204>")
#define RGB_AZURE				CString("<COLOR=240,255,255>")
#define RGB_BEIGE				CString("<COLOR=245,245,220>")
#define RGB_BLACK				CString("<COLOR=0,0,0>")
#define RGB_BLANCHEDALMOND		CString("<COLOR=255,235,205>")
#define RGB_BLUE				CString("<COLOR=0,0,255>")
#define RGB_BLUE_GRAY			CString("<COLOR=102,102,153>")
#define RGB_BLUE_VIOLET			CString("<COLOR=138,43,226>")
#define RGB_BRIGHT_GREEN		CString("<COLOR=0,255,0>")
#define RGB_BRIGHT_LAVENDER		CString("<COLOR=230,230,250>")
#define RGB_BRIGHT_PLUM			CString("<COLOR=221,160,221>")
#define RGB_BRIGHT_TAN			CString("<COLOR=255,204,153>")
#define RGB_BRIGHT_YELLOW		CString("<COLOR=255,255,224>")
#define RGB_BROWN				CString("<COLOR=153,51,0>")
#define RGB_BROWN_WOOD			CString("<COLOR=165,42,42>")
#define RGB_BISQUE				CString("<COLOR=255,228,196>")
#define RGB_BURLY_WOOD			CString("<COLOR=222,184,135>")
#define RGB_CADET_BLUE			CString("<COLOR=95,158,160>")
#define RGB_CHARTREUSE			CString("<COLOR=127,255,0>")
#define RGB_CHOCOLATE			CString("<COLOR=210,105,30>")
#define RGB_CORAL				CString("<COLOR=255,127,80>")
#define RGB_CORNFLOWER_BLUE		CString("<COLOR=100,149,237>")
#define RGB_CORNSILK			CString("<COLOR=255,248,220>")
#define RGB_CRIMSON				CString("<COLOR=220,20,60>")
#define RGB_CYAN				CString("<COLOR=0,255,255>")
#define RGB_DARK_BLUE			CString("<COLOR=0,0,128>")
#define RGB_DARK_CYAN			CString("<COLOR=0,128,128>")
#define RGB_DARK_GOLD			CString("<COLOR=255,204,0>")
#define RGB_DARK_GOLDEN_ROD		CString("<COLOR=184,134,11>")
#define RGB_DARK_GRAY			CString("<COLOR=169,169,169>")
#define RGB_DARK_GREEN			CString("<COLOR=0,100,0>")
#define RGB_DARK_KHAKI			CString("<COLOR=189,183,107>")
#define RGB_DARK_OLIVE			CString("<COLOR=85,107,47>")
#define RGB_DARK_ORANGE			CString("<COLOR=255,140,0>")
#define RGB_DARK_ORCHID			CString("<COLOR=153,50,204>")
#define RGB_DARK_RED			CString("<COLOR=128,0,0>")
#define RGB_DARK_SALMON			CString("<COLOR=233,150,122>")
#define RGB_DARK_SEA_GREEN		CString("<COLOR=143,188,143>")
#define RGB_DARK_SLATE_BLUE		CString("<COLOR=72,61,139>")
#define RGB_DARK_SLATE_GRAY		CString("<COLOR=47,79,79>")
#define RGB_DARK_TEAL			CString("<COLOR=0,51,102>")
#define RGB_DARK_TURQUOISE		CString("<COLOR=0,206,209>")
#define RGB_DARK_VIOLET			CString("<COLOR=148,0,211>")
#define RGB_DARK_YELLOW			CString("<COLOR=128,128,0>")
#define RGB_DARKER_GREEN		CString("<COLOR=0,51,0>")
#define RGB_DARKER_ORANGE		CString("<COLOR=255,102,0>")
#define RGB_DARKER_SEA_GREEN	CString("<COLOR=46,139,87>")
#define RGB_DEEP_PINK			CString("<COLOR=255,20,147>")
#define RGB_DEEP_SKY_BLUE		CString("<COLOR=0,191,255>")
#define RGB_DIM_GRAY			CString("<COLOR=105,105,105>")
#define RGB_DODGER_BLUE			CString("<COLOR=30,144,255>")
#define RGB_FIRE_BRICK			CString("<COLOR=178,34,34>")
#define RGB_FLORAL_WHITE		CString("<COLOR=255,250,240>")
#define RGB_FOREST_GREEN		CString("<COLOR=34,139,34>")
#define RGB_GAINSBORO			CString("<COLOR=220,220,220>")
#define RGB_GHOST_WHITE			CString("<COLOR=248,248,255>")
#define RGB_GOLD				CString("<COLOR=255,215,0>")
#define RGB_GOLDEN_ROD			CString("<COLOR=218,165,32>")
#define RGB_GRAY25				CString("<COLOR=192,192,192>")
#define RGB_GRAY40				CString("<COLOR=153,153,153>")
#define RGB_GRAY50				CString("<COLOR=128,128,128>")
#define RGB_GRAY80				CString("<COLOR=51,51,51>")
#define RGB_GREEN				CString("<COLOR=0,128,0>")
#define RGB_GREEN_YELLOW		CString("<COLOR=173,255,47>")
#define RGB_HONEY_DEW			CString("<COLOR=240,255,240>")
#define RGB_HOT_PINK			CString("<COLOR=255,105,180>")
#define RGB_INDIAN_RED			CString("<COLOR=205,92,92>")
#define RGB_INDIGO				CString("<COLOR=51,51,153>")
#define RGB_INDIGO_PURPLE		CString("<COLOR=75,0,130>")
#define RGB_IVORY				CString("<COLOR=255,255,240>")
#define RGB_KHAKI				CString("<COLOR=240,232,108>")
#define RGB_LAVENDER			CString("<COLOR=204,153,255>")
#define RGB_LAVENDER_BLUSH		CString("<COLOR=255,240,245>")
#define RGB_LAWN_GREEN			CString("<COLOR=124,252,0>")
#define RGB_LEMON_CHIFFON		CString("<COLOR=255,250,205>")
#define RGB_LIGHT_BLUE			CString("<COLOR=51,102,255>")
#define RGB_LIGHT_CORAL			CString("<COLOR=240,128,128>")
#define RGB_LIGHT_CYAN			CString("<COLOR=204,255,255>")
#define RGB_LIGHT_GOLDEN_ROD	CString("<COLOR=250,250,210>")
#define RGB_LIGHT_GRAY			CString("<COLOR=211,211,211>")
#define RGB_LIGHT_GREEN			CString("<COLOR=204,255,204>")
#define RGB_LIGHT_ORANGE		CString("<COLOR=255,153,0>")
#define RGB_LIGHT_PINK			CString("<COLOR=255,182,193>")
#define RGB_LIGHT_SALMON		CString("<COLOR=255,160,122>")
#define RGB_LIGHT_SKY_BLUE		CString("<COLOR=135,206,250>")
#define RGB_LIGHT_SEA_GREEN		CString("<COLOR=32,178,170>")
#define RGB_LIGHT_SLATE_GRAY	CString("<COLOR=119,136,153>")
#define RGB_LIGHT_STEEL_BLUE	CString("<COLOR=176,196,222>")
#define RGB_LIGHT_YELLOW		CString("<COLOR=255,255,153>")
#define RGB_LIGHTER_CYAN		CString("<COLOR=224,255,255>")
#define RGB_LIGHTER_GREEN		CString("<COLOR=144,238,144>")
#define RGB_LIGHTER_SKY_BLUE	CString("<COLOR=173,216,230>")
#define RGB_LIME				CString("<COLOR=153,204,0>")
#define RGB_LIME_GREEN			CString("<COLOR=50,205,50>")
#define RGB_LINEN				CString("<COLOR=250,240,230>")
#define RGB_MAGENTA				CString("<COLOR=255,0,255>")
#define RGB_MAROON				CString("<COLOR=128,0,0>")
#define RGB_MEDIUM_AQUAMARINE	CString("<COLOR=102,205,170>")
#define RGB_MEDIUM_BLUE			CString("<COLOR=0,0,205>")
#define RGB_MEDIUM_GREEN		CString("<COLOR=0,205,0>")
#define RGB_MEDIUM_ORCHID		CString("<COLOR=186,85,211>")
#define RGB_MEDIUM_PURPLE		CString("<COLOR=147,112,219>")
#define RGB_MEDIUM_RED			CString("<COLOR=205,0,0>")
#define RGB_MEDIUM_SEA_GREEN	CString("<COLOR=60,179,113>")
#define RGB_MEDIUM_SLATE_BLUE	CString("<COLOR=123,104,238>")
#define RGB_MEDIUM_SPRING_GREEN	CString("<COLOR=0,250,154>")
#define RGB_MEDIUM_TURQUOISE	CString("<COLOR=72,209,204>")
#define RGB_MEDIUM_VIOLET_RED	CString("<COLOR=199,21,133>")
#define RGB_MIDNIGHT_BLUE		CString("<COLOR=25,25,112>")
#define RGB_MINT_CREAM			CString("<COLOR=245,255,250>")
#define RGB_MISTY_ROSE			CString("<COLOR=255,228,225>")
#define RGB_MOCASSIN			CString("<COLOR=255,228,181>")
#define RGB_NAVAJO_WHITE		CString("<COLOR=255,222,173>")
#define RGB_OLD_LACE			CString("<COLOR=253,245,230>")
#define RGB_OLIVE				CString("<COLOR=51,51,0>")
#define RGB_OLIVE_DRAB			CString("<COLOR=107,142,35>")
#define RGB_ORANGE				CString("<COLOR=255,165,0>")
#define RGB_ORANGE_RED			CString("<COLOR=255,69,0>")
#define RGB_ORCHID				CString("<COLOR=218,112,214>")
#define RGB_PALE_BLUE			CString("<COLOR=153,204,255>")
#define RGB_PALE_GOLDEN_ROD		CString("<COLOR=238,232,170>")
#define RGB_PALE_GREEN			CString("<COLOR=152,251,152>")
#define RGB_PALE_TURQUOISE		CString("<COLOR=175,238,238>")
#define RGB_PALE_VIOLET_RED		CString("<COLOR=219,112,147>")
#define RGB_PAPAYA_WHIP			CString("<COLOR=255,239,213>")
#define RGB_PEACH_PUFF			CString("<COLOR=255,218,185>")
#define RGB_PERU				CString("<COLOR=205,133,63>")
#define RGB_PINK				CString("<COLOR=255,192,203>")
#define RGB_PLUM				CString("<COLOR=153,51,102>")
#define RGB_POWDER_BLUE			CString("<COLOR=176,224,230>")
#define RGB_PURPLE				CString("<COLOR=128,0,128>")
#define RGB_RED					CString("<COLOR=255,0,0>")
#define RGB_ROSE				CString("<COLOR=255,153,204>")
#define RGB_ROSY_BROWN			CString("<COLOR=188,143,143>")
#define RGB_ROYAL_BLUE			CString("<COLOR=65,105,225>")
#define RGB_SADDLE_BROWN		CString("<COLOR=139,69,19>")
#define RGB_SALMON				CString("<COLOR=250,128,114>")
#define RGB_SANDY_BROWN			CString("<COLOR=244,164,96>")
#define RGB_SEA_GREEN			CString("<COLOR=51,153,102>")
#define RGB_SEA_SHELL			CString("<COLOR=255,245,238>")
#define RGB_SIENNA				CString("<COLOR=160,82,45>")
#define RGB_SPRING_GREEN		CString("<COLOR=0,255,127>")
#define RGB_SKY_BLUE			CString("<COLOR=135,206,235>")
#define RGB_SLATE_BLUE			CString("<COLOR=106,90,205>")
#define RGB_SLATE_GRAY			CString("<COLOR=112,128,144>")
#define RGB_SNOW				CString("<COLOR=255,250,250>")
#define RGB_STEEL_BLUE			CString("<COLOR=70,130,180>")
#define RGB_TAN					CString("<COLOR=210,180,140>")
#define RGB_TOMATO				CString("<COLOR=255,99,71>")
#define RGB_TURQUOISE			CString("<COLOR=64,224,208>")
#define RGB_THISTLE				CString("<COLOR=216,191,216>")
#define RGB_VIOLET				CString("<COLOR=238,130,238>")
#define RGB_WHEAT				CString("<COLOR=245,222,179>")
#define RGB_WHITE				CString("<COLOR=255,255,255>")
#define RGB_WHITE_SMOKE			CString("<COLOR=245,245,245>")
#define RGB_YELLOW				CString("<COLOR=255,255,0>")
#define RGB_YELLOW_GREEN		CString("<COLOR=154,205,50>")

#define RGB_LOG_ERROR			RGB_RED
#define RGB_LOG_WARNING			RGB_DARKER_ORANGE
#define RGB_LOG_NOTICE			RGB_PLUM
#define RGB_LOG_DIMMED			RGB_DIM_GRAY
#define RGB_LOG_SUCCESS			RGB_DARKER_SEA_GREEN

enum EnumStatusBarBoxes
{
	SB_MESSAGETEXT = 0,
	SB_SESSIONTIME,
	SB_MESSAGESTATUS,
	SB_NUMUSERS,
	SB_UPLOADRATE,
	SB_DOWNLOADRATE,
	SB_SERVER,

	SB_NUMSBPARTS,
};

class CKnownFileList;

// CEmuleDlg Dialogfeld
class CEmuleDlg : public CTrayDialog, public CLoggable
{
friend class CMuleToolbarCtrl;
friend class 	CWebServer;
// Construction
public:
	CEmuleDlg(CWnd* pParent = NULL);	// Standard constructor
	~CEmuleDlg();
	enum { IDD = IDD_EMULE_DIALOG };

	void			AddServerMessageLine(LPCTSTR line);
	void			AddBugReport(LPCTSTR strFunctionName, LPCTSTR sFile, long nLine, CString msg);
	void			OutputLogText(const CString& strLogText, bool bDebug = false);
	void			AddLogText(bool addtostatusbar,const CString& txt ,bool bDebug = false);
	void			ShowConnectionState();
	void			ShowConnectionState(bool bConnected);
	void			ShowConnectionState(bool bConnected,CString server, bool iconOnly = false);
	void			ShowNotifier(CString Text, int MsgType, bool ForceSoundOFF = false, bool bMessageEnabled = false);
	void			ShowUserCount(uint32 users_toshow, uint32 files_toshow);
	void			ShowMessageState(byte iconnr);
	void			ShowSessionTime();
	void			SetActiveDialog(CDialog* dlg);
	void			ShowTransferRate(bool bUpdateAll = false);
	void			ShowStatistics();
	void			Localize();
	void			ResizeStatusBar();
	bool			IsRunning();
	void 			RunBackupNow(bool automated);

	CTransferWnd		m_wndTransfer;
	CServerWnd			m_wndServer;
	CPreferencesDlg		m_dlgPreferences;
	CSharedFilesWnd		m_wndSharedFiles;
	CSearchDlg			m_dlgSearch;
	CChatWnd			m_wndChat;
	CStatusBarCtrl		m_ctlStatusBar;
	CMuleToolbarCtrl	m_ctlToolBar;
#ifdef USE_REBAR
	CReBarCtrl			m_ctlReBar;
#endif
	CDialog				*m_pdlgActive;
	CStatisticsDlg		m_dlgStatistics;
	CIrcWnd				m_wndIRC;
	CTaskbarNotifier	m_wndTaskbarNotifier;
	int					m_iStatus;
	CRect				m_rClientRect;
	CThemeHelperST		m_themeHelper;
	CFont				m_fontDefault;
	uint16				m_iFilesToBeHashed;
protected:
	HICON				m_hIcon;

	virtual void		DoDataExchange(CDataExchange* pDX);
	virtual BOOL		OnInitDialog();
	virtual void		OnTrayRButtonUp(CPoint pt);
	virtual BOOL		OnCommand(WPARAM wParam, LPARAM lParam);

	afx_msg void		OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void		OnPaint();
	afx_msg HCURSOR		OnQueryDragIcon();
	afx_msg void		OnTimer(UINT_PTR nIDEvent);
	afx_msg int			OnCreate(LPCREATESTRUCT lpCreateStruct);

	// quick-speed changer -- based on xrmb
	//afx_msg void QuickSpeedUpload(UINT nID);
	//afx_msg void QuickSpeedDownload(UINT nID);
	void QuickSpeedOther(UINT nID);

	afx_msg LRESULT OnProcessTaskUI(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnWebServerConnect(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerRemove(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebSharedFilesReload(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerAddToStatic(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerRemoveFromStatic(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerClearCompleted(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerFileRename(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnTaskbarNotifierClicked(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnWMData(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnFileHashed(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnAreYouEmule(WPARAM, LPARAM);

	virtual void OnSize(UINT nType,int cx,int cy);
	void			OnOK()	{}
	void		 	OnClose();
	void		 	OnCancel();
	void		 	DisConnect();

	DECLARE_MESSAGE_MAP()
private:
	CStringArray	m_astrMissedLogLines;
	CStringArray	m_astrMissedDebugLogLines;
	CString			m_strLogText;
	CString			m_strDebugLog;
	CString 		m_strDebugLogFilePath;
	CString 		m_strLogFilePath;
	bool			m_bReady,m_bStartUpMinimized;
	HICON			m_hiconConn[3];
	HICON			m_hiconTrans[4];
	HICON			m_hiconIM[3];
	HICON			m_hiconMyTray;
	HICON			m_hiconUsers;

	CMeterIcon 		m_trayMeterIcon;

public:
	HICON 			m_hiconSourceTray;

#ifdef NEW_SOCKETS
//	CEngineData*	m_pEngineData;
#endif //NEW_SOCKETS

private:
	HICON 			m_hiconSourceTrayLowID;
	HICON 			m_hiconSourceTrayGrey;

	uint32			lastuprate;
	uint32			lastdownrate;
	CImageList		m_imageList;
	CTitleMenu		trayPopup;
	CMuleSystrayDlg *m_pSystrayDlg;

	UINT_PTR m_hTimer;
	static void CALLBACK Timer(HWND hwnd, UINT uiMsg, UINT idEvent, DWORD dwTime);

	void 			StartConnection();
	void 			CloseConnection();
	void 			RestoreWindow();
	void 			UpdateTrayIcon(int procent);
	void 			AddSpeedSelectorSys(CMenu* addToMenu);
	int  			GetRecMaxUpload();

	void BackupFromAppDir(LPCSTR extensionToBack,bool automated);
	void BackupFromTempDir(LPCSTR extensionToBack, bool automated);
	void BackupFiles(LPCSTR extensionToBack,bool automated, CString szPath, CString szBackupPath);

public:
	afx_msg BOOL OnQueryEndSession();
	afx_msg void OnNcDestroy();
	afx_msg void OnBnClickedButton2();
	BOOL TrayShow(void);
};
